#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <gnome.h>
#include <stdlib.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include "callbacks.h"
#include "functions.h"
#include "interface.h"
#include "support.h"


#define LENGTH_TIME_FRAME 500
#define LENGTH_SUBTITLE 1000
#define LENGTH_TIME 4
#define MAX_LENGTH_MOVE_ENTRY 10
#define MAX_C  200
#define MAX_FILENAME 900
#define MAX_LANG 900


GtkWidget *main_window;
GtkWidget *fileselection_window;
GtkWidget *pref_window;
GtkWidget *properties_window;
GtkWidget *information_window;
GtkWidget *change_format_window;
GtkWidget *save_as_window;
GtkWidget *about_window;
GtkWidget *entry_save_as;
GtkWidget *sub_list;
GtkWidget *entry_sub_bottom;
GtkWidget *text_sub_bottom;
GtkWidget *entry_move_from_bottom;
GtkWidget *entry_move_to_bottom;
GtkWidget *button_move_from_bottom;
GtkWidget *button_move_to_bottom;
GtkWidget *button_insert_bottom;
GtkWidget *button_change_bottom;
GtkWidget *button_delete_bottom;
GtkWidget *open_button;
GtkWidget *save_button;
GtkWidget *save_as_button;
GtkWidget *preferences_button;
GtkWidget *quit_button;
GtkWidget *ok_button1;
GtkWidget *cancel_button1;
GtkWidget *button_pref_ok;
GtkWidget *label_information;
GtkWidget *spinbutton_change_format_frames_in_sec;
GtkWidget *spinbutton_properties_frames_in_sec;
GtkWidget *spinbutton_properties_hours;
GtkWidget *spinbutton_properties_minutes;
GtkWidget *spinbutton_properties_seconds;
GtkWidget *combo_entry_properties_direction;
GtkWidget *combo_entry_change_format;
GtkWidget *entry_pref_temp_dir;
GtkWidget *entry_pref_lang_dir;
GtkWidget *combo_entry_pref_lang;
GtkWidget *combo_pref_lang;
GtkWidget *entry_chmod;
GtkWidget *entry_hour_from;
GtkWidget *entry_min_from;
GtkWidget *entry_sec_from;
GtkWidget *entry_hour_to;
GtkWidget *entry_min_to;
GtkWidget *entry_sec_to;
GtkWidget *entry_frame_from;
GtkWidget *entry_frame_to;
GtkWidget *entry_move_from_bottom;
GtkWidget *entry_move_to_bottom;
GtkWidget *label_move_from_to;
GtkWidget *text_sub_bottom;
GtkWidget *entry_sub_bottom;

struct el_list {
	gchar name[MAX_C];
	gchar filename[MAX_LENGTH_FILENAME];
	struct el_list *next;
};
typedef struct el_list * glist_lang;


gchar restart[MAX_C]="You have to restart GTKsubtitler";
gchar move_partly_on[MAX_C]="Move from <point> to <point>:";
gchar move_partly_off[MAX_C]="If you want move partly   please choose \"Move Partly\" in Edit - submenu";
gchar cant_read_tmp_file[MAX_C]="Can't read temp file!";
gchar cant_write_to_tmp_file[MAX_C]="Can't write to temp file! Check permisions!";
gchar cant_write_to_file[MAX_C]="Can't write to file! Check permisions!";
gchar cant_open_file[MAX_C]="Can't open file!";
gchar cant_read_file[MAX_C]="Can't read file (bad format) !";
gchar cant_move_subtitles[MAX_C]="Can't move subtitles so far, out of range" ;
gchar first_open_file[MAX_C]="Please first open file!";
gchar format_not_supported[MAX_C]="Thist format of file is not supported!";
gchar incompatibile_file_format[MAX_C]="Incompatibile file format !!!";
gchar filename[MAX_LENGTH_FILENAME], filename2[MAX_LENGTH_FILENAME];
gchar file_format1;
gchar file_format2;
gchar temp_filename[MAX_LENGTH_FILENAME]="/tmp/GTKsubtitler_tmp";
gchar temp_filename2[MAX_LENGTH_FILENAME]="/tmp/GTKsubtitler_tmp_";
gchar chmod_no[4]="644";
gchar lang_dir[MAX_LENGTH_FILENAME]="/usr/local/share/GTKsubtitler/";
gchar lang_current_filename[MAX_LENGTH_FILENAME]="/usr/share/GTKsubtitler/lang.en";
gchar lang_current_language[MAX_C]="English";
gchar f_frames[LENGTH_TIME_FRAME]="0";
gchar t_frames[LENGTH_TIME_FRAME]="0";
gchar f_hour[LENGTH_TIME]="0";
gchar f_min[LENGTH_TIME]="0";
gchar f_sec[LENGTH_TIME]="0";
gchar t_hour[LENGTH_TIME]="0";
gchar t_min[LENGTH_TIME]="0";
gchar t_sec[LENGTH_TIME]="0";
glist_lang lang_list=NULL;
gchar **information_sub;
glong length_sub_list=0;
gint hours_to_move=0;
gint minutes_to_move=0;
gint seconds_to_move=0;
gfloat frames_in_sec=29.97;
gint file_is_open=0;
gint direction=1;
gint move_partly=0;
gint merge=0;





void change_file_access(char *filename,char *chmod_no)
{

  mode_t file_mode=0;


  switch(chmod_no[0])
    {
    case '7':
      file_mode+=S_IRUSR; 
      file_mode+=S_IWUSR; 
      file_mode+=S_IXUSR;
      break;

    case '6':
      file_mode+=S_IRUSR; 
      file_mode+=S_IWUSR; 
      break;

    case '5':
      file_mode+=S_IRUSR; 
      file_mode+=S_IXUSR;
      break;

    case '4':
      file_mode+=S_IRUSR; 
      break;

    case '3':
      file_mode+=S_IWUSR; 
      file_mode+=S_IXUSR;
      break;

    case '2':
      file_mode+=S_IWUSR; 
      break;

    case '1':
      file_mode+=S_IXUSR;
      break;

    }

  switch(chmod_no[1])
    {
    case '7':
      file_mode+=S_IRGRP; 
      file_mode+=S_IWGRP; 
      file_mode+=S_IXGRP;
      break;

    case '6':
      file_mode+=S_IRGRP; 
      file_mode+=S_IWGRP; 
      break;

    case '5':
      file_mode+=S_IRGRP; 
      file_mode+=S_IXGRP;
      break;

    case '4':
      file_mode+=S_IRGRP; 
      break;

    case '3':
      file_mode+=S_IWGRP; 
      file_mode+=S_IXGRP;
      break;

    case '2':
      file_mode+=S_IWGRP; 
      break;

    case '1':
      file_mode+=S_IXGRP;
      break;

    }


  switch(chmod_no[2])
    {
    case '7':
      file_mode+=S_IROTH; 
      file_mode+=S_IWOTH; 
      file_mode+=S_IXOTH;
      break;

    case '6':
      file_mode+=S_IROTH; 
      file_mode+=S_IWOTH; 
      break;

    case '5':
      file_mode+=S_IROTH; 
      file_mode+=S_IXOTH;
      break;

    case '4':
      file_mode+=S_IROTH; 
      break;

    case '3':
      file_mode+=S_IWOTH; 
      file_mode+=S_IXOTH;
      break;

    case '2':
      file_mode+=S_IWOTH; 
      break;

    case '1':
      file_mode+=S_IXOTH;
      break;

    }

  chmod(filename,file_mode);
 



      return;
}

void read_lang_conf()
{

  FILE *input_file;
  gchar bufor;
  gchar filename[MAX_FILENAME];
  gint i;
  glist_lang temp;


  strcpy(filename,lang_dir);
  strcat(filename,"/conf");

  while(lang_list!=NULL)
  {
  temp=lang_list;
  lang_list=lang_list->next;
  free(temp);
  }


  if((input_file=fopen(filename,"r"))!=NULL)
    {
      while(fscanf(input_file,"%c",&bufor)!=EOF)
	{
	  if(bufor=='[')
	    {
	      temp=malloc(sizeof(struct el_list));
	      temp->next=lang_list;
	      lang_list=temp;
	      i=0;
	      while(fscanf(input_file,"%c",&temp->name[i])!=EOF && temp->name[i++]!=']')	;
	      temp->name[--i]=0;

	      while(fscanf(input_file,"%c",&bufor)!=EOF && bufor!='\n');

	      i=0;
	      while(fscanf(input_file,"%c",&temp->filename[i])!=EOF && temp->filename[i++]!='\n');

	      temp->filename[--i]=0;
	      

	      while(fscanf(input_file,"%c",&bufor)!=EOF && bufor!='\n');

	    }
	  else
	    if (bufor!='\n')
	      while(fscanf(input_file,"%c",&bufor)!=EOF && bufor!='\n');
	}



      fclose(input_file);


    }

  return;

}



void read_conf_callbacks()
{
  FILE *input_file;
  gchar bufor[MAX_E];
  gchar filename[MAX_FILENAME];
  gchar buf_txt[MAX_C];
  gint i;


  strcpy(filename,getenv("HOME"));
  strcat(filename,"/.GTKsubtitler.conf");


  if((input_file=fopen(filename,"r"))!=NULL)
    {
      while(fscanf(input_file,"%c",&bufor[0])!=EOF)
	{
	  if(bufor[0]=='[')
	    {
	      i=1;
	      while(fscanf(input_file,"%c",&bufor[i])!=EOF && bufor[i++]!='\n')	;
	      bufor[--i]=0;

	      i=0;
	      while(fscanf(input_file,"%c",&buf_txt[i])!=EOF && buf_txt[i++]!='\n');

	      buf_txt[--i]=0;


	      if(strcmp(bufor,"[TMP_FILENAME]")==0)
		strcpy(temp_filename,buf_txt);
	      else
		if(strcmp(bufor,"[TMP_FILENAME2]")==0)
		  strcpy(temp_filename2,buf_txt);
		else
		  if(strcmp(bufor,"[CHMOD_NO]")==0)
		    strcpy(chmod_no,buf_txt);
		  else
		    if(strcmp(bufor,"[LANG_DIR]")==0)
		      strcpy(lang_dir,buf_txt);
	  	    else
		    	if(strcmp(bufor,"[LANG_CURRENT_LANGUAGE]")==0)
		     	 strcpy(lang_current_language,buf_txt);
		    	if(strcmp(bufor,"[LANG_CURRENT_FILENAME]")==0)
		     	 strcpy(lang_current_filename,buf_txt);


	      while(fscanf(input_file,"%c",&bufor[0])!=EOF && bufor[0]!='\n');

	    }
	  else
	    if (bufor[0]!='\n')
	      while(fscanf(input_file,"%c",&bufor[0])!=EOF && bufor[0]!='\n');
	}



      fclose(input_file);
	read_lang_conf();

    }

  return;

}




void set_lang_callbacks(char *filename)
{
  gchar bufor[MAX_E];
  gchar buf_txt[MAX_E_TEXT];
  gchar c;
  gint i;
  FILE *input_file;

  if((input_file=fopen(filename,"r"))==NULL)
    return;
  

  if(fscanf(input_file,"%c",&c)!=EOF)
    {
      while(c!='#')
	if(fscanf(input_file,"%c",&c)==EOF)
	  {fclose(input_file); return;}


      
      while(c!='\n')
	if(fscanf(input_file,"%c",&c)==EOF)
	  {fclose(input_file); return;}
    }  

  
  
  while(fscanf(input_file,"%c",&bufor[0])!=EOF)
    {
      if (bufor[0]=='[')
	{


	  i=1;
	  while(fscanf(input_file,"%c",&bufor[i])!=EOF && bufor[i++]!='\n')	;
	  bufor[--i]=0;
	  
	  
	  i=0;
	  
	  while(fscanf(input_file,"%c",&buf_txt[i])!=EOF)
	    if(buf_txt[i]=='\n')
	      {
		if(fscanf(input_file,"%c",&buf_txt[++i])!=EOF && buf_txt[i]!='\n' && buf_txt[i]!=' ')
		  {
		    if(buf_txt[i]=='|')
		      buf_txt[i]='\n';
		    i++;
		  }
		else 
		  break;
	      }
	    else
	      {
		if(buf_txt[i]=='|')
		  buf_txt[i]='\n';
	      i++;
	      }
		
	  buf_txt[i-1]=0;
	  
	  
	if(strcmp(bufor,"[CANT_READ_TMP_FILE]")==0)
	  strcpy(cant_read_tmp_file,buf_txt);
	else
	  if(strcmp(bufor,"[CANT_WRITE_TO_TMP_FILE]")==0)
	    strcpy(cant_write_to_tmp_file,buf_txt);
	  else
	    if(strcmp(bufor,"[CANT_WRITE_TO_FILE]")==0)
	      strcpy(cant_write_to_file,buf_txt);
	    else
	      if(strcmp(bufor,"[CANT_OPEN_FILE]")==0)
		strcpy(cant_open_file,buf_txt);
	      else
		if(strcmp(bufor,"[CANT_READ_FILE]")==0)
		  strcpy(cant_read_file,buf_txt);
		else
		  if(strcmp(bufor,"[CANT_MOVE_SUBTITLES]")==0)
		    strcpy(cant_move_subtitles,buf_txt);
		  else
		    if(strcmp(bufor,"[FIRST_OPEN_FILE]")==0)
		      strcpy(first_open_file,buf_txt);
			else
			  if(strcmp(bufor,"[FORMAT_NOT_SUPPORTED]")==0)
			    strcpy(format_not_supported,buf_txt);	      
			  else
			    if(strcmp(bufor,"[INCOMPATIBILE_FILE_FORMAT]")==0)
			      strcpy(incompatibile_file_format,buf_txt);
			    else
			      if(strcmp(bufor,"[MOVE_PARTLY_ON]")==0)
				strcpy(move_partly_on,buf_txt);	      
			      else
				if(strcmp(bufor,"[MOVE_PARTLY_OFF]")==0)
				  strcpy(move_partly_off,buf_txt);
				else
				  if(strcmp(bufor,"[RESTART]")==0)
				    strcpy(restart,buf_txt);
 	
	if(buf_txt[i]!='\n')
	  while(fscanf(input_file,"%c",&bufor[0])!=EOF && bufor[0]!='\n');
	
	}
      else
	if (bufor[0]=='@')
	  break;
	else
	  if (bufor[0]!='\n')
	    while(fscanf(input_file,"%c",&bufor[0])!=EOF && bufor[0]!='\n');
      
    }
  
   


  fclose(input_file);
  
  
  return;
}





void exit_program()
{
  FILE *f;
  gchar filename[MAX_LENGTH_FILENAME];
  
  strcpy(filename,getenv("HOME"));
  strcat(filename,"/.GTKsubtitler.conf");


  if((f=fopen(filename,"w"))!=NULL)
    {
      fprintf(f,"/*File is generated by GTKsubtitler do not edit! */\n");
      fprintf(f,"[TMP_FILENAME]\n%s\n\n",temp_filename);
      fprintf(f,"[TMP_FILENAME2]\n%s\n\n",temp_filename2);
      fprintf(f,"[CHMOD_NO]\n%s\n\n",chmod_no);
      fprintf(f,"[LANG_DIR]\n%s\n\n",lang_dir);
      fprintf(f,"[LANG_CURRENT_FILENAME]\n%s\n\n",lang_current_filename);
      fprintf(f,"[LANG_CURRENT_LANGUAGE]\n%s\n\n",lang_current_language);
      fclose(f);
      chmod(filename,S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);

    }

  if((f=fopen(temp_filename,"r"))!=NULL)
    {
      fclose(f);		
      unlink(temp_filename);
    }


  if((f=fopen(temp_filename2,"r"))!=NULL)
    {
      fclose(f);		
      unlink(temp_filename2);
    }


  gtk_main_quit();

  return;
}


void set_mainwindow(GtkWidget *window)
{
  main_window=window;
  sub_list=lookup_widget(main_window,"sub_list");
  return;
}


void show_information(char *text_info)
{
information_window=create_information_window();
gtk_widget_show(information_window);

label_information=lookup_widget(information_window,"label_information");
gtk_label_set_text(GTK_LABEL(label_information),text_info);

}


void save_sub_list()
{
  FILE *f,*f2;
  gchar *time_frames, *text, tmp[LENGTH_TIME_FRAME];
  gint i=0,j;
  
  if ((f=fopen(temp_filename,"r"))==NULL)
  {
    show_information(cant_read_tmp_file);
    return;
  }

  if ((f2=fopen(temp_filename2,"w"))==NULL)
  {
    show_information(cant_write_to_tmp_file);
    return;   
  }
  

  while(i<=length_sub_list)
    {
      
       gtk_clist_get_text(GTK_CLIST(sub_list),i,0,&time_frames);
       gtk_clist_get_text(GTK_CLIST(sub_list),i,1,&text);
      
      
      
       switch(file_format1)
	 {
	 case 't':/*time*/
	   fprintf(f2,"%s:%s \n",time_frames,text);
	   break;

	 case 'm':/*microdvd*/
	   fprintf(f2,"%s%s \n",time_frames,text);
	   break;

	 case 's':/*SubViewer 2.0*/
	   if(time_frames[0]!=0)
	     fprintf(f2,"%s\n%s\n\n",time_frames,text);
	   else
	     fprintf(f2,"%s\n",text);
	   break;
	   
	 case 'r':/*SubRip*/
		fprintf(f2,"%d\n%s\n",i+1,time_frames);
		j=0;
		while(text[j]!=0)
		{
		if(text[j]!='|')
			fprintf(f2,"%c",text[j]);
		else
			fprintf(f2,"\n");
		j++;
		}
		fprintf(f2,"\n\n");
	   break;

	 case 'p': /*MPsub*/
	   if(time_frames[0]!=0)
	     {
	       j=0;
	       while(time_frames[j]!='{' && time_frames[j]!=0)
		 tmp[j]=time_frames[j++];
	       
	       while(tmp[--j]==' ')
		 {
		   tmp[j]=0;
		 }
	       
	       fprintf(f2,"%s\n%s\n\n",tmp,text);
	     }
	   else
	     fprintf(f2,"%s\n",text);
	   break;

	 }


      i++;
    }

  fclose(f);
  fclose(f2);
  switch(copy_file(temp_filename2,temp_filename))
    {
    case 1:
      show_information(cant_read_tmp_file);
      break;
    case 2:
      show_information(cant_write_to_tmp_file);
      break;
    }

  return;
}


void
set_sub_list()
{
  gchar **line,*time_frame,*subtitle;
  int i,j;
  FILE *input_file;	
  gchar c,tmp_tab[LENGTH_TIME_FRAME];
  long tmp_time=0,tmp_time2=0;
  gchar *tmp_tab2;
  
  line=malloc(sizeof(gpointer)*2);
    
 
  length_sub_list=0;

  gtk_clist_freeze(GTK_CLIST(sub_list));
  gtk_clist_clear(GTK_CLIST(sub_list));
  
  time_frame=malloc(sizeof(char)*LENGTH_TIME_FRAME);
  subtitle=malloc(sizeof(char)*LENGTH_SUBTITLE);

  if((input_file=fopen(temp_filename,"r"))==NULL)
    {
      show_information(cant_open_file);
    }
  else
    {
      switch(file_format1)
	{
	  
	case 'm': /*microdvd*/


	  while(fscanf(input_file,"%c",&c)!=EOF)
	    {
	            
	      time_frame[0]=c;
	      i=1;	
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='}'))
		time_frame[i++]=c;
	      time_frame[i++]=c;
	      
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='}'))
		time_frame[i++]=c;
	      
	      time_frame[i++]=c;
	      time_frame[i]=0;
	      
	      
	      
	      i=0;
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		if(c!=13)
		  subtitle[i++]=c;
	      
	      subtitle[i]=0;
	      
	      
	      line[0]=time_frame;
	      line[1]=subtitle;
	      
	      gtk_clist_insert(GTK_CLIST(sub_list),length_sub_list++,line);
	    }
	  break;
	case 't': /*time */


	  while(fscanf(input_file,"%c",&c)!=EOF)
	    {
	     
	      
	      time_frame[0]=c;
	      i=1;	
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!=':'))
		time_frame[i++]=c;
	      time_frame[i++]=c;
	      
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!=':'))
		time_frame[i++]=c;
	      time_frame[i++]=c;
	      
	      
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!=':'))
		time_frame[i++]=c;
	      
	      time_frame[i++]=0;
	      

	      i=0;
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		if(c!=13)
		  subtitle[i++]=c;
	      
	      subtitle[i]=0;
	      
	      
	      line[0]=time_frame;
	      line[1]=subtitle;
	      
	      gtk_clist_insert(GTK_CLIST(sub_list),length_sub_list++,line);
	      
	    }
	  break;
	  
	case 'r': /*SubRip*/



	  while(fscanf(input_file,"%c",&c)!=EOF)
	    {

	      
	      i=0;	
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'));
	      
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		if(c!=13)
		  time_frame[i++]=c;

	      time_frame[i]=0;
	      
	      
	      i=0;
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		if(c!=13)
		  subtitle[i++]=c;
	      
	      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!=13)&&(c!='\n'))
		{
		  subtitle[i++]='|';
		  subtitle[i++]=c;
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		    if(c!=13)
		      subtitle[i++]=c;
		}
	      subtitle[i]=0;

	      if(c!='\n')
		while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'));
	      

	     	            
	      line[0]=time_frame;
	      line[1]=subtitle;
	      
	      gtk_clist_insert(GTK_CLIST(sub_list),length_sub_list++,line);
	    }
	  break;
	  
	case 'p': /*MPsub*/

	  while(fscanf(input_file,"%c",&c)!=EOF)
	    {

	      if(c=='T' || c=='F' || c=='N' || c=='A' || c=='t' || c=='f' || c=='n' || c=='a' || c==' ' || c==13 || c=='\n')
		{
		  time_frame[0]=0;
		  if (c!='\n')
		    {
		  i=1;
		  subtitle[0]=c;
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		    if(c!=13 && c!=9)
		      subtitle[i++]=c;
		  
		  subtitle[i]=0;
		    }
		  else
		    subtitle[0]=0;

		}
	      else
		{
		  
		  
		  time_frame[0]=c;
		  i=1;
		  
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		    if(c!=13)
		      time_frame[i++]=c;

		  time_frame[i++]=' ';
		  time_frame[i++]='{';
		  tmp_tab2=itoa(tmp_time);
		  j=0;
		  while(tmp_tab2[j]!=0)
		    time_frame[i++]=tmp_tab2[j++];
		  time_frame[i++]='}';
		  time_frame[i]=0;

		  i=0; j=0;
		  while(time_frame[i]>='0' && time_frame[i]<='9')
		    tmp_tab[j++]=time_frame[i++];
		  
		  tmp_tab[j]=0;

		  tmp_time+=atoi(tmp_tab);

		  if(time_frame[i]=='.' || time_frame[i]==',')
		    {
		      tmp_time2+=(time_frame[++i]-48);
		    }
		  
		 
		  while(time_frame[i++]!=' ');

		  j=0;
		  while(time_frame[i]>='0' && time_frame[i]<='9')
		    tmp_tab[j++]=time_frame[i++];
		  
		  tmp_tab[j]=0;
		  
		  tmp_time+=atoi(tmp_tab);
		  
		  if(time_frame[i]=='.' || time_frame[i]==',')
		    {
		      tmp_time2+=(time_frame[++i]-48);
		    }
		  
	
		  
		  while(tmp_time2>=10)
		    {
		      tmp_time++;
		      tmp_time2-=10;
		    }
		  
		  i=0;
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		    if(c!=13)
		      subtitle[i++]=c;
		  
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!=13)&&(c!='\n'))
		    {
		      subtitle[i++]='|';
		      subtitle[i++]=c;
		      while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
			if(c!=13)
			  subtitle[i++]=c;
		    }
		  subtitle[i]=0;
		  
		  if(c!='\n')
		    while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'));
		}
	      
	      line[0]=time_frame;
	      line[1]=subtitle;
	      
	      
	      gtk_clist_insert(GTK_CLIST(sub_list),length_sub_list++,line);
	      
	    }
	  break;
	  
	case 's': /* SubViewer*/
	  

	  
	  while(fscanf(input_file,"%c",&c)!=EOF)
	    {

	      if(c=='[')
		{
		  time_frame[0]=0;
			  
		  i=1;
		  subtitle[0]=c;
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		    if(c!=13)
		      subtitle[i++]=c;
		  subtitle[i]=0;
		}
	      else
		{
		  time_frame[0]=c;
		  
		  i=1;	
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		    if(c!=13)
		      time_frame[i++]=c;
		  
		  time_frame[i]=0;
		  
		  i=0;
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n'))
		    if(c!=13)
		      subtitle[i++]=c;
	      
		  subtitle[i]=0;
		  
		  while((fscanf(input_file,"%c",&c)!=EOF)&&(c!='\n')); 
		  
		  
		}
	 
	      line[0]=time_frame;
	      line[1]=subtitle;
	      
	      gtk_clist_insert(GTK_CLIST(sub_list),length_sub_list++,line);
	      
	    }
	  
	  break;

	}
      
      length_sub_list--;
      fclose(input_file);
    }
  
  gtk_clist_thaw(GTK_CLIST(sub_list));

}


void preferences()
{
  GList *combo_lang_items = NULL;
  glist_lang temp;
  temp=lang_list;
  pref_window=create_pref_window();

  entry_pref_temp_dir=lookup_widget(pref_window,"entry_pref_temp_dir");
  gtk_entry_set_text(GTK_ENTRY(entry_pref_temp_dir),temp_filename);

  entry_chmod=lookup_widget(pref_window,"entry_chmod");
  gtk_entry_set_text(GTK_ENTRY(entry_chmod),chmod_no);


  entry_pref_lang_dir=lookup_widget(pref_window,"entry_pref_lang_dir");
  gtk_entry_set_text(GTK_ENTRY(entry_pref_lang_dir),lang_dir);

  combo_entry_pref_lang=lookup_widget(pref_window,"combo_entry_pref_lang");
  combo_pref_lang=lookup_widget(pref_window,"combo_pref_lang");


while (temp!=NULL)
{
  combo_lang_items = g_list_append (combo_lang_items, (gpointer) temp->name);
  temp=temp->next;
}

 gtk_combo_set_popdown_strings (GTK_COMBO (combo_pref_lang), combo_lang_items);

 g_list_free (combo_lang_items);

  gtk_entry_set_text(GTK_ENTRY(combo_entry_pref_lang),lang_current_language);


  gtk_widget_show(pref_window);
  return;
}

void properties()
{
 
  properties_window=create_properties_window();



  spinbutton_properties_hours=lookup_widget(properties_window,"spinbutton_properties_hours");
  spinbutton_properties_minutes=lookup_widget(properties_window,"spinbutton_properties_minutes");
  spinbutton_properties_seconds=lookup_widget(properties_window,"spinbutton_properties_seconds");
  spinbutton_properties_frames_in_sec=lookup_widget(properties_window,"spinbutton_properties_frames_in_sec");
  combo_entry_properties_direction=lookup_widget(properties_window,"combo_entry_properties_direction");


  label_move_from_to=lookup_widget(properties_window,"label_move_from_to");
   entry_hour_from=lookup_widget(properties_window,"entry_hour_from");
  entry_min_from=lookup_widget(properties_window,"entry_min_from");
  entry_sec_from=lookup_widget(properties_window,"entry_sec_from");
  entry_hour_to=lookup_widget(properties_window,"entry_hour_to");
  entry_min_to=lookup_widget(properties_window,"entry_min_to");
  entry_sec_to=lookup_widget(properties_window,"entry_sec_to");
  entry_frame_from=lookup_widget(properties_window,"entry_frame_from");
  entry_frame_to=lookup_widget(properties_window,"entry_frame_to");


 gtk_spin_button_set_value(GTK_SPIN_BUTTON(spinbutton_properties_hours),hours_to_move);
  gtk_spin_button_set_value(GTK_SPIN_BUTTON(spinbutton_properties_minutes),minutes_to_move);
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(spinbutton_properties_seconds),seconds_to_move);
 gtk_spin_button_set_value(GTK_SPIN_BUTTON(spinbutton_properties_frames_in_sec),frames_in_sec);
 if (direction==1)
    gtk_entry_set_text(GTK_ENTRY(combo_entry_properties_direction),"===>>");
 else
   gtk_entry_set_text(GTK_ENTRY(combo_entry_properties_direction),"<<===");


 
   

 if (move_partly==0)
   {
     gtk_label_set_text(GTK_LABEL(label_move_from_to),move_partly_off);
     gtk_entry_set_editable(GTK_ENTRY(entry_hour_from),FALSE);
     gtk_entry_set_editable(GTK_ENTRY(entry_min_from),FALSE);
     gtk_entry_set_editable(GTK_ENTRY(entry_sec_from),FALSE);
     gtk_entry_set_editable(GTK_ENTRY(entry_hour_to),FALSE);
     gtk_entry_set_editable(GTK_ENTRY(entry_min_to),FALSE);
     gtk_entry_set_editable(GTK_ENTRY(entry_sec_to),FALSE);
     gtk_entry_set_editable(GTK_ENTRY(entry_frame_from),FALSE);
     gtk_entry_set_editable(GTK_ENTRY(entry_frame_to),FALSE);

   }
 else
   {
        gtk_label_set_text(GTK_LABEL(label_move_from_to),move_partly_on);

     if(file_format1!='m') /*MicroDVD*/
       {
 
	 gtk_entry_set_editable(GTK_ENTRY(entry_frame_from),FALSE);
	 gtk_entry_set_editable(GTK_ENTRY(entry_frame_to),FALSE);

	 gtk_entry_set_text(GTK_ENTRY(entry_hour_from),f_hour);
	 gtk_entry_set_text(GTK_ENTRY(entry_min_from),f_min);
	 gtk_entry_set_text(GTK_ENTRY(entry_sec_from),f_sec);
	 gtk_entry_set_text(GTK_ENTRY(entry_hour_to),t_hour);
	 gtk_entry_set_text(GTK_ENTRY(entry_min_to),t_min);	  
	 gtk_entry_set_text(GTK_ENTRY(entry_sec_to),t_sec);
       }
     else
       {
	 gtk_entry_set_editable(GTK_ENTRY(entry_hour_from),FALSE);
	 gtk_entry_set_editable(GTK_ENTRY(entry_min_from),FALSE);
	 gtk_entry_set_editable(GTK_ENTRY(entry_sec_from),FALSE);
	 gtk_entry_set_editable(GTK_ENTRY(entry_hour_to),FALSE);
	 gtk_entry_set_editable(GTK_ENTRY(entry_min_to),FALSE);
	 gtk_entry_set_editable(GTK_ENTRY(entry_sec_to),FALSE);
	 
	 gtk_entry_set_text(GTK_ENTRY(entry_frame_from),f_frames);
	 gtk_entry_set_text(GTK_ENTRY(entry_frame_to),t_frames);
       }
     
   }

   gtk_widget_show(properties_window);
  return;
}


void save_file()
{
  if (file_is_open==1)
    {
      switch(copy_file(temp_filename,filename))
	{
	case 1: 
	  show_information(cant_read_tmp_file);
	  break;
	  
	case 2: 
	  show_information(cant_write_to_file);
	  break;
	}
      change_file_access(filename,chmod_no);
    }
  else
    show_information(first_open_file);
  return;
}


void save_as()
{
  if (file_is_open==1)
    {
      save_as_window=create_save_as_window();
      gtk_widget_show(save_as_window);

      entry_save_as=lookup_widget(save_as_window,"entry_save_as");
      gtk_entry_set_text(GTK_ENTRY(entry_save_as),filename);
    }
  else
    show_information(first_open_file);
  return;
}


void set_move_entry(int be)
{

  /*if be is 1 then we change "from" otherwise we change "to"*/

  gint i=0,j=0;
  gchar temp[MAX_LENGTH_MOVE_ENTRY];
  
  if (be==1)
    {
      entry_move_from_bottom=lookup_widget(main_window,"entry_move_from_bottom");
    } 
  else
    {
      entry_move_to_bottom=lookup_widget(main_window,"entry_move_to_bottom"); 
    }
  
if (file_format1=='m')
  {
    if(be==1)
      {
	gtk_entry_set_text(GTK_ENTRY(entry_move_from_bottom),f_frames);
      }
    else
      {
	
	gtk_entry_set_text(GTK_ENTRY(entry_move_to_bottom),t_frames);
      }
    
  }
 else
   {
     if(be==1)
    {
      while(f_hour[i]!=0)
	temp[j++]=f_hour[i++];
      
      i=0;
      temp[j++]=':';
      while(f_min[i]!=0)
	temp[j++]=f_min[i++];
      
      i=0;
      temp[j++]=':';
      
      while(f_sec[i]!=0)
	temp[j++]=f_sec[i++];
      
      temp[j]=0;
      gtk_entry_set_text(GTK_ENTRY(entry_move_from_bottom),temp);
    }
     else
     { 
       

       while(t_hour[i]!=0)
	temp[j++]=t_hour[i++];

      i=0;
      temp[j++]=':';
      while(t_min[i]!=0)
	temp[j++]=t_min[i++];

      i=0;
      temp[j++]=':';
      
      while(t_sec[i]!=0)
	temp[j++]=t_sec[i++];

      temp[j]=0;

      gtk_entry_set_text(GTK_ENTRY(entry_move_to_bottom),temp);
    }

    }


}






gboolean
on_main_window_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  exit_program();
  return FALSE;
}


void
on_open_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  merge=0;
  fileselection_window=create_fileselection_window();
  gtk_widget_show(fileselection_window);
  return;
}


void
on_save_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  save_file();
  return;
}


void
on_save_as_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  save_as();
  return;
}


void
on_exit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  exit_program();
  return;
}


void
on_move_all_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (file_is_open==1)
    {
      move_partly=0;
      properties();
    }
  else
    show_information(first_open_file);

  return;
}


void
on_move_partly_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (file_is_open==1)
    {
      move_partly=1;
      properties();
    }
  else
    show_information(first_open_file);

  return;
}


void
on_change_format_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if (file_is_open==1)
    {
      change_format_window=create_change_format_window();

      spinbutton_change_format_frames_in_sec=lookup_widget(change_format_window,"spinbutton_change_format_frames_in_sec");
      gtk_spin_button_set_value(GTK_SPIN_BUTTON(spinbutton_change_format_frames_in_sec),frames_in_sec);
      gtk_widget_show(change_format_window);
    }
  else
    show_information(first_open_file);

  return;
}


void
on_merge_two_sub_files1_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  merge=1;
  fileselection_window=create_fileselection_window();
  gtk_widget_show(fileselection_window);
  return;
}


void
on_convert_to_iso_8859_1_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  if(file_is_open==1)
    {
      if(convert_to_iso_8859_1(temp_filename,temp_filename2)==0)
	{
	  copy_file(temp_filename2,temp_filename);
	  set_sub_list();
	}
      else
	show_information(cant_read_tmp_file);
    }
  else
    show_information(first_open_file);

}


void
on_convert_to_iso_8859_2_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
if(file_is_open==1)
    {
      if(convert_to_iso_8859_2(temp_filename,temp_filename2)==0)
	{
	  copy_file(temp_filename2,temp_filename);
	  set_sub_list();
	}
      else
	show_information(cant_read_tmp_file);
    }
  else
    show_information(first_open_file);

}


void
on_preferences1_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  preferences();
  return;
}


void
on_about1_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  about_window=create_about_window();
  gtk_widget_show(about_window);
  return;
}


void
on_open_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  merge=0;
  fileselection_window=create_fileselection_window();
  gtk_widget_show(fileselection_window);
  return;
}


void
on_save_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  save_file();
  return;
}


void
on_save_as_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  save_as();
  return;
}


void
on_preferences_button_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  preferences();
  return;
}


void
on_quit_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  exit_program();
  return;
}


void
on_button_move_from_bottom_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
  gint sub_list_row,i=0,j=0;
  gchar *time_frames,tmp[LENGTH_TIME_FRAME],*tmp3;
  long tmp2;
  
  if (file_is_open)
    {
      if (GTK_CLIST(sub_list)->selection!=NULL)
	{
	  sub_list_row=(gint)GTK_CLIST(sub_list)->selection->data;
	  gtk_clist_get_text(GTK_CLIST(sub_list),sub_list_row,0,&time_frames);
	  
	  if(((time_frames[0]<='9')&&(time_frames[0]>='0'))||(time_frames[0]=='{'))
	    {
	      
	      switch(file_format1)
		{
		case 'm':
		  i=0;
		  
		  while(time_frames[i]!='}')
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_frames[j++]=time_frames[i];
		      i++;
		    }
		  f_frames[j]=0;
		  
		  break;
		  
		  
		case 't':
		  
		  j=0;
		  while(time_frames[i]!=':')
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_hour[j++]=time_frames[i];
		      i++;
		    }
		  f_hour[j]=0;
		  j=0;
		  i++;
		  while(time_frames[i]!=':')
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_min[j++]=time_frames[i];
		      i++;
		    }
		  f_min[j]=0;
		  j=0;
		  i++;
		  while(time_frames[i]!=0)
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_sec[j++]=time_frames[i];
		      i++;
		    }
		  f_sec[j]=0;
		  break;
		  
		  
		case 's':
		  
		  j=0;
		  while((time_frames[i]!=':')&&(j<=2))
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_hour[j++]=time_frames[i];
		      i++;
		    }
		  f_hour[j]=0;
		  j=0;
		  i++;
		  while((time_frames[i]!=':')&&(j<=2))
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_min[j++]=time_frames[i];
		      i++;
		    }
		  f_min[j]=0;
		  j=0;
		  i++;
		  while((time_frames[i]!=',')&&(j<=2))
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_sec[j++]=time_frames[i];
		      i++;
		    }
		  f_sec[j]=0;
		  break;
		  
		  
		case 'r':
		  
		  j=0;
		  while((time_frames[i]!=':')&&(j<=2))
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_hour[j++]=time_frames[i];
		      i++;
		    }
		  f_hour[j]=0;
		  j=0;
		  i++;
		  while((time_frames[i]!=':') && (j<=2))
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_min[j++]=time_frames[i];
		      i++;
		    }
		  f_min[j]=0;
		  j=0;
		  i++;
		  while((time_frames[i]!=',')&&(time_frames[i]!='.')&&(i<=8))
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			f_sec[j++]=time_frames[i];
		      i++;
		    }
		  f_sec[j]=0;
		  break;

		case 'p':

		  while(time_frames[i++]!='{');

		  
		  j=0;
		  while(time_frames[i]!='}')
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			tmp[j++]=time_frames[i];
		      i++;
		    }
		  
		  tmp[j]=0;
	
		  
		  tmp2=atoi(tmp);
		  tmp3=itoa((int)(tmp2/3600));
		  i=0;
		  while(tmp3[i]!=0)
		    f_hour[i]=tmp3[i++];
		  f_hour[i]=0;
		  
		  tmp2=tmp2%3600;
		  tmp3=itoa((int)(tmp2/60));
		  i=0;
		  while(tmp3[i]!=0)
		    f_min[i]=tmp3[i++];
		  f_min[i]=0;

		  tmp2=tmp2%60;
		  tmp3=itoa((int)(tmp2));
		  i=0;
		  while(tmp3[i]!=0)
		    f_sec[i]=tmp3[i++];
		  f_sec[i]=0;
		  
		  break;
		  
		}
	      
	      set_move_entry(1);
	      
	    }
	  
	}
    }
  
  return;
}


void
on_button_move_to_bottom_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{

  gint sub_list_row,i=0,j=0;
  gchar *time_frames;
  gchar tmp[LENGTH_TIME_FRAME],*tmp3;
  long tmp2;

if(file_is_open){
  if (GTK_CLIST(sub_list)->selection!=NULL)
    {
      sub_list_row=(gint)GTK_CLIST(sub_list)->selection->data;
      gtk_clist_get_text(GTK_CLIST(sub_list),sub_list_row,0,&time_frames);
      
      if(((time_frames[0]<='9')&&(time_frames[0]>='0'))||(time_frames[0]=='{'))
	{
	  switch(file_format1)
	    {
	      
	    case 'm':
	      
	      while(time_frames[i++]!='}');
	      
	      while(time_frames[i]!='}')
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_frames[j++]=time_frames[i];
		  i++;
		}
	      t_frames[j]=0;
	      
	      break;
	      
	    case 't':
	      
	      j=0;
	      while(time_frames[i]!=':')
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_hour[j++]=time_frames[i];
		  i++;
		}
	      t_hour[j]=0;
	      j=0;
	      i++;
	      while(time_frames[i]!=':')
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_min[j++]=time_frames[i];
		  i++;
		}
	      t_min[j]=0;
	      j=0;
	      i++;
	      while(time_frames[i]!=0)
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_sec[j++]=time_frames[i];
		  i++;
		}
	      t_sec[j]=0;
	      
	      break;
	      
	      
	    case 'r':
	      i=0;
	      while(time_frames[i++]!='>');
	  
	      i++;
	      j=0;
	      while((time_frames[i]!=':')&&(j<=2))
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_hour[j++]=time_frames[i];
		  i++;
		}
	      t_hour[j]=0;
	      j=0;
	      i++;
	      while((time_frames[i]!=':')&&(j<=2))
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_min[j++]=time_frames[i];
		  i++;
		}
	      t_min[j]=0;
	      j=0;
	      i++;
	      while((time_frames[i]!=',')&&(time_frames[i]!='.')&&(j<=2))
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_sec[j++]=time_frames[i];
		  i++;
		}
	      t_sec[j]=0;
	      
	      break;
	      
	    case 's':
	      while(time_frames[i++]!=',');
	  
	      j=0;
	      while((time_frames[i]!=':')&&(j<=2))
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_hour[j++]=time_frames[i];
		  i++;
		}
	      t_hour[j]=0;
	      j=0;
	      i++;
	      while((time_frames[i]!=':')&&(j<=2))
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_min[j++]=time_frames[i];
		  i++;
		}
	      t_min[j]=0;
	      j=0;
	      i++;
	      while((time_frames[i]!=',')&&(time_frames[i]!='.')&&(j<=2))
		{
		  if((time_frames[i]>='0')&&(time_frames[i]<='9'))
		    t_sec[j++]=time_frames[i];
		  i++;
		}
	      t_sec[j]=0;
	      
	      break;
	      	case 'p':

		  while(time_frames[i++]!='{');

		  
		  j=0;
		  while(time_frames[i]!='}')
		    {
		      if((time_frames[i]>='0')&&(time_frames[i]<='9'))
			tmp[j++]=time_frames[i];
		      i++;
		    }
		  
		  tmp[j]=0;
	
		  
		  tmp2=atoi(tmp);
		  tmp3=itoa((int)(tmp2/3600));
		  i=0;
		  while(tmp3[i]!=0)
		    t_hour[i]=tmp3[i++];
		  t_hour[i]=0;
		  
		  tmp2=tmp2%3600;
		  tmp3=itoa((int)(tmp2/60));
		  i=0;
		  while(tmp3[i]!=0)
		    t_min[i]=tmp3[i++];
		  t_min[i]=0;

		  tmp2=tmp2%60;
		  tmp3=itoa((int)(tmp2));
		  i=0;
		  while(tmp3[i]!=0)
		    t_sec[i]=tmp3[i++];
		  t_sec[i]=0;
		  
		  break;

	      

	    }
	  set_move_entry(2);
	}
       
	}
    }



 return;

}


void
on_button_change_bottom_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gint sub_list_row=0,i=0,j=0;
  gchar *time_frames, *text,*text_subviewer;
   
   text_subviewer=malloc(LENGTH_SUBTITLE*sizeof(gchar));
   
   if (GTK_CLIST(sub_list)->selection!=NULL)
    {
      sub_list_row=(gint)GTK_CLIST(sub_list)->selection->data;
      gtk_clist_freeze(GTK_CLIST(sub_list));
      
      text_sub_bottom=lookup_widget(main_window,"text_sub_bottom");
      entry_sub_bottom=lookup_widget(main_window,"entry_sub_bottom");

      time_frames=gtk_entry_get_text(GTK_ENTRY(entry_sub_bottom));
      text=gtk_editable_get_chars(GTK_EDITABLE(text_sub_bottom),0,-1);
      text=g_strdelimit(text,"\n",'|');
      gtk_clist_set_text(GTK_CLIST(sub_list),sub_list_row,0,time_frames);

      
      if(file_format1=='s')
	{
	  while(text[i]!=0)
	    {
	      if((text[i]=='|')||(text[i]=='\n'))
		{
		  text_subviewer[j++]='[';
		  text_subviewer[j++]='B';
		  text_subviewer[j++]='R';
		  text_subviewer[j]=']';
		}
	      else
		text_subviewer[j]=text[i]; 
	      i++;
	      j++;
	    }
	  text_subviewer[j]=0;
	  gtk_clist_set_text(GTK_CLIST(sub_list),sub_list_row,1,text_subviewer);
	}
      else
	gtk_clist_set_text(GTK_CLIST(sub_list),sub_list_row,1,text);
    

      gtk_clist_thaw(GTK_CLIST(sub_list));
      save_sub_list();
      set_sub_list();
     }
   return;
}


void
on_button_insert_bottom_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  gint sub_list_row,i=0,j=0;
  gchar **new_row,*time_frames,*text,*text_subviewer;
   
  text_subviewer=malloc(LENGTH_SUBTITLE*sizeof(gchar));
  new_row=malloc(sizeof(gpointer)*2);
  
  
  if (GTK_CLIST(sub_list)->selection!=NULL)
    {
      sub_list_row=(gint)GTK_CLIST(sub_list)->selection->data;
      gtk_clist_freeze(GTK_CLIST(sub_list));
      
      text_sub_bottom=lookup_widget(main_window,"text_sub_bottom");
      entry_sub_bottom=lookup_widget(main_window,"entry_sub_bottom");
      
      time_frames=gtk_entry_get_text(GTK_ENTRY(entry_sub_bottom));
      text=gtk_editable_get_chars(GTK_EDITABLE(text_sub_bottom),0,-1);

      

      new_row[0]=time_frames;
      new_row[1]=malloc(sizeof(gchar));
      *new_row[1]=0;
      gtk_clist_insert(GTK_CLIST(sub_list),sub_list_row+1,new_row);
      text=g_strdelimit(text,"\n",'|');

      if(file_format1=='s')
	{
	  while(text[i]!=0)
	    {
	      if((text[i]=='|')||(text[i]=='\n'))
		{
		  text_subviewer[j++]='[';
		  text_subviewer[j++]='B';
		  text_subviewer[j++]='R';
		  text_subviewer[j]=']';
		}
	      else
		text_subviewer[j]=text[i]; 
	      i++;
	      j++;
	    }
	  text_subviewer[j]=0;
	  gtk_clist_set_text(GTK_CLIST(sub_list),sub_list_row+1,1,text_subviewer);
	}
      else
	gtk_clist_set_text(GTK_CLIST(sub_list),sub_list_row+1,1,text);
      
      
      length_sub_list++;
      gtk_clist_thaw(GTK_CLIST(sub_list));
      save_sub_list();
      set_sub_list();
    }
  return;
}


void
on_button_delete_bottom_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
 gint sub_list_row=0;

  if (GTK_CLIST(sub_list)->selection!=NULL)
    {
      sub_list_row=(gint)GTK_CLIST(sub_list)->selection->data;
      gtk_clist_freeze(GTK_CLIST(sub_list));
      gtk_clist_remove(GTK_CLIST(sub_list),sub_list_row);
      gtk_clist_thaw(GTK_CLIST(sub_list));
      length_sub_list--;
      save_sub_list();
      set_sub_list();
    }
 return;
}


gboolean
on_fileselection_delete_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_destroy(fileselection_window);
  return FALSE;
}


gboolean
on_pref_window_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_destroy(pref_window);
  return FALSE;
}


void
on_button_pref_ok_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  FILE *f,*g;
  gchar *temp,*chmod_e, bufor[MAX_LENGTH_FILENAME];
  glist_lang  temp_l;
  int i=0, restart_f=0;

  temp_l=lang_list;
  chmod_e=gtk_entry_get_text(GTK_ENTRY(entry_chmod));

 if ((chmod_e[0]=='7' || chmod_e[0]=='6' || chmod_e[0]=='5' || chmod_e[0]=='4' || chmod_e[0]=='3'|| chmod_e[0]=='2'|| chmod_e[0]=='1'|| chmod_e[1]=='0') && (chmod_e[1]=='7' || chmod_e[1]=='6' || chmod_e[1]=='5' || chmod_e[1]=='4' || chmod_e[1]=='3'|| chmod_e[1]=='2'|| chmod_e[1]=='1'|| chmod_e[1]=='0') && (chmod_e[2]=='7' || chmod_e[2]=='6' || chmod_e[2]=='5' || chmod_e[2]=='4' || chmod_e[2]=='3'|| chmod_e[2]=='2'|| chmod_e[2]=='1'|| chmod_e[2]=='0'))
 {
  i=0;
  while(chmod_e[i]!=0)
	{
	  chmod_no[i]=chmod_e[i];
	  i++;
	}
  chmod_no[i]=0;
  }





  temp=gtk_entry_get_text(GTK_ENTRY(entry_pref_temp_dir));


  if((strcmp(temp,temp_filename)!=0)&&((f=fopen(temp,"w"))!=NULL))
    {
      fclose(f);

      if((g=fopen(temp_filename,"r"))!=NULL)
	{
	  fclose(g);
	  copy_file(temp_filename,temp);
	  unlink(temp_filename);
	}

      strcpy(temp_filename,temp);
      strcpy(temp_filename2,temp);
      temp_filename2[strlen(temp_filename2)]='_';
      temp_filename2[strlen(temp_filename2)+1]=0;


      set_sub_list();


      if((g=fopen(temp_filename2,"r"))!=NULL)
	{
	  fclose(g);
	  unlink(temp_filename2);
	}


    }



   temp=gtk_entry_get_text(GTK_ENTRY(combo_entry_pref_lang));
   if(strcmp(lang_current_language,temp)!=0)
   { 
    strcpy(lang_current_language,temp); 
    restart_f=1;

   while(temp_l!=NULL)
   {
     if (strcmp(lang_current_language,temp_l->name)==0 ){
     	strcpy(lang_current_filename,lang_dir); strcat(lang_current_filename,temp_l->filename); break;}
     temp_l=temp_l->next;
   }

}

    temp=gtk_entry_get_text(GTK_ENTRY(entry_pref_lang_dir));
    strcpy(bufor,temp); strcat(bufor,"/conf");
if(strcmp(lang_dir,temp)!=0)
    if((g=fopen(bufor,"r"))!=NULL)
      {
	fclose(g);
    	strcpy(lang_dir , temp);
    	read_lang_conf();
	restart_f=1;
      }

	if(restart_f==1)
	show_information(restart);
  gtk_widget_destroy(pref_window);
  return;
}


void
on_button_pref_cancel_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(pref_window);
  return;
}


gboolean
on_properties_window_delete_event      (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

  return FALSE;
}


void
on_button_properties_ok_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
  char *direct;
  gint ms;
  glong from_tf=0;
  glong to_tf=0;
  glong from_frame;
  glong to_frame;
  gint from_hour;
  gint from_min;
  gint from_sec;
  gint to_hour;
  gint to_min;
  gint to_sec;
  
  hours_to_move=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton_properties_hours));
  minutes_to_move=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton_properties_minutes));
  seconds_to_move=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton_properties_seconds));
  frames_in_sec=gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spinbutton_properties_frames_in_sec));
  direct=gtk_entry_get_text(GTK_ENTRY(combo_entry_properties_direction));
  
  from_tf=0;
  to_tf=99*SEC_IN_HOUR+60*SEC_IN_MIN+60;


  if (move_partly==1)
    {
      if (file_format1=='m')
	{
	  from_frame=atol(gtk_entry_get_text(GTK_ENTRY(entry_frame_from)));
	  to_frame=atol(gtk_entry_get_text(GTK_ENTRY(entry_frame_to)));

	  from_tf=from_frame/frames_in_sec;
	  to_tf=to_frame/frames_in_sec;

	  
	}
      else
	{
	  from_hour=atoi(gtk_entry_get_text(GTK_ENTRY(entry_hour_from)));
	  from_min=atoi(gtk_entry_get_text(GTK_ENTRY(entry_min_from)));
	  from_sec=atoi(gtk_entry_get_text(GTK_ENTRY(entry_sec_from)));
	  to_hour=atoi(gtk_entry_get_text(GTK_ENTRY(entry_hour_to)));
	  to_min=atoi(gtk_entry_get_text(GTK_ENTRY(entry_min_to)));
	  to_sec=atoi(gtk_entry_get_text(GTK_ENTRY(entry_sec_to)));
	  
	  
	  from_tf=from_hour*SEC_IN_HOUR+from_min*SEC_IN_MIN+from_sec;
	  to_tf=to_hour*SEC_IN_HOUR+to_min*SEC_IN_MIN+to_sec;

	}
       

    }

    if (strcmp(direct,"===>>")==0)
      direction=1;
    else
      direction=0;

    gtk_widget_destroy(properties_window);

  if (file_is_open==1)
    {
      switch(file_format1)
	{
	case 'm':
	  ms=move_microdvd(temp_filename,temp_filename2,direction,hours_to_move,minutes_to_move,seconds_to_move,from_tf,to_tf,frames_in_sec);    
	  break;

	case 't':
	  ms=move_time(temp_filename,temp_filename2,direction,hours_to_move,minutes_to_move,seconds_to_move,from_tf,to_tf);
	  break;

	case 's':
	  ms=move_subviewer2(temp_filename,temp_filename2,direction,hours_to_move,minutes_to_move,seconds_to_move,from_tf,to_tf); 
	  break;
	  
	case 'r':  
	  ms=move_subrip(temp_filename,temp_filename2,direction,hours_to_move,minutes_to_move,seconds_to_move,from_tf,to_tf);
	  break;
	  
	case 'p':  
	  ms=move_mpsub(temp_filename,temp_filename2,direction,hours_to_move,minutes_to_move,seconds_to_move,from_tf,to_tf);
	  break;

	default:
	  ms=3;
	  break;
	}


      switch(ms)
	{
	case 0:
	  copy_file(temp_filename2,temp_filename);
	  set_sub_list();
	  break;
	  
	case 1:
	  show_information(cant_open_file);
	  break;
	  
	case 2:
	  show_information(cant_read_file);
	  break;
		 
	case 3:
	  show_information(cant_move_subtitles);
	  break;
	}
      
	 
	         
    }  
  else
    show_information(first_open_file);

  return;
}


void
on_button_properties_cancel_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_destroy(properties_window);
    return;
}


void
on_button_inf_ok_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_destroy(information_window);
    return;
}


void
on_button_ok_change_format_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
 char *format,temp_filename3[MAX_LENGTH_FILENAME];
  int fr=0,i=0,ms=0;


  frames_in_sec=gtk_spin_button_get_value_as_float(GTK_SPIN_BUTTON(spinbutton_change_format_frames_in_sec));

  while(temp_filename[i]!=0)
    temp_filename3[i]=temp_filename[i++];

  temp_filename3[i++]='_';
  temp_filename3[i++]='_';
  temp_filename3[i]=0;

  combo_entry_change_format=lookup_widget(change_format_window,"combo_entry_change_format");

  format=gtk_entry_get_text(GTK_ENTRY(combo_entry_change_format));

  if (strcmp(format,"Time")==0)
    fr=1;
  else
    if (strcmp(format,"MicroDVD")==0)
      fr=2;
    else
      if (strcmp(format,"SubViewer 2.0")==0)
	fr=3;
      else
	if (strcmp(format,"SubRip")==0)
	  fr=4; 
	else
	  if (strcmp(format,"MPsub")==0)
	    fr=5; 
  gtk_widget_destroy(change_format_window);


  switch(file_format1)
    {


    case 'm':
      {
	
	switch(fr)
	  {
	    
	  case 1: 
	    
	    if((ms=microdvd_to_time(temp_filename,temp_filename2,frames_in_sec))==0)
	      {
		copy_file(temp_filename2,temp_filename);
		file_format1='t';
		set_sub_list();
	      }
	    break;
	    
	  case 3: 
	    if((ms=microdvd_to_time(temp_filename,temp_filename2,frames_in_sec))==0)
	      {
		if((ms=time_to_subviewer2(temp_filename2,temp_filename3))==0)
		  {
		    copy_file(temp_filename3,temp_filename);
		    file_format1='s';
		    set_sub_list();
		    unlink(temp_filename3);
		  }
	      }
	    break;
			    
	    
	  case 4: 
	    if((ms=microdvd_to_time(temp_filename,temp_filename2,frames_in_sec))==0)
	      {
	      
		if((ms=time_to_subrip(temp_filename2,temp_filename3))==0)
		  {
		    copy_file(temp_filename3,temp_filename);
		    file_format1='r';
		    set_sub_list();
		    unlink(temp_filename3);
		  }
		
	      }
	    break;
	    
	    
	  case 5: 
	    if((ms=microdvd_to_time(temp_filename,temp_filename2,frames_in_sec))==0)
	      {
	      
		if((ms=time_to_mpsub(temp_filename2,temp_filename3))==0)
		  {
		    copy_file(temp_filename3,temp_filename);
		    file_format1='p';
		    set_sub_list();
		    unlink(temp_filename3);
		  }
		
	      }
	    break;

	    
	  	
	  }
      } /* case 'm' */
	break;
      


      
    case 't':
	{
	  switch(fr)
	    {

	    case 2: 
	      if((ms=time_to_microdvd(temp_filename,temp_filename2,frames_in_sec))==0)
		{
		  copy_file(temp_filename2,temp_filename);
		  file_format1='m';
		  set_sub_list();
		}  
	      break;
	      
	      
	    case 3: 
	      if((ms=time_to_subviewer2(temp_filename,temp_filename2))==0)
		{
		  copy_file(temp_filename2,temp_filename);
		  file_format1='s';
		  set_sub_list();
		}
	      break;
	      
	      
	    case 4: 
	      if((ms=time_to_subrip(temp_filename,temp_filename2))==0)
		{
		  copy_file(temp_filename2,temp_filename);
		  file_format1='r';
		  set_sub_list();
		}
	      break;
	      
	    case 5: 
	      if((ms=time_to_mpsub(temp_filename,temp_filename2))==0)
		{
		  copy_file(temp_filename2,temp_filename);
		  file_format1='p';
		  set_sub_list();
		  unlink(temp_filename2);
		  
		}
	      break;
	      
	      
	    }
	} /* case 't': */
	
	break;

	


    case 'r':
      {
	
	switch(fr)
	  {
	  case 1: 
	    if((ms=subrip_to_time(temp_filename,temp_filename2))==0)
	      {
		copy_file(temp_filename2,temp_filename);
		file_format1='t';
		set_sub_list();
	      }
	    break;
	    
	    
	    
	  case 2:/*to microdvd*/ 
	    
	    if((ms=subrip_to_time(temp_filename,temp_filename2))==0)
	      {
		if((ms=time_to_microdvd(temp_filename2,temp_filename3,frames_in_sec))==0)
		  {
		    copy_file(temp_filename3,temp_filename);
		    unlink(temp_filename3);
		    file_format1='m';
		    set_sub_list();
		  }
	      }
	    break;
		  
     	      

	    case 3: 
	      
	      if((ms=subrip_to_subviewer2(temp_filename,temp_filename2))==0)
		{
		  copy_file(temp_filename2,temp_filename);
		  file_format1='s';
		  set_sub_list();
		}
	      
	      break;
	      
	      

	  case 4 :
	    /* We do nothing */ 
	    break;

	  case 5:
	    if((ms=subrip_to_time(temp_filename,temp_filename2))==0)
	      {
		
		if((ms=time_to_mpsub(temp_filename2,temp_filename3))==0)
		  {
		    copy_file(temp_filename3,temp_filename);
		    file_format1='p';
		    set_sub_list();
		    unlink(temp_filename3);
		  }
		
	      }
	    break;

	  }
	break;
	
      }
      break;




    case 's':
      {
	switch(fr)
	  {
	  case 1: 
	    if((ms=subviewer2_to_time(temp_filename,temp_filename2))==0)
	      {
		copy_file(temp_filename2,temp_filename);
		file_format1='t';
		set_sub_list();
	      }
	    break;
	    
	    
	    
	  case 2: 
	    if((ms=subviewer2_to_time(temp_filename,temp_filename2))==0)
	      {
		if((ms=time_to_microdvd(temp_filename2,temp_filename3,frames_in_sec))==0)
		  {
		    copy_file(temp_filename3,temp_filename);
		    unlink(temp_filename3);
		    file_format1='m';
		    set_sub_list();
		  }	
	      }
	    break;
	    
	  case 3 :
	    /* We do nothing */ 
	    break;
	    
	    
	  case 4: 
	    if((ms=subviewer2_to_subrip(temp_filename,temp_filename2))==0)
	    {
	      copy_file(temp_filename2,temp_filename);
	      file_format1='r';
	      set_sub_list();
	    }
	    break;
	    
	  case 5:
	    if((ms=subviewer2_to_time(temp_filename,temp_filename2))==0)
	      {
		if((ms=time_to_mpsub(temp_filename2,temp_filename3))==0)
		  {
		    copy_file(temp_filename3,temp_filename);
		    file_format1='p';
		    set_sub_list();
		    unlink(temp_filename3);
		  }
		
	      }
	    break;
	    
	  }
      } /* case 's': */
      break;
      
    case 'p':
      switch(fr)
	{
	case 1: 
	  if((ms=mpsub_to_time(temp_filename,temp_filename2))==0)
	    {
	      copy_file(temp_filename2,temp_filename);
	      file_format1='t';
	      set_sub_list();
	    }
	  break;
	  
	  
	  
	case 2: 
	  if((ms=mpsub_to_time(temp_filename,temp_filename2))==0)
	    {
	      if((ms=time_to_microdvd(temp_filename2,temp_filename3,frames_in_sec))==0)
		{
		  copy_file(temp_filename3,temp_filename);
		  unlink(temp_filename3);
		  file_format1='m';
		  set_sub_list();
		}	
	    }
	  
	  break;
	  
	case 3: 
	  if((ms=mpsub_to_time(temp_filename,temp_filename2))==0)
	    {
	      if((ms=time_to_subviewer2(temp_filename2,temp_filename3))==0)
		{
		  copy_file(temp_filename3,temp_filename);
		  unlink(temp_filename3);
		  file_format1='s';
		  set_sub_list();
		}	
	    }
	  
	  break;
	    
	case 4: 
	  if((ms=mpsub_to_time(temp_filename,temp_filename2))==0)
	    {
	      if((ms=time_to_subrip(temp_filename2,temp_filename3))==0)
		{
		  copy_file(temp_filename3,temp_filename);
		  unlink(temp_filename3);
		  file_format1='r';
		  set_sub_list();
		}	
	    }
	  
	  break;   
	  
        } /* case 'p': */
      break;

  
    }  
  
if (ms!=0)
{
  switch(ms)
    {
    case 1:
      show_information(cant_open_file);
      break;
      
    case 2:
      show_information(cant_read_file);
      break;
      
    case 3:
      show_information(cant_move_subtitles);
      break;
    }
}


  return;
}


void
on_button_cancel_change_format_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_destroy(change_format_window);
    return;
}


/* fileselection */

void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
 
  gchar *tmpfilename,*tmpfilename2,file_format_tmp;
  gint i=0,ms=5; 
  
  tmpfilename2=malloc(sizeof(gchar)*MAX_LENGTH_FILENAME);

  tmpfilename=gtk_file_selection_get_filename(GTK_FILE_SELECTION(fileselection_window));
  

  while(tmpfilename[i]!=0)
    {
      tmpfilename2[i]=tmpfilename[i];
      i++;
    }
  tmpfilename2[i]=0;


  gtk_widget_destroy(fileselection_window);

  switch(file_format_tmp=check_file_format(tmpfilename2))
    {
    case 1:
      show_information(cant_open_file);
      break;
      
    case '?':
      show_information(format_not_supported);
      break;
      

    default:
      
      if (merge==0)
	{
	  i=0;
	  while(tmpfilename2[i]!=0)
	    {
	      filename[i]=tmpfilename2[i];
	      i++;
	    }
	  filename[i]=0;
	  file_format1=file_format_tmp;
	  file_is_open=1;
	  copy_file(filename,temp_filename);

	}
      else
	{
	  i=0;
	  while(tmpfilename2[i]!=0)
	    {
	      filename2[i]=tmpfilename2[i];
	      i++;
	    }
	  filename2[i]=0;
	  file_format2=file_format_tmp;
	  
	  if(file_format1==file_format2)
	    {
	      
	      switch(file_format2)
		{
		  
		case 'm':
		  ms=merge_microdvd(temp_filename,filename2, temp_filename2,frames_in_sec);
		  break;
		  
		case 't':
		  ms=merge_time(temp_filename,filename2, temp_filename2);
		  break;
		  
		case 'r':
		  ms=merge_subrip(temp_filename,filename2, temp_filename2);
		  break;
		  
		case 's':
		  ms=merge_subviewer2(temp_filename,filename2, temp_filename2);
		  break;
		  
		case 'p':
		  ms=merge_mpsub(temp_filename,filename2, temp_filename2);
		  break;

		}

	      
	      switch(ms)
		{
		case 0:
		  copy_file(temp_filename2,temp_filename);
		  break;
		  
		case 1:
		  show_information(cant_open_file);
		  break;
		  
		case 2:
		  show_information(cant_open_file);
		  break;

		case 3:
		  show_information(cant_read_file);
		  break;
		  
		case 4:
		  show_information(cant_read_file);
		  break;
		  
		case 5:
		  show_information(cant_open_file);
		  break;
		  
		}
	      
	      
	    }
	  else 
	    show_information(incompatibile_file_format); 
	  
	}
      set_sub_list();
      break; 
    }

  return;
}


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
    gtk_widget_destroy(fileselection_window);
    return;
}

/********/

gboolean
on_save_as_window_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_destroy(save_as_window);
  return FALSE;
}


void
on_button_ok_save_as_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  char *filename_save_as;
  int i;

  entry_save_as=lookup_widget(save_as_window,"entry_save_as");
  filename_save_as=gtk_entry_get_text(GTK_ENTRY(entry_save_as));

  switch(copy_file(temp_filename,filename_save_as))
    {
    case 0:
      i=0;
      while(filename_save_as[i]!=0)
	{
	  filename[i]=filename_save_as[i];
	  i++;
	}
      filename[i]=0;
      change_file_access(filename,chmod_no);
      break;

    case 1:
      show_information(cant_read_tmp_file);
      break;

    case 2:
      show_information(cant_write_to_file);
      break;
    }

  gtk_widget_destroy(save_as_window);
  return;

}


void
on_button_cancel_save_as_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(save_as_window);
  return;
}


gboolean
on_information_window_delete_event     (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_destroy(information_window);
  return FALSE;
}



gboolean
on_about_window_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_widget_destroy(about_window);
  return FALSE;
}


void
on_button_close_about_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(about_window);
  return;
}


void
on_sub_list_select_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gint sub_list_row=0;
  gchar *time_frames, *text;
  
  text_sub_bottom=lookup_widget(main_window,"text_sub_bottom");
  gtk_text_set_point(GTK_TEXT(text_sub_bottom),0);
  gtk_text_forward_delete(GTK_TEXT(text_sub_bottom),gtk_text_get_length(GTK_TEXT(text_sub_bottom)));
  sub_list_row=(gint)GTK_CLIST(sub_list)->selection->data;

  gtk_clist_get_text(GTK_CLIST(sub_list),sub_list_row,0,&time_frames);
  gtk_clist_get_text(GTK_CLIST(sub_list),sub_list_row,1,&text);


  entry_sub_bottom=lookup_widget(main_window,"entry_sub_bottom");
  gtk_entry_set_text(GTK_ENTRY(entry_sub_bottom),time_frames);

   gtk_text_freeze(GTK_TEXT(text_sub_bottom));
   gtk_text_insert(GTK_TEXT(text_sub_bottom),NULL,NULL,NULL,text,-1);
   gtk_text_thaw(GTK_TEXT(text_sub_bottom));
 
  return;
}



