#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "functions.h"


char *itoa(int i)
{
  char tab[MAX_ITOA];
  char *a;
  int ii,ii2;

  a=malloc(MAX_ITOA*(sizeof(char)));
  
  if(i==0)
    {
      a[0]='0';
      a[1]=0;
      return a;
    }

  ii=0;
  while(i>0)
    {
      tab[ii++]=(i%10)+48;
      i=i/10;
    }
  --ii;
  
  ii2=0;
  while(ii>=0)
    a[ii2++]=tab[ii--];

  a[ii2]=0;
    

  return a;
}


int copy_file(char *input_filename, char *output_filename)
{

  /*
  This function copy text file. It returns 0 when everything is OK,
  when can't open input file returns 1, 2 when can't write to output file.
*/

  FILE *input_file,*output_file;
  char c;

  if((input_file=fopen(input_filename,"r"))==NULL)
    return 1;


  if((output_file=fopen(output_filename,"w"))==NULL)
    return 2;


  while(fscanf(input_file,"%c",&c)!=EOF)
    if (c!=13)
      fprintf(output_file,"%c",c);


  fclose(input_file);
  fclose(output_file);
  return 0;
}



int check_file_format(char *filename)
{
  /*
    Function check format of file. It returns 'f' when file if microdvd-format, 't' when file is time-format, 's' when file is sub viewer 2.0 -format or 'r' when file is subrip-format, p - when file format is MPsub, or '?' when file is other format,  when can't open the file  it returns 1.
  */
  FILE *input_file;
  char c;


  if((input_file=fopen(filename,"r"))==NULL)
       return 1;





  if(fscanf(input_file,"%c",&c)!=EOF)
    {
      switch(c)
	{
	case '{' :
	  if(fscanf(input_file,"%c",&c)!=EOF)
	    {
	      if ((c>='0')&&(c<='9'))
		{
		  fclose(input_file);
		  return 'm';
		}
	      else
		{
		  fclose(input_file);
		  return '?';
		}
	    }
	  else 
	    {
	      fclose(input_file);
	      return '?';
	    }
	
	  break;

	case '[':
	  if(fscanf(input_file,"%c",&c)!=EOF)
	    {
	      if (c=='I')
		{
		  fclose(input_file);
		  return 's';
		}
	      else
		{
		  fclose(input_file);
		  return '?';
		}
	    }
	  else
	    {  fclose(input_file); return '?';}
	  break;
	  
	default :
		
	
	  if ((c>='0')&&(c<='9'))
	    {
	     while((c>='0')&&(c<='9')){

	      if(fscanf(input_file,"%c",&c)==EOF)
		  {
		   fclose(input_file);
		    return '?'; 
		  }
		 if(c==':')
		  {		      
		  fclose(input_file);
		  return 't';
	        	}
		    else
		if(c==' '||c==','||c=='.')
		  {		      
		    fclose(input_file);
		    return 'p';
		  }
				
		  else
		    if((c==' ')||(c==13)||(c=='\n')||(c=='.')||(c==','))
		      {
			while(c==' ')
			  if(fscanf(input_file,"%c",&c)==EOF)
			    { 
			      fclose(input_file);
			      return '?';
			    }
			
			
			if((c==13)||(c=='\n'))
			  {
			    fclose(input_file);
			    return 'r';
			  }
			else
			  if(((c>='0')&&(c<='9'))||(c=='.')||(c==','))
			    {
			      fclose(input_file);
			      return 'p';
			    }
		      }
		}

		}
	  else
	    {
	      if(c=='T' || c=='F' || c=='N' || c=='A' || c=='t' || c=='f' || c=='n' || c=='a')
		{
		  fclose(input_file);
		  return 'p';
		}
	      else
		{
		  fclose(input_file);
		  return '?';
		}
		    
	  }
	
	  break;
	  
	
    }
}
  else return '?';
  
  
  
  
  fclose(input_file);
  
  
  return '?'; 
  
}








int move_time(char *input_filename, char *output_filename, int what_direction, int hours_to_move, int minutes_to_move , int seconds_to_move, long from_time, long to_time)
{
  /*
    Function move subtitles. It returns 0 when everything is OK, 1 when can't
    read input file, 2 when file format is diffrent than time-format, or 
    can't read file, 3 when function  can't move subititles so far(out of 
    range), 4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  long sume=0,akt_sume=0;
  int hours,minutes,seconds,first=0;
  
  
  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
    
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;
  

  akt_sume=hours_to_move*SEC_IN_HOUR+minutes_to_move*SEC_IN_MIN+seconds_to_move;
 

  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {
      
     if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
       {
	 fclose(file_output);
	 fclose(file_input);
	 return 2;
       }
     
     
     
     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
	   
     if((sume>=from_time)&&(sume<=to_time))
       {
	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	     if (what_direction==1)
	       {
		 if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }
		   
		   
		 sume+=akt_sume;
	       }
	     else
	       {
		 if(sume-akt_sume<0)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }

	       sume-=akt_sume;
	       }
	     hours=sume/SEC_IN_HOUR;
	     sume-=hours*SEC_IN_HOUR;
	     minutes=sume/SEC_IN_MIN;
	     sume-=minutes*SEC_IN_MIN;
	     seconds=sume;
	   }
	 
       }
     
     hours<=9 ? 
       fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
     minutes<=9 ? 
       fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
     seconds<=9 ? 
       fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
	
	 
      
     
	 
     while((c!='\n')&&(fscanf(file_input,"%c",&c)==1))
       if (c!=13) /*end of line in dos*/
	 fprintf(file_output,"%c",c);
	      
     
    }
 
    
 fclose(file_input);
 fclose(file_output);
 return 0;
}








int move_microdvd(char *input_filename,char *output_filename, int what_direction, int hours_to_move, int minutes_to_move , int seconds_to_move, long from_time, long to_time,float frames_in_sec)
{
  /*
    Function move subtitles. It returns 0 when everything is OK, 1 when can't
    read input file, 2 when file format is diffrent than time-format, or 
    can't read file, 3 when function  can't move subititles so far(out of 
    range), , 4 when can't open file to write
  */
  
  FILE *file_input,*file_output;
  char c;
  long sume=0,begin_frame,end_frame,plus;
  
  
  if((file_input=fopen(input_filename,"r"))==NULL)
         return 1;
    
     
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;
  


  plus=(hours_to_move*SEC_IN_HOUR*frames_in_sec) + (minutes_to_move*SEC_IN_MIN*frames_in_sec) + (seconds_to_move*frames_in_sec);

  while ((fscanf(file_input,"%c",&c))!=EOF)
    {
       
      while(c!='{')
	{
	  if((fscanf(file_input,"%c",&c))!=1)
	    {
	      fclose(file_output);
	      fclose(file_input);
	      return 2;
	    }
	}
     
      
      if((fscanf(file_input,"%ld%c%c%ld",&begin_frame,&c,&c,&end_frame))!=4)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      
      sume=begin_frame/frames_in_sec;
      
      
      if((sume>=from_time)&&(sume<to_time))
	{
	  if (what_direction==1)
	    {
	      begin_frame+=plus;
	      end_frame+=plus;
	   }
	  else
	    {
	      begin_frame-=plus;
	      end_frame-=plus;
	    }
	  
	  if ((begin_frame<0)||(end_frame<0)||(end_frame>=(99*SEC_IN_HOUR+59*SEC_IN_MIN+59)*frames_in_sec))
	   {
	     fclose(file_output);
	     fclose(file_input);
	     return 3;
	   }
	  
	}
      fprintf(file_output,"{%ld}{%ld",begin_frame,end_frame);
      
	 
     while((c!='\n')&&(fscanf(file_input,"%c",&c)==1))
       if (c!=13) /*end of line in dos*/
	 fprintf(file_output,"%c",c);
       

    }

  
  fclose(file_input);
  fclose(file_output);
  return 0;
}






int move_subrip(char *input_filename, char *output_filename, int what_direction, int hours_to_move, int minutes_to_move , int seconds_to_move, long from_time, long to_time)
{
  /*
    Function move subtitles. It returns 0 when everything is OK, 1 when can't
    read input file, 2 when file format is diffrent than subrip-format, or 
    can't read file, 3 when function  can't move subititles so far(out of 
    range), 4 when can't open file to write,5 can't write to file;
  */

  FILE *file_input,*file_output;
  char c,tmp;
  long sume=0,akt_sume=0;
  int hours,minutes,seconds,first=0,temp_int;
  
  
  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
    
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;
  

  akt_sume=hours_to_move*SEC_IN_HOUR+minutes_to_move*SEC_IN_MIN+seconds_to_move;
 

  while ((fscanf(file_input,"%d",&temp_int))!=EOF)
    {
      if(fprintf(file_output,"%d\n",temp_int)==0)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 5;
	}
      
      if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      
     
     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
	   
     if((sume>=from_time)&&(sume<=to_time))
       {
	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	     if (what_direction==1)
	       {
		 if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }
		   
		   
		 sume+=akt_sume;
	       }
	     else
	       {
		 if(sume-akt_sume<0)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }

	       sume-=akt_sume;
	       }
	     hours=sume/SEC_IN_HOUR;
	     sume-=hours*SEC_IN_HOUR;
	     minutes=sume/SEC_IN_MIN;
	     sume-=minutes*SEC_IN_MIN;
	     seconds=sume;
	   }
	 
       }
     
     	 
     hours<=9 ? 
       fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
     minutes<=9 ? 
       fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
     seconds<=9 ? 
       fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
      
     

	 while((fscanf(file_input,"%c",&tmp)!=EOF)&&(tmp!='>'))
	   fprintf(file_output,"%c",tmp);
	   
	 fprintf(file_output,"%c",tmp);


	 if(fscanf(file_input,"%c",&tmp)!=EOF)
	   {
	     fprintf(file_output,"%c",tmp);
	   }
	 else
	   {
	     fclose(file_output);
	     fclose(file_input);
	     return 2;
	   }


         
      if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
     

     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
	   
     if((sume>=from_time)&&(sume<=to_time))
       {
	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	     if (what_direction==1)
	       {
		 if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }
		   
		   
		 sume+=akt_sume;
	       }
	     else
	       {
		 if(sume-akt_sume<0)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }

	       sume-=akt_sume;
	       }
	     hours=sume/SEC_IN_HOUR;
	     sume-=hours*SEC_IN_HOUR;
	     minutes=sume/SEC_IN_MIN;
	     sume-=minutes*SEC_IN_MIN;
	     seconds=sume;
	   }
	 
       }
     
     	 
    hours<=9 ? 
       fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
     minutes<=9 ? 
       fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
     seconds<=9 ? 
       fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 


     
     while((fscanf(file_input,"%c",&c)==1)&&(fprintf(file_output,"%c",c))&&(c!='\n'));
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n')&&(c!=13))
       {
	 fprintf(file_output,"%c",c);
	 while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	   {
	     fprintf(file_output,"%c",c);
	   }
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"\n");
     
     
     if(c!='\n')
       while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
  

    }
 
    
 fclose(file_input);
 fclose(file_output);
 return 0;
}








int move_subviewer2(char *input_filename, char *output_filename, int what_direction, int hours_to_move, int minutes_to_move , int seconds_to_move, long from_time, long to_time)
{
  /*
    Function move subtitles. It returns 0 when everything is OK, 1 when can't
    read input file, 2 when file format is diffrent than subviewer2-format, or 
    can't read file, 3 when function  can't move subititles so far(out of 
    range), 4 when can't open file to write,5 can't write to file;
  */

  FILE *file_input,*file_output;
  char c;
  long sume=0,akt_sume=0;
  int hours,minutes,seconds,first=0;
  
  
  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
    
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;
  

  akt_sume=hours_to_move*SEC_IN_HOUR+minutes_to_move*SEC_IN_MIN+seconds_to_move;
 
  
  while (((fscanf(file_input,"%c",&c)!=EOF))&&(c=='['))
    {
      fprintf(file_output,"%c",c);
      while (((fscanf(file_input,"%c",&c)!=EOF))&&(c!='\n'))
	fprintf(file_output,"%c",c);
      fprintf(file_output,"%c",c);
    }
    
  fseek(file_input,-1,SEEK_CUR);


  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {
      
            
      if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
     

     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
     
     if((sume>=from_time)&&(sume<=to_time))
       {
	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	     if (what_direction==1)
	       {
		 if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }
		   
		   
		 sume+=akt_sume;
	       }
	     else
	       {
		 if(sume-akt_sume<0)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }

	       sume-=akt_sume;
	       }
	     hours=sume/SEC_IN_HOUR;
	     sume-=hours*SEC_IN_HOUR;
	     minutes=sume/SEC_IN_MIN;
	     sume-=minutes*SEC_IN_MIN;
	     seconds=sume;
	   }
	 
       }
     
     	 
	  hours<=9 ? 
       fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
     minutes<=9 ? 
       fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
     seconds<=9 ? 
       fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
	 
      
     

	 while((fscanf(file_input,"%c",&c)!=EOF)&&(c!=','))
	   fprintf(file_output,"%c",c);
	   
	 fprintf(file_output,"%c",c);



	 if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
	      



     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
	   
     if((sume>=from_time)&&(sume<=to_time))
       {
	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	     if (what_direction==1)
	       {
		 if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }
		   
		   
		 sume+=akt_sume;
	       }
	     else
	       {
		 if(sume-akt_sume<0)
		   {
		     fclose(file_output);
		     fclose(file_input);
		     return 3;
		   }

	       sume-=akt_sume;
	       }
	     hours=sume/SEC_IN_HOUR;
	     sume-=hours*SEC_IN_HOUR;
	     minutes=sume/SEC_IN_MIN;
	     sume-=minutes*SEC_IN_MIN;
	     seconds=sume;
	   }
	 
       }
     
     	 
  hours<=9 ? 
       fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
     minutes<=9 ? 
       fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
     seconds<=9 ? 
       fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 



     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c",c);

     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c\n",c);
     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
  

    }
 
    
 fclose(file_input);
 fclose(file_output);
 return 0;
}



int move_mpsub(char *input_filename, char *output_filename, int what_direction, int hours_to_move, int minutes_to_move , int seconds_to_move, long from_time, long to_time)
{
  /*
    Function move subtitles. It returns 0 when everything is OK, 1 when can't
    read input file, 2 when file format is diffrent than time-format, or 
    can't read file, 3 when function  can't move subititles so far(out of 
    range), 4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  float sume=0,tmp3;
  long akt_sume,akt_sume2,tmp1,tmp2;
  float time,how_long;
  int first=0,last=0;
  
  
  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
    
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;
  
  /* skip intro:) */

  while (fscanf(file_input,"%c",&c)!=EOF && c!='0' && c!='1' && c!='2' && c!='3' && c!='4' && c!='5' && c!='6' && c!='7' && c!='8' && c!='9')
    {
      fprintf(file_output,"%c",c);
      while ((c!='\n')&&((fscanf(file_input,"%c",&c)!=EOF)))
	fprintf(file_output,"%c",c);
    }
    
  fseek(file_input,-1,SEEK_CUR);

  /*************/

  akt_sume=hours_to_move*SEC_IN_HOUR+minutes_to_move*SEC_IN_MIN+seconds_to_move;
 
  sume=0;

  akt_sume2=akt_sume;


  while ((fscanf(file_input,"%ld",&tmp1))!=EOF)
    {
      if((fscanf(file_input,"%c",&c))!=1)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      if(c=='.' || c==',')
	{
	if((fscanf(file_input,"%f",&tmp3))!=1)
	  {
	    fclose(file_output);
	    fclose(file_input);
	    return 2;
	  }

	while(tmp3>=10)
	  tmp3/=10;
	
	time=(float)tmp1;
	time+=(float)(tmp3/10);

	if((fscanf(file_input,"%c",&c))!=1)
	  {
	    fclose(file_output);
	    fclose(file_input);
	    return 2;
       }
	
	}
      else
	time=(float)tmp1;

      


     if((fscanf(file_input,"%ld",&tmp1))!=1)
       {
	 fclose(file_output);
	 fclose(file_input);
	 return 2;
       }
     
     if((fscanf(file_input,"%c",&c))!=1)
       {
	 fclose(file_output);
	 fclose(file_input);
	 return 2;
       }
      
      if(c=='.' || c==',')
	{
	if((fscanf(file_input,"%f",&tmp3))!=1)
	  {
	    fclose(file_output);
	    fclose(file_input);
	    return 2;
	  }

	while(tmp3>=10)
	  tmp3/=10;
	
	how_long=(float)tmp1;
	how_long+=(tmp3/10);
	
	}
      else
	how_long=(float)tmp1;
      
      
      
      sume+=time;
      
     if (what_direction==1)
       {
	 if (sume>=from_time && first==0)
	   {
	     time+=akt_sume;
	     
	     first=1;
	   }
	 else
	   if(sume>=to_time && last==0) 
	     { 
	       if((time-akt_sume)<0) 
		 {
		   time=0;
		 }
	       else
		 {  
		   time-=akt_sume;
		   last=1;
		 }
	          
	     }
	   
	 sume+=how_long;
	 tmp1=(long)time;
	 tmp2=(long)((time-tmp1)*10);
	 tmp2!=0 ? fprintf(file_output,"%ld.%ld",tmp1,tmp2) : fprintf(file_output,"%ld",tmp1) ;
	 
	 tmp1=(long)how_long;
	 tmp2=(long)((how_long-tmp1)*10);
	 tmp2!=0 ? fprintf(file_output," %ld.%ld\n",tmp1,tmp2) :fprintf(file_output," %ld\n",tmp1) ;
 
       }
     else
       {
	 


	 if (sume>=from_time && first==0  && sume<to_time)
	   {
	     if(time-akt_sume<0)
	       {
		 akt_sume-=time;
		 time=0;
	       }
	     else
	       {
		 time-=akt_sume;
		 first=1;
	       }
	   }
	 else
	   {
	     if(sume>=to_time && last==0)
	       {
		 time+=(float)akt_sume2;
		 last=1;
	       }

	   }	     
	 sume+=how_long;
	 tmp1=(long)time;
	 tmp2=(long)((time-tmp1)*10);
	 tmp2!=0 ? fprintf(file_output,"%ld.%ld",tmp1,tmp2) : fprintf(file_output,"%ld",tmp1) ;
	 
	 tmp1=(long)how_long;
	 tmp2=(long)((how_long-tmp1)*10);
	 tmp2!=0 ? fprintf(file_output," %ld.%ld\n",tmp1,tmp2) :fprintf(file_output," %ld\n",tmp1) ;	 
       }
     
     while((c!='\n')&&(fscanf(file_input,"%c",&c)==1));
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n')&&(c!=13))
       {
	 fprintf(file_output,"%c",c);
	 while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	   {
	     fprintf(file_output,"%c",c);
	   }
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"\n");
     
     
     if(c!='\n')
       while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
  
	      
     
    }
 
    
 fclose(file_input);
 fclose(file_output);
 return 0;
}








int convert_to_iso_8859_1(char *input_filename,char *output_filename)
{
  /*
    Function return 0 when everything is OK, 1 when can't read input file
    , 2 when can't open file to write
  */

  FILE *file_input,*file_output;
  signed char c;

  
  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 2;
  
  
  while(fscanf(file_input,"%c",&c)!=EOF)
    {
      switch (c)
	{
	case -126 :
	  {
	    fprintf(file_output,"%c",44);
	    break;
	  }
	case -124 :
	  {
	    fprintf(file_output,"%c",44);
	    break;
	  }
	  case -123 :
	  {
	    fprintf(file_output,"%c",46);
	    break;
	  }
	case -122 :
	  {
	    fprintf(file_output,"%c",43);
	    break;
	  }
	case -121 :
	  {
	    fprintf(file_output,"%c",43);
	    break;
	  }
	  case -118 :
	  {
	    fprintf(file_output,"%c",83);
	    break;
	  }
	  	case -115 :
	  {
	    fprintf(file_output,"%c",-85);
	    break;
	  }

	case -116 :
	  {
	    fprintf(file_output,"%c",83); 
	    break;
	  }
	case -114 :
	  {
	    fprintf(file_output,"%c",-82);
	    break;
	  }
	  case -113 :
	  {
	    fprintf(file_output,"%c",-81);
	    break;
	  }
	case -111 :
	  {
	    fprintf(file_output,"%c",36);
	    break;
	  }
	case -110 :
	  {
	    fprintf(file_output,"%c",39);
	    break;
	  }
	  case -109 :
	  {
	    fprintf(file_output,"%c",34);
	    break;
	  }
	case -108 :
	  {
	    fprintf(file_output,"%c",34);
	    break;
	  }
	case -107 :
	  {
	    fprintf(file_output,"%c",-80);
	    break;
	  }
	  case -106 :
	  {
	    fprintf(file_output,"%c",-83);
	    break;
	  }
	case -105 :
	  {
	    fprintf(file_output,"%c",-83);
	    break;
	  }
	case -102 :
	  {
	    fprintf(file_output,"%c",115);
	    break;
	  }
	  case -100 :
	  {
	    fprintf(file_output,"%c",115);
	    break;
	  }
	case -99 :
	  {
	    fprintf(file_output,"%c",105);
	    break;
	  }
	case -98 :
	  {
	    fprintf(file_output,"%c",122);
	    break;
	  }
	case -97 :
	  {
	    fprintf(file_output,"%c",122);
	    break;
	  }
	case -78 :
	  {
	    fprintf(file_output,"%c",-72);
	    break;
	  }
	  case -72 :
	  {
	    fprintf(file_output,"%c",39);
	    break;
	  }
	case -67 :
	  {
	    fprintf(file_output,"%c",-34);
	    break;
	  }
	case -65 :
	  {
	    fprintf(file_output,"%c",122);
	    break;
	  }
	case -64 :
	  {
	    fprintf(file_output,"%c",82);
	    break;
	  }
	case -63 :
	  {
	    fprintf(file_output,"%c",65);
	    break;
	  }
	case -62 :
	  {
	    fprintf(file_output,"%c",65);
	    break;
	  }
	case -61 :
	  {
	    fprintf(file_output,"%c",65);
	    break;
	  }
	case -60 :
	  {
	    fprintf(file_output,"%c",65);
	    break;
	  }
	case -59 :
	  {
	    fprintf(file_output,"%c",76);
	    break;
	  }
	case -58 :
	  {
	    fprintf(file_output,"%c",67);
	    break;
	  }
	case -57 :
	  {
	    fprintf(file_output,"%c",67);
	    break;
	  }
	case -56 :
	  {
	    fprintf(file_output,"%c",67);
	    break;
	  }
	case -55 :
	  {
	    fprintf(file_output,"%c",69);
	    break;
	  }
	case -54 :
	  {
	    fprintf(file_output,"%c",69);
	    break;
	  }
	case -53 :
	  {
	    fprintf(file_output,"%c",69);
	    break;
	  }
	case -52 :
	  {
	    fprintf(file_output,"%c",69);
	    break;
	  }
	case -51 :
	  {
	    fprintf(file_output,"%c",73);
	    break;
	  }
	case -50 :
	  {
	    fprintf(file_output,"%c",73);
	    break;
	  }
	case -49 :
	  {
	    fprintf(file_output,"%c",68);
	    break;
	  }
	case -48 :
	  {
	    fprintf(file_output,"%c",68);
	    break;
	  }
	case -47 :
	  {
	    fprintf(file_output,"%c",78);
	    break;
	  }
	case -46 :
	  {
	    fprintf(file_output,"%c",78);
	    break;
	  }
	case -45 :
	  {
	    fprintf(file_output,"%c",79);
	    break;
	  }
	case -44 :
	  {
	    fprintf(file_output,"%c",79);
	    break;
	  }
	case -43 :
	  {
	    fprintf(file_output,"%c",79);
	    break;
	  }
	case -42 :
	  {
	    fprintf(file_output,"%c",79);
	    break;
	  }
	case -41 :
	  {
	    fprintf(file_output,"%c",120);
	    break;
	  }
	case -40 :
	  {
	    fprintf(file_output,"%c",82);
	    break;
	  }
	case -39 :
	  {
	    fprintf(file_output,"%c",85);
	    break;
	  }
	case -38 :
	  {
	    fprintf(file_output,"%c",85);
	    break;
	  }
	case -37 :
	  {
	    fprintf(file_output,"%c",85);
	    break;
	  }
	case -36 :
	  {
	    fprintf(file_output,"%c",85);
	    break;
	  }
	case -35 :
	  {
	    fprintf(file_output,"%c",89);
	    break;
	  }
	case -34 :
	  {
	    fprintf(file_output,"%c",84);
	    break;
	  }
	case -33 :
	  {
	    fprintf(file_output,"%c",66);
	    break;
	  }
	case -32 :
	  {
	    fprintf(file_output,"%c",114);
	    break;
	  }

	case -31 :
	  {
	    fprintf(file_output,"%c",97);
	    break;
	  }
	case -30 :
	  {
	    fprintf(file_output,"%c",97);
	    break;
	  }
	case -29 :
	  {
	    fprintf(file_output,"%c",97);
	    break;
	  }
	case -28 :
	  {
	    fprintf(file_output,"%c",97);
	    break;
	  }
  	case -27 :
	  {
	    fprintf(file_output,"%c",108);
	    break;
	  }
  	case -26 :
	  {
	    fprintf(file_output,"%c",99);
	    break;
	  }
  	case -25 :
	  {
	    fprintf(file_output,"%c",99);
	    break;
	  }
  	case -24 :
	  {
	    fprintf(file_output,"%c",99);
	    break;
	  }
  	case -23 :
	  {
	    fprintf(file_output,"%c",101);
	    break;
	  }
  	case -22 :
	  {
	    fprintf(file_output,"%c",101);
	    break;
	  }
 	case -21 :
	  {
	    fprintf(file_output,"%c",101);
	    break;
	  }
	case -20 :
	  {
	    fprintf(file_output,"%c",101);
	    break;
	  }
	case -19 :
	  {
	    fprintf(file_output,"%c",105);
	    break;
	  }
	case -18 :
	  {
	    fprintf(file_output,"%c",105);
	    break;
	  }
	case -17 :
	  {
	    fprintf(file_output,"%c",100);
	    break;
	  }
 	case -16 :
	  {
	    fprintf(file_output,"%c",100);
	    break;
	  }
	case -15 :
	  {
	    fprintf(file_output,"%c",110);
	    break;
	  }
	case -14 :
	  {
	    fprintf(file_output,"%c",110);
	    break;
	  }
 	case -13 :
	  {
	    fprintf(file_output,"%c",111);
	    break;
	  }
	case -12 :
	  {
	    fprintf(file_output,"%c",111);
	    break;
	  }
	case -11 :
	  {
	    fprintf(file_output,"%c",111);
	    break;
	  }
	  case -10 :
	  {
	    fprintf(file_output,"%c",111);
	    break;
	  }
 	case -8 :
	  {
	    fprintf(file_output,"%c",114);
	    break;
	  }
 	case -7 :
	  {
	    fprintf(file_output,"%c",117);
	    break;
	  }
 	case -6 :
	  {
	    fprintf(file_output,"%c",117);
	    break;
	  }
  	case -5 :
	  {
	    fprintf(file_output,"%c",117);
	    break;
	  }
	case -4 :
	  {
	    fprintf(file_output,"%c",117);
	    break;
	  }
 	case -3 :
	  {
	    fprintf(file_output,"%c",121);
	    break;
	  }
 	case -2 :
	  {
	    fprintf(file_output,"%c",116);
	    break;
	  }
	case -95 :
	  {
	    fprintf(file_output,"%c",65);
	    break;
	  }
	case -93 :
	  {
	    fprintf(file_output,"%c",76);
	    break;
	  }
	case -91 :
	  {
	    fprintf(file_output,"%c",76);
	    break;
	  }
	case -90 :
	  {
	    fprintf(file_output,"%c",83);
	    break;
	  }
	case -87 :
	  {
	    fprintf(file_output,"%c",83);
	    break;
	  }
	case -86 :
	  {
	    fprintf(file_output,"%c",83);
	    break;
	  }
	case -85 :
	  {
	    fprintf(file_output,"%c",84);
	    break;
	  }
	case -84 :
	  {
	    fprintf(file_output,"%c",90);
	    break;
	  }
	case -82 :
	  {
	    fprintf(file_output,"%c",90);
	    break;
	  }
	case -81 :
	  {
	    fprintf(file_output,"%c",90);
	    break;
	  }
	case -79 :
	  {
	    fprintf(file_output,"%c",97);
	    break;
	  }
	case -77 :
	  {
	    fprintf(file_output,"%c",108);
	    break;
	  }
	case -75 :
	  {
	    fprintf(file_output,"%c",108);
	    break;
	  }
	case -74 :
	  {
	    fprintf(file_output,"%c",115);
	    break;
	  }
	case -71 :
	  {
	    fprintf(file_output,"%c",115);
	    break;
	  }
	case -70 :
	  {
	    fprintf(file_output,"%c",115);
	    break;
	  }
	case -69 :
	  {
	    fprintf(file_output,"%c",116);
	    break;
	  }
	case -68:
	  {
	    fprintf(file_output,"%c",122);
	    break;
	  }
	case -66:
	  {
	    fprintf(file_output,"%c",122);
	    break;
	  }
	case 13:
	  break;
	default :
	  {
	    fprintf(file_output,"%c",c);
	    break;
	  }
	}
    }


  fclose(file_input);
  fclose(file_output);
  return 0;
}

















int convert_to_iso_8859_2(char *input_filename,char *output_filename)
{
  /*
    Function return 0 when everything is OK, 1 when can't read input file
    , 2 when can't open file to write
  */

  FILE *file_input,*file_output;
  signed char c;


  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;

  if((file_output=fopen(output_filename,"w"))==NULL)
    return 2;


  while(fscanf(file_input,"%c",&c)!=EOF)
    {
      switch (c)
	{
	case -126 :
	  {
	    fprintf(file_output,"%c",44);
	    break;
	  }
	case -124 :
	  {
	    fprintf(file_output,"%c",44);
	    break;
	  }
	  case -123 :
	  {
	    fprintf(file_output,"%c",46);
	    break;
	  }
	case -122 :
	  {
	    fprintf(file_output,"%c",43);
	    break;
	  }
	case -121 :
	  {
	    fprintf(file_output,"%c",43);
	    break;
	  }
	  case -118 :
	  {
	    fprintf(file_output,"%c",-87);
	    break;
	  }
	  	case -115 :
	  {
	    fprintf(file_output,"%c",-85);
	    break;
	  }
	case -116 :
	  {
	    fprintf(file_output,"%c",-90);
	    break;
	  }
	case -114 :
	  {
	    fprintf(file_output,"%c",-90);
	    break;
	  }
	  case -113 :
	  {
	    fprintf(file_output,"%c",-81);
	    break;
	  }
	case -111 :
	  {
	    fprintf(file_output,"%c",36);
	    break;
	  }
	case -110 :
	  {
	    fprintf(file_output,"%c",39);
	    break;
	  }
	  case -109 :
	  {
	    fprintf(file_output,"%c",34);
	    break;
	  }
	case -108 :
	  {
	    fprintf(file_output,"%c",34);
	    break;
	  }
	case -107 :
	  {
	    fprintf(file_output,"%c",-80);
	    break;
	  }
	  case -106 :
	  {
	    fprintf(file_output,"%c",-83);
	    break;
	  }
	case -105 :
	  {
	    fprintf(file_output,"%c",-83);
	    break;
	  }
	case -102 :
	  {
	    fprintf(file_output,"%c",-71);
	    break;
	  }
	  case -100 :
	  {
	    fprintf(file_output,"%c",-74);
	    break;
	  }
	case -99 :
	  {
	    fprintf(file_output,"%c",-69);
	    break;
	  }
	case -98 :
	  {
	    fprintf(file_output,"%c",-66);
	    break;
	  }
	case -97 :
	  {
	    fprintf(file_output,"%c",-65);
	    break;
	  }
	  case -91 :
	  {
	    fprintf(file_output,"%c",-95);
	    break;
	  }
	case -86 :
	  {
	    fprintf(file_output,"%c",-70);
	    break;
	  }
	case -85 :
	  {
	    fprintf(file_output,"%c",60);
	    break;
	  }
	case -78 :
	  {
	    fprintf(file_output,"%c",-72);
	    break;
	  }
	  case -72 :
	  {
	    fprintf(file_output,"%c",39);
	    break;
	  }
	case -71 :
	  {
	    fprintf(file_output,"%c",-79);
	    break;
	  }
	case -69 :
	  {
	    fprintf(file_output,"%c",62);
	    break;
	  }
	case -68 :
	  {
	    fprintf(file_output,"%c",-59);
	    break;
	  }
	  case -67 :
	  {
	    fprintf(file_output,"%c",-34);
	    break;
	  }
	case -66 :
	  {
	    fprintf(file_output,"%c",-75);
	    break;
	  }
	case 13:
	  break;
	default :
	  {
	    fprintf(file_output,"%c",c);
	    break;
	  }
	}
    }


  fclose(file_input);
  fclose(file_output);
  return 0;
}
















int microdvd_to_time(char *input_filename, char *output_filename,float frames_in_sec)
{
 /*
    Function convert microdvd-format subtitles to time format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than time-format, or can't read file, 
    3 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  long sume=0,frames_begin;
  int hours,minutes,seconds;
   
     

  if((file_input=fopen(input_filename,"r"))==NULL)
        return 1;
  
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 3;
  

  
  while ((fscanf(file_input,"%c",&c))!=EOF)
    {
      
      while(c!='{')
	{
	  if((fscanf(file_input,"%c",&c))!=1)
	    {
	      fclose(file_input);
	      fclose(file_output);
	      return 2;
	    }
	}
      
      if(fscanf(file_input,"%ld%c%c",&frames_begin,&c,&c)!=3)
	{
	  fclose(file_input);
	  fclose(file_output);
	  return 2;
	}

	while(c!='}')
	  {
	    if((fscanf(file_input,"%c",&c))!=1)
	      {
		fclose(file_input);
		fclose(file_output);
		return 2;
	      }
	  }
	

     sume=frames_begin/frames_in_sec;
	   
     hours=sume/3600;
     sume-=hours*3600;
     minutes=sume/60;
     sume-=minutes*60;
     seconds=sume;
     
     
     hours<=9 ? 
       fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
     minutes<=9 ? 
       fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
     seconds<=9 ? 
       fprintf(file_output,"0%d:",seconds) : fprintf(file_output,"%d:",seconds);	 
     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c",c);
    }
  
  c!='\n' ?    fprintf(file_output,"\n00:00:00:\n") : fprintf(file_output,"00:00:00:\n");
  
  fclose(file_input);
  fclose(file_output);
  return 0;
}










int time_to_microdvd(char *input_filename, char *output_filename,float frames_in_sec)
{
 /*
    Function convert time - format  subtitles to microdvd format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than time-format, or can't read file, 
    3 when function  can't move subititles so far(out of range), 
    4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c,subtitle[MAX_SUB_LENGTH];
  long sume=0,last_sume=0;
  int hours,minutes,seconds,i;
   
     

  if((file_input=fopen(input_filename,"r"))==NULL)
        return 1;
  
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;

 

  if ((fscanf(file_input,"%d",&hours))!=EOF)
    {
            
    if((fscanf(file_input,"%c%d%c%d%c",&c,&minutes,&c,&seconds,&c))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      last_sume=(hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds)*frames_in_sec;

      i=0;
      
      while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	{
	  subtitle[i++]=c;
	}
      subtitle[i]='\0';

    }



   
  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {

      if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  printf("hir");
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}      
     
      
      sume=((hours*SEC_IN_HOUR)+(minutes*SEC_IN_MIN)+seconds)*frames_in_sec;
      
      if ((last_sume==0)||(sume!=0))
	{

	  if(fscanf(file_input,"%c",&c)!=1)
	    {
	      fclose(file_input);
	      fclose(file_output);
	      return 2;
	    }
	  
	  if ((last_sume+(HOW_LONG_SHOW_SUB*frames_in_sec))>sume)
	    fprintf(file_output,"{%ld}{%ld}",last_sume,sume-1);
	  else
	    fprintf(file_output,"{%ld}{%ld}",last_sume,(long )(last_sume+HOW_LONG_SHOW_SUB*frames_in_sec));

	  fprintf(file_output,"%s",subtitle);
	  fprintf(file_output,"\n");

	  i=0;
	  
	  while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	    subtitle[i++]=c;
	    
	  subtitle[i]='\0';
	    
	  last_sume=sume;
	}
      else
	{
	  while ((fscanf(file_input,"%c",&c))!=EOF);
	}
      
      if(sume>last_sume)
	last_sume=sume;
    } 

  
  
  fprintf(file_output,"{%ld}{%ld}",last_sume,(long )(last_sume+HOW_LONG_SHOW_SUB*frames_in_sec));
  
  fprintf(file_output,"%s",subtitle);
  fprintf(file_output,"\n");
  

  fclose(file_input);
  fclose(file_output);
  return 0;
}










int time_to_subviewer2(char *input_filename, char *output_filename)
{
 /*
    Function convert time-format subtitles to subviewer2 format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than time-format, or can't read file, 
    4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  int hours,minutes,seconds,first=1;
   
     

  if((file_input=fopen(input_filename,"r"))==NULL)
        return 1;
  
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;

   
  fprintf(file_output,"[INFORMATION]\n");
  fprintf(file_output,"[AUTHOR]\n");
  fprintf(file_output,"[SOURCE]\n");
  fprintf(file_output,"[PRG]\n");
  fprintf(file_output,"[FILEPATH]\n");
  fprintf(file_output,"[DELAY]\n");
  fprintf(file_output,"[CD TRACK]\n");
  fprintf(file_output,"[COMMENT] edited by GTKsubtitler <www.gtksubtitler.prv.pl>\n");
  fprintf(file_output,"[END INFORMATION]\n");
  fprintf(file_output,"[SUBTITLE]\n");
  fprintf(file_output,"[COLF]&HFFFFFF,[STYLE]bd,[SIZE]18,[FONT]Arial\n");

  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {

      if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  fclose(file_input);
	  fclose(file_output);
	  return 2;
	}
      
      if((hours!=0)||(minutes!=0)||(seconds!=0)||(first==1))
	{
	  if(fscanf(file_input,"%c",&c)!=1)
	    {
	      fclose(file_input);
	      fclose(file_output);
	      return 2;
	    }
	  
	  if((hours!=0)||(minutes!=0)||(seconds!=0))
	    first=0;
 
	  hours<=9 ? 
	    fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
	  minutes<=9 ? 
	    fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	  seconds<=9 ? 
	    fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
	  
	  fprintf(file_output,".00,");
	  
	  hours<=9 ? 
	    fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
	  minutes<=9 ? 
	    fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	  seconds+HOW_LONG_SHOW_SUB<=9 ? 
	    fprintf(file_output,"0%d",seconds+HOW_LONG_SHOW_SUB) : fprintf(file_output,"%d",seconds+HOW_LONG_SHOW_SUB);	 
	  
	  fprintf(file_output,".00\n");
	  
	  
	  while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	    if(c=='|')
	      fprintf(file_output,"[BR]");
	    else
	      fprintf(file_output,"%c",c);
	  
	  fprintf(file_output,"\n\n");
	}
      else
	{
	  while ((fscanf(file_input,"%c",&c))!=EOF);
	}
      
    }

  fclose(file_input);
  fclose(file_output);
  return 0;
}
















int subviewer2_to_time(char *input_filename, char *output_filename)
{
  /*
    Function convert subviewer 2.0 -format subtitles to time format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than time-format, or can't read file, 
    3 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  int hours,minutes,seconds;
  
  
  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
    
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 3;
  

   
  while (((fscanf(file_input,"%c",&c)!=EOF))&&(c=='['))
    {
      while (((fscanf(file_input,"%c",&c)!=EOF))&&(c!='\n'));
    }
    
  fseek(file_input,-1,SEEK_CUR);
  
  
  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {
      
      
      if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      
      while((fscanf(file_input,"%c",&c)!=EOF)&&(c!='\n'));
       
      
      
      
      hours<=9 ? 
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ? 
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d:",seconds) : fprintf(file_output,"%d:",seconds);	 
      


          while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 if(c=='[')
	   {
	     fscanf(file_input,"%c",&c);
	     if(c=='\n')
	       {
		 fprintf(file_output,"[");
		 break;
	       }
	     if((c=='B')||(c=='b'))
	       {
		 if((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
		   {
		     if((c=='R')||(c=='r'))
		       {
			 fscanf(file_input,"%c",&c);
			 if(c=='\n')
			   {
			     fprintf(file_output,"[BR");
			     break;
			   }
			 if(c==']')
			   fprintf(file_output,"|");
			 else
			   fscanf(file_input,"[BR%c",&c);
		       }
		     else
		       fprintf(file_output,"[B%c",c);
		   }
		 else
		   {
		     fprintf(file_output,"[B");
		     break;
		   }
	       }
	     else
	       fprintf(file_output,"%c",c);
	   }
	 else
	   fprintf(file_output,"%c",c);
       }

     
      	   fprintf(file_output,"\n"); 
     
    }
 
  fprintf(file_output,"00:00:00:");
  
  fclose(file_input);
  fclose(file_output);
  return 0;
}

























int subviewer2_to_subrip(char *input_filename, char *output_filename)
{
  /*
    Function convert subviewer 2.0 -format subtitles to subrip format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than time-format, or can't read file, 
    3 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  int hours,minutes,seconds,rest,i=1;
  
  
  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
    
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 3;
  

   
  while (((fscanf(file_input,"%c",&c)!=EOF))&&(c=='['))
    {
      while (((fscanf(file_input,"%c",&c)!=EOF))&&(c!='\n'));
    }
    
  fseek(file_input,-1,SEEK_CUR);
  
  
  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {
      
      
      if((fscanf(file_input,"%c%d%c%d%c%d%c",&c,&minutes,&c,&seconds,&c,&rest,&c))!=7)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      
      
                  
      
      hours<=9 ? 
	fprintf(file_output,"%d\n0%d:",i++,hours) :  fprintf(file_output,"%d\n%d:",i++,hours);
      minutes<=9 ? 
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d,",seconds) : fprintf(file_output,"%d,",seconds);	 

      rest<=9 ? 
	 fprintf(file_output,"0%d0 --> ",rest) : fprintf(file_output,"%d0 --> ",rest);	 
      

      

      if((fscanf(file_input,"%d%c%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds,&c,&rest))!=7)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      
      hours<=9 ? 
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ? 
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d,",seconds) : fprintf(file_output,"%d,",seconds);	 
      
      rest<=9 ? 
	fprintf(file_output,"0%d0\n",rest) : fprintf(file_output,"%d0\n",rest);	 
      
      
      while((fscanf(file_input,"%c",&c)!=EOF)&&(c!='\n'));



     
      while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 if(c=='[')
	   {
	     fscanf(file_input,"%c",&c);
	     if(c=='\n')
	       {
		 fprintf(file_output,"[");
		 break;
	       }
	     if((c=='B')||(c=='b'))
	       {
		 if((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
		   {
		     if((c=='R')||(c=='r'))
		       {
			 fscanf(file_input,"%c",&c);
			 if(c=='\n')
			   {
			     fprintf(file_output,"[BR");
			     break;
			   }
			 if(c==']')
			   fprintf(file_output,"\n");
			 else
			   fscanf(file_input,"[BR%c",&c);
		       }
		     else
		       fprintf(file_output,"[B%c",c);
		   }
		 else
		   {
		     fprintf(file_output,"[B");
		     break;
		   }
	       }
	     else
	       fprintf(file_output,"%c",c);
	   }
	 else
	   fprintf(file_output,"%c",c);
       }

      fprintf(file_output,"\n\n");
      
      
    }

  
  fclose(file_input);
  fclose(file_output);
  return 0;
}









int time_to_subrip(char *input_filename, char *output_filename)
{
 /*
    Function convert time-format subtitles to subrip format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than time-format, or can't read file, 
    4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  int hours,minutes,seconds,first=1;
  long i=1;
     

  if((file_input=fopen(input_filename,"r"))==NULL)
        return 1;
  
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;

   
  

  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {

      if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  fclose(file_input);
	  fclose(file_output);
	  return 2;
	}


      if((hours!=0)||(minutes!=0)||(seconds!=0)||(first==1))
	{
	  if(fscanf(file_input,"%c",&c)!=1)
	    {
	      fclose(file_input);
	      fclose(file_output);
	      return 2;
	    }
	  
	  if((hours!=0)||(minutes!=0)||(seconds!=0))
	    first=0;
 
	  hours<=9 ? 
	    fprintf(file_output,"%ld\n0%d:",i++,hours) :  fprintf(file_output,"%ld\n%d:",i++,hours);
	  minutes<=9 ? 
	    fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	  seconds<=9 ? 
	    fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 

	  
	  fprintf(file_output,".000 --> ");
	  

	  hours<=9 ? 
	    fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
	  minutes<=9 ? 
	    fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	  seconds+HOW_LONG_SHOW_SUB<=9 ? 
	    fprintf(file_output,"0%d",seconds+HOW_LONG_SHOW_SUB) : fprintf(file_output,"%d",seconds+HOW_LONG_SHOW_SUB);	 
	  
	  fprintf(file_output,".000\n");
	  
	  
	  
	  while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	    if(c=='|')
	      fprintf(file_output,"\n");
	    else
	      fprintf(file_output,"%c",c);
	  
	  fprintf(file_output,"\n\n");
	}
       else
	{
	  while ((fscanf(file_input,"%c",&c))!=EOF);
	}
    }

  fclose(file_input);
  fclose(file_output);
  return 0;
}
  
















int subrip_to_time(char *input_filename, char *output_filename)
{
 /*
    Function convert srt-format subtitles to time format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than time-format, or can't read file, 
    4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  int hours,minutes,seconds,first;
     

  if((file_input=fopen(input_filename,"r"))==NULL)
        return 1;
  
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;

   
  

  while ((fscanf(file_input,"%c",&c))!=EOF)
    {
      while ((c!='\n')&&(fscanf(file_input,"%c",&c)==1));
      
      if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_input);
	  fclose(file_output);
	  return 2;
	}
      
      
 
	  hours<=9 ? 
	    fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
	  minutes<=9 ? 
	    fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	  seconds<=9 ? 
	    fprintf(file_output,"0%d:",seconds) : fprintf(file_output,"%d:",seconds);	 
	  
	  while ((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
	  
	  first=1;
	  while((fscanf(file_input,"%c",&c)==1)&&(c!='\n')&&(c!=13))
	    {

	      if (first==0)
		fprintf(file_output," | ");
	      
	      fprintf(file_output,"%c",c);

	      while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
		if(c!=13) /*end of line in dos, in linux is only new line*/
		  fprintf(file_output,"%c",c);
	      
	      first=0;
	    }
	  
	  
	    while ((c!='\n')&&(fscanf(file_input,"%c",&c)==1));

	
	  fprintf(file_output,"\n");
    }


fprintf(file_output,"00:00:00:");

  fclose(file_input);
  fclose(file_output);
  return 0;
}






int subrip_to_subviewer2(char *input_filename, char *output_filename)
{
 /*
    Function convert subrip-format subtitles to subviewer format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than subrip-format, or can't read file, 
    4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  int hours,minutes,seconds,rest,first;
     

  if((file_input=fopen(input_filename,"r"))==NULL)
        return 1;
  
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;

   
  fprintf(file_output,"[INFORMATION]\n");
  fprintf(file_output,"[AUTHOR]\n");
  fprintf(file_output,"[SOURCE]\n");
  fprintf(file_output,"[PRG]\n");
  fprintf(file_output,"[FILEPATH]\n");
  fprintf(file_output,"[DELAY]\n");
  fprintf(file_output,"[CD TRACK]\n");
  fprintf(file_output,"[COMMENT] edited by GTKsubtitler <www.gtksubtitler.prv.pl>\n");
  fprintf(file_output,"[END INFORMATION]\n");
  fprintf(file_output,"[SUBTITLE]\n");
  fprintf(file_output,"[COLF]&HFFFFFF,[STYLE]bd,[SIZE]18,[FONT]Arial\n");
  

  while ((fscanf(file_input,"%c",&c))!=EOF)
    {
      while ((c!='\n')&&(fscanf(file_input,"%c",&c)==1));
      
      if((fscanf(file_input,"%d%c%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds,&c,&rest))!=7)
	{
	  fclose(file_input);
	  fclose(file_output);
	  return 2;
	}
      
      
 
	  hours<=9 ? 
	    fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
	  minutes<=9 ? 
	    fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	  seconds<=9 ? 
	    fprintf(file_output,"0%d.",seconds) : fprintf(file_output,"%d.",seconds);	 
	  
	  if (rest>=100)
	    rest/=10;
	  
	  rest<=9 ?
	    fprintf(file_output,"0%d,",rest) : fprintf(file_output,"%d,",rest);	 
	  
	  while ((fscanf(file_input,"%c",&c)==1)&&(c!='>'));
	  fscanf(file_input,"%c",&c);


	  if((fscanf(file_input,"%d%c%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds,&c,&rest))!=7)
	    {
	      fclose(file_input);
	      fclose(file_output);
	      return 2;
	    }
	  

hours<=9 ? 
	    fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
	  minutes<=9 ? 
	    fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	  seconds<=9 ? 
	    fprintf(file_output,"0%d.",seconds) : fprintf(file_output,"%d.",seconds);	 
	  if (rest>=100)
	     rest/=10;
	  rest<=9 ?
	    fprintf(file_output,"0%d\n",rest) : fprintf(file_output,"%d\n",rest);	 
	  

	  while ((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
	  
	  first=1;
	  while((fscanf(file_input,"%c",&c)==1)&&(c!='\n')&&(c!=13))
	    {
	      if (first==0)
		fprintf(file_output," [BR] ");

	      fprintf(file_output,"%c",c);	      

	      while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
		if(c!=13) {/*end of line in dos, in linux is only new line*/
		if(c=='|')
		  fprintf(file_output,"[BR]");
		else
		    fprintf(file_output,"%c",c);
	      }
	      first=0;
	    }
	  
	  
	    while ((c!='\n')&&(fscanf(file_input,"%c",&c)==1));
	    
	
	  fprintf(file_output,"\n\n");
    }




  fclose(file_input);
  fclose(file_output);
  return 0;
}








int time_to_mpsub(char *input_filename, char *output_filename)
{
 /*
    Function convert time - format  subtitles to mpsub format. 
    It returns 0 when everything is OK, 1 when can't read input file, 
    2 when file format is diffrent than time-format, or can't read file, 
    3 when function  can't move subititles so far(out of range), 
    4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  long sume=0,last_sume=0;
  int hours,minutes,seconds;
 
  
  

  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
  
  
  if((file_output=fopen(output_filename,"w"))==NULL) 
    return 4;
  
  
  last_sume=0;
  
  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {

      if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}      
      



      sume=((hours*SEC_IN_HOUR)+(minutes*SEC_IN_MIN)+seconds);
      
      if ((last_sume==0)||(sume!=0))
	{

	  if((fscanf(file_input,"%c",&c))!=1)
	    {
	      fclose(file_output);
	      fclose(file_input);
	      return 2;
	    } 

	  if ((last_sume+(HOW_LONG_SHOW_SUB))>sume)
	    fprintf(file_output,"0 %d\n",HOW_LONG_SHOW_SUB);
	  else
	    fprintf(file_output,"%ld %d\n",sume-last_sume,HOW_LONG_SHOW_SUB);
	  
	  
	  while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	    {
	      if(c!=13 && c!=9 && c!='|') 
		fprintf(file_output,"%c",c);
	      if (c=='|')
		fprintf(file_output,"\n");
	    }
	  
	  fprintf(file_output,"\n\n");
	  last_sume=(sume+HOW_LONG_SHOW_SUB);
	}
      else
	{
	  while ((fscanf(file_input,"%c",&c))!=EOF);
	}
      
   
    }
  
  
  

  
  
  
  fclose(file_input);
  fclose(file_output);
  
  return 0;
}








int mpsub_to_time(char *input_filename, char *output_filename)
{
  /*
    Function converts mpsub-format to time format file. 
    It returns 0 when everything is OK, 1 when can't
    read input file, 2 when file format is diffrent than time-format, or 
    can't read file, , 4 when can't open file to write
  */

  FILE *file_input,*file_output;
  char c;
  float sume=0,tmp3,time,how_long;
  int hours,seconds,minutes,first;
  long akt_sume,tmp1;
  
  if((file_input=fopen(input_filename,"r"))==NULL)
    return 1;
    
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 4;
  
  /* skip intro:) */

  while (fscanf(file_input,"%c",&c)!=EOF && c!='0' && c!='1' && c!='2' && c!='3' && c!='4' && c!='5' && c!='6' && c!='7' && c!='8' && c!='9')
    {
      while ((c!='\n')&&((fscanf(file_input,"%c",&c)!=EOF)));
    }
    
    
  fseek(file_input,-1,SEEK_CUR);

  /*************/

 
  sume=0;


  while ((fscanf(file_input,"%ld",&tmp1))!=EOF)
    {
      if((fscanf(file_input,"%c",&c))!=1)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      if(c=='.' || c==',')
	{
	if((fscanf(file_input,"%f",&tmp3))!=1)
	  {
	    fclose(file_output);
	    fclose(file_input);
	    return 2;
	  }

	while(tmp3>=10)
	  tmp3/=10;
	
	time=(float)tmp1;
	time+=(float)(tmp3/10);

	if((fscanf(file_input,"%c",&c))!=1)
	  {
	    fclose(file_output);
	    fclose(file_input);
	    return 2;
       }
	
	}
      else
	time=(float)tmp1;

      


     if((fscanf(file_input,"%ld",&tmp1))!=1)
       {
	 fclose(file_output);
	 fclose(file_input);
	 return 2;
       }
     
     if((fscanf(file_input,"%c",&c))!=1)
       {
	 fclose(file_output);
	 fclose(file_input);
	 return 2;
       }
      
      if(c=='.' || c==',')
	{
	if((fscanf(file_input,"%f",&tmp3))!=1)
	  {
	    fclose(file_output);
	    fclose(file_input);
	    return 2;
	  }

	while(tmp3>=10)
	  tmp3/=10;
	
	how_long=(float)tmp1;
	how_long+=(tmp3/10);
	
	}
      else
	how_long=(float)tmp1;
      
      
      
      sume+=time;
      
      akt_sume=sume;

      hours=akt_sume/SEC_IN_HOUR;
      akt_sume%=SEC_IN_HOUR;
      minutes=akt_sume/SEC_IN_MIN;
      akt_sume%=SEC_IN_MIN;
      seconds=akt_sume;
      
      hours<=9 ? 
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ? 
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d:",seconds) : fprintf(file_output,"%d:",seconds);	 
      
      sume+=how_long;
      
      while((c!='\n')&&(fscanf(file_input,"%c",&c)==1));
      
      
      first=0;
      while((fscanf(file_input,"%c",&c)==1)&&(c!='\n')&&(c!=13))
	{
	  if(first!=0)
	    fprintf(file_output,"|");
	  else
	    first=1;
	  
	  fprintf(file_output,"%c",c);
	  
	  while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	    {
	      
	      if (c!=13 && c!=9)
		fprintf(file_output,"%c",c);
	    }
	  
	}
      fprintf(file_output,"\n");
      
      
      
      if(c!='\n')
	while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
      
      	 
    }
  fprintf(file_output,"00:00:00:");
  
  fclose(file_input);
  fclose(file_output);
  return 0;
}












int merge_time(char *input_filename1,char  *input_filename2,  char *output_filename)
{
/*
Function returns 1 when can't open first input file, 2 when can't open second input file, 3 when can't read first input file 4 when can't read second input file, 5 when can't open input file to write, 6 when can't move subtitles in second file (out of range)

*/

  FILE *file_input,*file_output;
  char c;
  int hours,seconds,minutes,first=0,last_hours=0,last_minutes=0,last_seconds=0;
  long akt_sume,sume;
  

  if((file_input=fopen(input_filename1,"r"))==NULL)
     return 1;
    

  if((file_output=fopen(output_filename,"w"))==NULL)
     return 5;


 while ((fscanf(file_input,"%d",&hours))!=EOF)
    {

      if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 3;
	}

    
      
      if((hours!=0)||(minutes!=0)||(seconds!=0))
	first=1;
      
      
      if((hours==0)&&(minutes==0)&&(seconds==0)&&(first=1))
	break;
      
     
     hours<=9 ? 
       fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
     minutes<=9 ? 
       fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
     seconds<=9 ? 
       fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
     
         
 
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       fprintf(file_output,"%c",c);
     
     fprintf(file_output,"%c",c);
     
     
     last_hours=hours;
     last_minutes=minutes;
     last_seconds=seconds;
     
    }
 
 fclose(file_input);
 
 if((file_input=fopen(input_filename2,"r"))==NULL)
   return 2;
 
 

 akt_sume=last_hours*SEC_IN_HOUR+last_minutes*SEC_IN_MIN+last_seconds;
 
 
 while ((fscanf(file_input,"%d",&hours))!=EOF)
   {
     
     if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
       {
	 fclose(file_output);
	 fclose(file_input);
	 return 4;
       }
     hours+=last_hours;
     minutes+=last_minutes;
     seconds+=last_seconds;
     
     sume=(hours+last_hours)*SEC_IN_HOUR+(minutes+last_minutes)*SEC_IN_MIN+(seconds+last_seconds);
	   
     if((sume>=0)&&(sume<=99*SEC_IN_HOUR+59*SEC_IN_MIN+59))
       {
	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	  
	    if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
	      {
		fclose(file_output);
		fclose(file_input);
		return 6;
	      }
	    
	    
	    sume+=akt_sume;
	   }
       }  
     else
       {
	 fclose(file_output);
	 fclose(file_input);
	 return 6;
       }
     
     hours<=9 ? 
       fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
     minutes<=9 ? 
       fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
     seconds<=9 ? 
       fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
	
	 
      
     
	 
     while((c!='\n')&&(fscanf(file_input,"%c",&c)==1))
       if (c!=13 && c!=9) /*end of line in dos*/
	 fprintf(file_output,"%c",c);
	      
     
   }
 



 
      
    
 
 fclose(file_input);
 fclose(file_output); 
 return 0;
}

   
















int merge_microdvd(char *input_filename1,char  *input_filename2, char *output_filename,float frames_in_sec)
{
  /*
Function returns 1 when can't open first input file, 2 when can't open second input file, 3 when can't read first input file, 4 when can't read second input file, 5 when can't open input file to write, 6 can't move subtitles so far in second file (out of range)

  */

  FILE *file_input,*file_output;
  char c;
  long frames_begin,frames_end,sume,plus;
  int hours,minutes,seconds;
  
  if((file_input=fopen(input_filename1,"r"))==NULL)
    return 1;
    
  

  if((file_output=fopen(output_filename,"w"))==NULL)
     return 5;


  
  while ((fscanf(file_input,"%c",&c))!=EOF)
    {
      
      while(c!='{')
	{
	  if((fscanf(file_input,"%c%ld%c%c%ld",&c,&frames_begin,&c,&c,&frames_end))!=5)
	    {
	      fclose(file_input);
	      fclose(file_output);
	      return 3;
	    }
	}
      
    
     
     
     fprintf(file_output,"{%ld}{%ld",frames_begin,frames_end);
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c",c);
    }
  sume=frames_end/frames_in_sec;
  hours=sume/SEC_IN_HOUR;
  sume-=hours*SEC_IN_HOUR;
  minutes=sume/SEC_IN_MIN;
  sume-=minutes*SEC_IN_MIN;
  seconds=sume;


   
  fclose(file_input);
  if((file_input=fopen(input_filename2,"r"))==NULL)
    return 2;
  

  plus=(hours*SEC_IN_HOUR*frames_in_sec) + (minutes*SEC_IN_MIN*frames_in_sec) + (seconds*frames_in_sec);

  while ((fscanf(file_input,"%c",&c))!=EOF)
    {
       
      while(c!='{')
	{
	  if((fscanf(file_input,"%c",&c))!=1)
	    {
	      fclose(file_output);
	      fclose(file_input);
	      return 4;
	    }
	}
     
      
      if((fscanf(file_input,"%ld%c%c%ld",&frames_begin,&c,&c,&frames_end))!=4)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 4;
	}
      
      
      sume=frames_begin/frames_in_sec;
      
      
      if((sume>=0)&&(sume<99*SEC_IN_HOUR+59*SEC_IN_MIN+59))
	{

	      frames_begin+=plus;
	      frames_end+=plus;
	  
	  
	  if ((frames_begin<0)||(frames_end<0)||(frames_end>=(99*SEC_IN_HOUR+59*SEC_IN_MIN+59)*frames_in_sec))
	   {
	     fclose(file_output);
	     fclose(file_input);
	     return 6;
	   }
	  
	}
      else
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 6;
	}

      fprintf(file_output,"{%ld}{%ld",frames_begin,frames_end);
      
	 
     while((c!='\n')&&(fscanf(file_input,"%c",&c)==1))
       if (c!=13) /*end of line in dos*/
	 fprintf(file_output,"%c",c);
       

    }


  
  fclose(file_input);
  fclose(file_output);
  return 0;
  

}















int merge_subviewer2(char *input_filename1, char *input_filename2,  char *output_filename)
{
/*
Function returns 1 when can't open first input file, 2 when cant open second input file, 3 when can't read first input file 4 when can't read second input file , 5 when can't open input file to write
*/

  FILE *file_input,*file_output;
  char c;
  int hours,seconds,minutes,first=0;
  long sume,akt_sume;
  


  if((file_input=fopen(input_filename1,"r"))==NULL)
     return 1;
    

  if((file_output=fopen(output_filename,"w"))==NULL)
     return 5;


  
  while (((fscanf(file_input,"%c",&c)!=EOF))&&(c=='['))
    {
      fprintf(file_output,"%c",c);
      while (((fscanf(file_input,"%c",&c)!=EOF))&&(c!='\n'))
	fprintf(file_output,"%c",c);
      fprintf(file_output,"%c",c);
    }
  
  fseek(file_input,-1,SEEK_CUR);


  while ((fscanf(file_input,"%d",&hours))!=EOF)
    {
      if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
      
      hours<=9 ?    
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ?
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);
	 
      
      
      
	 while((fscanf(file_input,"%c",&c)!=EOF)&&(c!=','))
	   fprintf(file_output,"%c",c);
	 
	 fprintf(file_output,"%c",c);
	 
	 
	 
      if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
     
      
      hours<=9 ?    
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ?
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);
      
      
      
     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c",c);

     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c\n",c);
     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
  

    }



    fclose(file_input);


    if((file_input=fopen(input_filename1,"r"))==NULL)
      return 2;
    
    


    while (((fscanf(file_input,"%c",&c)!=EOF))&&(c=='['))
      {
	while (((fscanf(file_input,"%c",&c)!=EOF))&&(c!='\n'));
      }
  
  


    
    fseek(file_input,-1,SEEK_CUR);
    
    
    akt_sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
    
    
    while ((fscanf(file_input,"%d",&hours))!=EOF)
      {
	
            
	if((fscanf(file_input,"%c%d%c%d",&c,&minutes,&c,&seconds))!=4)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      


   

     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
     
     if((sume>=0)&&(sume<=99*SEC_IN_HOUR+59*SEC_IN_MIN+59))
       {
	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	    if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
	      {
		fclose(file_output);
		fclose(file_input);
		return 3;
	      }
	    
	    
	    sume+=akt_sume;
	    
	    hours=sume/SEC_IN_HOUR;
	    sume-=hours*SEC_IN_HOUR;
	    minutes=sume/SEC_IN_MIN;
	    sume-=minutes*SEC_IN_MIN;
	    seconds=sume;
	   }
	 
       }
     
     	   hours<=9 ?    
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ?
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);
      
	 
      
     

	 while((fscanf(file_input,"%c",&c)!=EOF)&&(c!=','))
	   fprintf(file_output,"%c",c);
	   
	 fprintf(file_output,"%c",c);




      if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 2;
	}
      
     

     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
	   
     if((sume>=0)&&(sume<=99*SEC_IN_HOUR+59*SEC_IN_MIN+59))
       {
	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	    if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
	      {
		fclose(file_output);
		fclose(file_input);
		return 3;
	      }
	    
	    
	    sume+=akt_sume;
	    
	    hours=sume/SEC_IN_HOUR;
	    sume-=hours*SEC_IN_HOUR;
	    minutes=sume/SEC_IN_MIN;
	    sume-=minutes*SEC_IN_MIN;
	    seconds=sume;
	   }
	 
       }
     
     	 
	  hours<=9 ?    
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ?
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);
      



     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c",c);

     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c\n",c);
     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
  

    }
 
    
 fclose(file_input);
 fclose(file_output);
 return 0;



}





















int merge_subrip(char *input_filename1,char *input_filename2, char *output_filename)
{
 /*
Function returns 1 when can't open first input file, 2 when cant open second input file, 3 when can't read first input file 4 when can't read second input file , 5 when can't open output file to write, 6 out of range - cant move subtitles so far;
*/

  FILE *file_input,*file_output;
  char c,tmp;
  long sume=0,akt_sume=0,i=1;
  int hours,minutes,seconds,first=0,temp_int;
  
  
  if((file_input=fopen(input_filename1,"r"))==NULL)
    return 1;
    
  
  if((file_output=fopen(output_filename,"w"))==NULL)
    return 5;
  

 

  while ((fscanf(file_input,"%d",&temp_int))!=EOF)
    {
      i++;
      if(fprintf(file_output,"%d\n",temp_int)==0)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 5;
	}
      
      if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 3;
	}
      
        hours<=9 ? 
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ? 
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
	 
          
      while((fscanf(file_input,"%c",&tmp)!=EOF)&&(fprintf(file_output,"%c",tmp))&&(tmp!='>'));
      
      if(fscanf(file_input,"%c",&tmp)!=EOF)
	{
	  fprintf(file_output,"%c",tmp);
	}
      else
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 3;
	}
      
      
      
      if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 3;
	}
      
      hours<=9 ? 
	fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
      minutes<=9 ? 
	fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
      seconds<=9 ? 
	fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
      
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c",c);

     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n')&&(c!=13))
       {
	 fprintf(file_output,"%c",c);
	 while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	   {
	     fprintf(file_output,"%c",c);
	   }
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"\n");

       
       if(c!='\n')
	 while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
  

    }
  
  fclose(file_input);
  if((file_input=fopen(input_filename2,"r"))==NULL)
    return 2; 
  
  akt_sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
  

  while ((fscanf(file_input,"%d",&temp_int))!=EOF)
    {
      if(fprintf(file_output,"%ld\n",i++)==0)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 5;
	}
      
      if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	{
	  fclose(file_output);
	  fclose(file_input);
	  return 4;
	}
      
   
     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
	   

	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	 
	    if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
	      {
		fclose(file_output);
		fclose(file_input);
		return 6;
	      }
		   
	    sume+=akt_sume;
	    
	    hours=sume/SEC_IN_HOUR;
	    sume-=hours*SEC_IN_HOUR;
	    minutes=sume/SEC_IN_MIN;
	    sume-=minutes*SEC_IN_MIN;
	    seconds=sume;
	   }
	        
         hours<=9 ? 
	   fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
	 minutes<=9 ? 
	   fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	 seconds<=9 ? 
	   fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 
	 
     

	 while((fscanf(file_input,"%c",&tmp)!=EOF)&&(tmp!='>'))
	   fprintf(file_output,"%c",tmp);
	   
	 fprintf(file_output,"%c",tmp);


	 if(fscanf(file_input,"%c",&tmp)!=EOF)
	   {
	     fprintf(file_output,"%c",tmp);
	   }
	 else
	   {
	     fclose(file_output);
	     fclose(file_input);
	     return 4;
	   }



	 if((fscanf(file_input,"%d%c%d%c%d",&hours,&c,&minutes,&c,&seconds))!=5)
	   {
	     fclose(file_output);
	     fclose(file_input);
	     return 4;
	   }


     sume=hours*SEC_IN_HOUR+minutes*SEC_IN_MIN+seconds;
	   

	 if ((sume!=0)||(first==0))
	   {
	    if (sume!=0)
	        first=1;
		
	 
	    if(sume+akt_sume>99*SEC_IN_HOUR+59*SEC_IN_MIN+59)
	      {
		fclose(file_output);
		fclose(file_input);
		return 6;
	      }
		   
		   
	    sume+=akt_sume;
	    
	    hours=sume/SEC_IN_HOUR;
	    sume-=hours*SEC_IN_HOUR;
	    minutes=sume/SEC_IN_MIN;
	    sume-=minutes*SEC_IN_MIN;
	    seconds=sume;
	   }
	 
         hours<=9 ? 
	   fprintf(file_output,"0%d:",hours) :  fprintf(file_output,"%d:",hours);
	 minutes<=9 ? 
	   fprintf(file_output,"0%d:",minutes) : fprintf(file_output,"%d:",minutes);
	 seconds<=9 ? 
	   fprintf(file_output,"0%d",seconds) : fprintf(file_output,"%d",seconds);	 



     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
       {
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"%c",c);

     
     
     while((fscanf(file_input,"%c",&c)==1)&&(c!='\n')&&(c!=13))
       {
	 fprintf(file_output,"%c",c);
	 while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'))
	   {
	     fprintf(file_output,"%c",c);
	   }
	 fprintf(file_output,"%c",c);
       }
     fprintf(file_output,"\n");

       
       if(c!='\n')
	 while((fscanf(file_input,"%c",&c)==1)&&(c!='\n'));
  

    }


 
 fclose(file_input);
 fclose(file_output);
 return 0;
}









int merge_mpsub(char *input_filename1,char  *input_filename2,  char *output_filename)
{
/*
Function returns 1 when can't open first input file, 2 when can't open second input file, 3 when can't read first input file 4 when can't read second input file, 5 when can't open input file to write, 6 when can't move subtitles in second file (out of range)

*/

  FILE *file_input,*file_output;
  char c;
  

  if((file_input=fopen(input_filename1,"r"))==NULL)
     return 1;
    

  if((file_output=fopen(output_filename,"w"))==NULL)
     return 5;


  while ((fscanf(file_input,"%c",&c))!=EOF)
    {
      fprintf(file_output,"%c",c);
    }
  
 fclose(file_input);


 
 
 if((file_input=fopen(input_filename2,"r"))==NULL)
   return 2;
 
 

  while (fscanf(file_input,"%c",&c)!=EOF && c!='0' && c!='1' && c!='2' && c!='3' && c!='4' && c!='5' && c!='6' && c!='7' && c!='8' && c!='9')
    {
      while ((c!='\n')&&((fscanf(file_input,"%c",&c)!=EOF)));
    }
    
  
  fseek(file_input,-1,SEEK_CUR);

  /*************/

   fprintf(file_output,"\n");

  
  while ((fscanf(file_input,"%c",&c))!=EOF)
    {
      fprintf(file_output,"%c",c);
    }
  
 
      
    
 
 fclose(file_input);
 fclose(file_output); 
 return 0;
}

   
