#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"


gchar GTKSUBTITLER_VERSION[]="--===[ GTKsubtitler v0.2.4 ]===--";

gchar E_OPEN[MAX_E]="Open";
gchar E_OPEN_DESC[MAX_E_DESC]="Open file";
gchar E_SAVE[MAX_E]="Save";
gchar E_SAVE_DESC[MAX_E_DESC]="Save file";
gchar E_SAVE_AS[MAX_E]=" Save As";
gchar E_SAVE_AS_DESC[MAX_E_DESC]="Save file As";
gchar E_FILE[MAX_E]="File";
gchar E_MOVE_ALL[MAX_E]="Move all";
gchar E_MOVE_ALL_DESC[MAX_E_DESC]="Move all subtitles";
gchar E_MOVE_PARTLY[MAX_E]="Move partly";
gchar E_MOVE_PARTLY_DESC[MAX_E_DESC]="Move from <point> to <point>";
gchar E_CHANGE_FORMAT[MAX_E]="Change format";
gchar E_CHANGE_FORMAT_DESC[MAX_E_DESC]="Change format of file";
gchar E_MERGE[MAX_E]="Merge 2 sub files";
gchar E_MERGE_DESC[MAX_E_DESC]="Merge two sub files into one";
gchar E_CONVERT_ISO_1[MAX_E]="Convert to iso-8859-1";
gchar E_CONVERT_ISO_1_DESC[MAX_E_DESC]="Convert from windows iso format";
gchar E_CONVERT_ISO_2[MAX_E]="Convert to iso-8859-2";
gchar E_CONVERT_ISO_2_DESC[MAX_E_DESC]="Convert from windows iso format";
gchar E_EXIT[MAX_E]="Exit";
gchar E_EXIT_DESC[MAX_E_DESC]="Exit program";
gchar E_SETTINGS[MAX_E]="Settings";
gchar E_HELP[MAX_E]="Help";
gchar E_ABOUT[MAX_E]="About";
gchar E_EDIT[MAX_E]="Edit";
gchar E_QUIT[MAX_E]="Quit";
gchar E_MOVE_FROM[MAX_E]="Move from:";
gchar E_MOVE_TO[MAX_E]="Move to:";
gchar E_DELETE[MAX_E]="Delete";
gchar E_CHANGE[MAX_E]="Change";
gchar E_INSERT[MAX_E]="Insert";
gchar E_FAQ[MAX_E]="Faq";
gchar E_TIME_FRAMES[MAX_E]="Time / Frames";
gchar E_SUBTITLE[MAX_E]="Subtitle";
gchar E_CHOOSE_FILE[MAX_E]="Choose file:";
gchar E_CHOOSE_FORMAT[MAX_E]="Choose format";
gchar E_FILE_ACCESS[MAX_E]="File Access:";
gchar E_GENERAL[MAX_E]="General";
gchar E_LANG[MAX_E]="Lang";
gchar E_LANG_DIR[MAX_E]="Lang dir:";
gchar E_TEMP_DIR[MAX_E]="Temporary dir:";
gchar E_HOW_MANY_HOURS[MAX_E_DESC]="How may hours move subtitles?";
gchar E_HOW_MANY_MIN[MAX_E_DESC]="How may minutes move subtitles?";
gchar E_HOW_MANY_SEC[MAX_E_DESC]="How may seconds move subtitles?";
gchar E_WHAT_DIRECTION[MAX_E_DESC]="In what direction move subtitles:";
gchar E_HOUR_MINUTE_SECOND[MAX_E_DESC]="HOUR  :  MINUTE  :  SECOND";
gchar E_FRAME_MICRODVD[MAX_E]="Frame (Microdvd)";
gchar E_FROM[MAX_E]="From:";
gchar E_TO[MAX_E]="To:";
gchar E_TIME[MAX_E]="Time:";
gchar E_PROPERTIES[MAX_E]="Properties:";
gchar E_PREFERENCES[MAX_E]="Preferences";
gchar E_PREFERENCES_WINDOW[MAX_E]="Preferences:";
gchar E_FRAMES_IN_ONE_SEC[MAX_E_DESC]="ONLY IN MICRODVD FORMAT            How many frames is in \none second of film?";
gchar E_INFORMATION[MAX_E]="Information";
gchar E_MOVE_FROM_POINT_TO_POINT[MAX_E_DESC]="Move from <point> to <point>";

gchar E_TEXT_ABOUT[MAX_E_TEXT]="GTKsubtitler is a small program for editing and converting subtitles for DivX films. It is written in C and GTK with small help of glade. \n It supports five formats of subtitles:\n*) Microdvd format\n*) Time format\n*) SubRip format\n*) SubViewer 2.0\n*) MPsub\nFor details please see www.gtksubtitler.prv.pl\n\nWith GTKsubtitler you can move your subtitles forward and backward, convert from windows (pseudo iso-8859-2) format to iso-8859-1/2 , change format of you sub-file. You can also merge 2 and more files into 1.\n\n";

gchar E_TEXT_FAQ[MAX_E_TEXT]="Where is the latest version of GTKsubtitler?\nwww.gtksubtitler.prv.pl - on this page you will find the latest stable and current vesions of program, you can also jump to www.freshmeat.net/gtksubtitler.\n\nProgram crashes or I found bug.\nPlease get the latest version of program from cvs.pld.org.pl (or www.gtksubtitler.prv.pl - only stable versions) and test it, if program still have bug please send me mail with full description of bug .\n";




void set_lang_interface(char *filename)
{
  gchar bufor[MAX_E];
  gchar buf_txt[MAX_E_TEXT];
  gchar c;
  gint i;
  FILE *input_file;

  if((input_file=fopen(filename,"r"))==NULL)
    return;


  if(fscanf(input_file,"%c",&c)!=EOF)
    {
      while(c!='@')
	if(fscanf(input_file,"%c",&c)==EOF)
	  {fclose(input_file); return;}



      while(c!='\n')
	if(fscanf(input_file,"%c",&c)==EOF)
	  {fclose(input_file); return;}
    }



  while(fscanf(input_file,"%c",&bufor[0])!=EOF)
    {
      if (bufor[0]=='[')
	{


	  i=1;
	  while(fscanf(input_file,"%c",&bufor[i])!=EOF && bufor[i++]!='\n')	;
	  bufor[--i]=0;


	  i=0;

	  while(fscanf(input_file,"%c",&buf_txt[i])!=EOF)
	    if(buf_txt[i]=='\n')
	      {
		if(fscanf(input_file,"%c",&buf_txt[++i])!=EOF && buf_txt[i]!='\n' && buf_txt[i]!=' ')
		  {
		    if(buf_txt[i]=='|')
		      buf_txt[i]='\n';
		    i++;
		  }
		else
		  break;
	      }
	    else
	      {
		if(buf_txt[i]=='|')
		  buf_txt[i]='\n';
	      i++;
	      }

	  buf_txt[i-1]=0;


	  if(strcmp(bufor,"[E_OPEN]")==0)
	    strcpy(E_OPEN,buf_txt);
	  else
	    if(strcmp(bufor,"[E_OPEN_DESC]")==0)
	      strcpy(E_OPEN_DESC,buf_txt);
	    else
	      if(strcmp(bufor,"[E_SAVE]")==0)
		strcpy(E_SAVE,buf_txt);
	      else
		if(strcmp(bufor,"[E_SAVE_DESC]")==0)
		  strcpy(E_SAVE_DESC,buf_txt);
		else
		  if(strcmp(bufor,"[E_SAVE_AS]")==0)
		    strcpy(E_SAVE_AS,buf_txt);
		  else
		if(strcmp(bufor,"[E_SAVE_AS_DESC]")==0)
		  strcpy(E_SAVE_AS_DESC,buf_txt);
		else
		if(strcmp(bufor,"[E_FILE]")==0)
		  strcpy(E_FILE,buf_txt);
		else
		  if(strcmp(bufor,"[E_MOVE_ALL]")==0)
		    strcpy(E_MOVE_ALL,buf_txt);
		  else
		    if(strcmp(bufor,"[E_MOVE_ALL_DESC]")==0)
		      strcpy(E_MOVE_ALL_DESC,buf_txt);
		    else
		      if(strcmp(bufor,"[E_MOVE_PARTLY]")==0)
			strcpy(E_MOVE_PARTLY,buf_txt);
		      else
			if(strcmp(bufor,"[E_MOVE_PARTLY_DESC]")==0)
			  strcpy(E_MOVE_PARTLY_DESC,buf_txt);
			else
			  if(strcmp(bufor,"[E_CHANGE_FORMAT]")==0)
			    strcpy(E_CHANGE_FORMAT,buf_txt);
			  else
			    if(strcmp(bufor,"[E_CHANGE_FORMAT_DESC]")==0)
			      strcpy(E_CHANGE_FORMAT_DESC,buf_txt);
			    else
			      if(strcmp(bufor,"[E_MERGE]")==0)
				strcpy(E_MERGE,buf_txt);
			      else
				if(strcmp(bufor,"[E_MERGE_DESC]")==0)
				  strcpy(E_MERGE_DESC,buf_txt);
				else
				  if(strcmp(bufor,"[E_CONVERT_ISO_1]")==0)
				    strcpy(E_CONVERT_ISO_1,buf_txt);
				  else
				    if(strcmp(bufor,"[E_CONVERT_ISO_1_DESC]")==0)
				      strcpy(E_CONVERT_ISO_1_DESC,buf_txt);
				    else
				      if(strcmp(bufor,"[E_CONVERT_ISO_2]")==0)
					strcpy(E_CONVERT_ISO_2,buf_txt);
				      else
					if(strcmp(bufor,"[E_CONVERT_ISO_2_DESC]")==0)
					  strcpy(E_CONVERT_ISO_2_DESC,buf_txt);
					else
					  if(strcmp(bufor,"[E_EXIT]")==0)
					    strcpy(E_EXIT,buf_txt);
					  else
					    if(strcmp(bufor,"[E_EXIT_DESC]")==0)
					      strcpy(E_EXIT_DESC,buf_txt);
					    else
					      if(strcmp(bufor,"[E_PREFERENCES]")==0)
						strcpy(E_PREFERENCES,buf_txt);
					      else
						if(strcmp(bufor,"[E_SETTINGS]")==0)
						  strcpy(E_SETTINGS,buf_txt);
						else
						  if(strcmp(bufor,"[E_HELP]")==0)
						    strcpy(E_HELP,buf_txt);
						  else
						    if(strcmp(bufor,"[E_ABOUT]")==0)
						      strcpy(E_ABOUT,buf_txt);
						    else
						      if(strcmp(bufor,"[E_EDIT]")==0)
							strcpy(E_EDIT,buf_txt);
						      else
							if(strcmp(bufor,"[E_QUIT]")==0)
							  strcpy(E_QUIT,buf_txt);
							else
							  if(strcmp(bufor,"[E_MOVE_FROM]")==0)
							    strcpy(E_MOVE_FROM,buf_txt);
							  else
							    if(strcmp(bufor,"[E_MOVE_TO]")==0)
							      strcpy(E_MOVE_TO,buf_txt);
							    else
							      if(strcmp(bufor,"[E_DELETE]")==0)
								strcpy(E_DELETE,buf_txt);
							      else
								if(strcmp(bufor,"[E_INSERT]")==0)
								  strcpy(E_INSERT,buf_txt);
								else
								  if(strcmp(bufor,"[E_CHANGE]")==0)
								    strcpy(E_CHANGE,buf_txt);
								  else
								    if(strcmp(bufor,"[E_FAQ]")==0)
								      strcpy(E_FAQ,buf_txt);
								    else
								      if(strcmp(bufor,"[E_TIME_FRAMES]")==0)
									  strcpy(E_TIME_FRAMES,buf_txt);
									else
									  if(strcmp(bufor,"[E_SUBTITLE]")==0)
									    strcpy(E_SUBTITLE,buf_txt);
									  else
									    if(strcmp(bufor,"[E_CHOOSE_FORMAT]")==0)
									      strcpy(E_CHOOSE_FORMAT,buf_txt);
									    else
									      if(strcmp(bufor,"[E_FILE_ACCESS]")==0)
										strcpy(E_FILE_ACCESS,buf_txt);
									      else
										if(strcmp(bufor,"[E_GENERAL]")==0)
										  strcpy(E_GENERAL,buf_txt);
										else
										  if(strcmp(bufor,"[E_LANG]")==0)
										    strcpy(E_LANG,buf_txt);
										  else
										    if(strcmp(bufor,"[E_LANG_DIR]")==0)
										      strcpy(E_LANG_DIR,buf_txt);
										    else
										      if(strcmp(bufor,"[E_TEMP_DIR]")==0)
											strcpy(E_TEMP_DIR,buf_txt);
										      else
											if(strcmp(bufor,"[E_HOW_MANY_HOURS]")==0)
											  strcpy(E_HOW_MANY_HOURS,buf_txt);
											else
											  if(strcmp(bufor,"[E_HOW_MANY_MIN]")==0)
											    strcpy(E_HOW_MANY_MIN,buf_txt);
											  else
											    if(strcmp(bufor,"[E_HOW_MANY_SEC]")==0)
											      strcpy(E_HOW_MANY_SEC,buf_txt);
											    else
											      if(strcmp(bufor,"[E_WHAT_DIRECTION]")==0)
												strcpy(E_WHAT_DIRECTION,buf_txt);
											      else
												if(strcmp(bufor,"[E_HOUR_MINUTE_SECOND]")==0)
												  strcpy(E_HOUR_MINUTE_SECOND,buf_txt);
												else
												  if(strcmp(bufor,"[E_FRAME_MICRODVD]")==0)
												    strcpy(E_FRAME_MICRODVD,buf_txt);
												  else
												    if(strcmp(bufor,"[E_FROM]")==0)
												      strcpy(E_FROM,buf_txt);
												    else
												      if(strcmp(bufor,"[E_TO]")==0)
													strcpy(E_TO,buf_txt);
												      else
													if(strcmp(bufor,"[E_FRAMES_IN_ONE_SEC]")==0)
													  strcpy(E_FRAMES_IN_ONE_SEC,buf_txt);
													else
													  if(strcmp(bufor,"[E_INFORMATION]")==0)
													    strcpy(E_INFORMATION,buf_txt);
													  else
													    if(strcmp(bufor,"[E_MOVE_FROM_POINT_TO_POINT]")==0)
													      strcpy(E_MOVE_FROM_POINT_TO_POINT,buf_txt);
													    else
													      if(strcmp(bufor,"[E_TEXT_ABOUT]")==0)
														strcpy(E_TEXT_ABOUT,buf_txt);
													      else
														if(strcmp(bufor,"[E_TEXT_FAQ]")==0)
														  strcpy(E_TEXT_FAQ,buf_txt);
														else
														
														  	if(strcmp(bufor,"[E_CHOOSE_FILE]")==0)
														    	strcpy(E_CHOOSE_FILE,buf_txt);
														    else
															  	if(strcmp(bufor,"[E_TIME]")==0)
															    	strcpy(E_TIME,buf_txt);
															    else
															  	if(strcmp(bufor,"[E_PROPERTIES]")==0)
															    	strcpy(E_PROPERTIES,buf_txt);
											    					else
															  	if(strcmp(bufor,"[E_PREFERENCES_WINDOW]")==0)
															    	strcpy(E_PREFERENCES_WINDOW,buf_txt);


	  if(buf_txt[i]!='\n')
	    while(fscanf(input_file,"%c",&bufor[0])!=EOF && bufor[0]!='\n');

	}
      else
	if (bufor[0]=='#')
	  break;
	else
	  if (bufor[0]!='\n')
	    while(fscanf(input_file,"%c",&bufor[0])!=EOF && bufor[0]!='\n');
      
    }

   


  fclose(input_file);
  
  
  return;
}


static GnomeUIInfo file_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, E_OPEN,
    E_OPEN_DESC,
    (gpointer) on_open_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_OPEN,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, E_SAVE,
    E_SAVE_DESC,
    (gpointer) on_save_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, E_SAVE_AS,
    E_SAVE_AS_DESC,
    (gpointer) on_save_as_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_SAVE_AS,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, E_EXIT,
    E_EXIT_DESC,
    (gpointer) on_exit_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_EXIT,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo edit_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, E_MOVE_ALL,
    E_MOVE_ALL_DESC,
    (gpointer) on_move_all_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_FORWARD,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, E_MOVE_PARTLY,
    E_MOVE_PARTLY_DESC,
    (gpointer) on_move_partly_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_LAST,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, E_CHANGE_FORMAT,
    E_CHANGE_FORMAT_DESC,
    (gpointer) on_change_format_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_REFRESH,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, E_MERGE,
    E_MERGE_DESC,
    (gpointer) on_merge_two_sub_files1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_UNDO,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, E_CONVERT_ISO_1,
    E_CONVERT_ISO_1_DESC,
    (gpointer) on_convert_to_iso_8859_1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CONVERT,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, E_CONVERT_ISO_2,
    E_CONVERT_ISO_2_DESC,
    (gpointer) on_convert_to_iso_8859_2_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_CONVERT,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo settings_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, E_PREFERENCES,
    NULL,
    (gpointer) on_preferences1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_STOCK, GNOME_STOCK_MENU_PREF,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo help_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, E_ABOUT,
    NULL,
    (gpointer) on_about1_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo menubar_uiinfo[] =
{
  {
    GNOME_APP_UI_SUBTREE, E_FILE,
    NULL,
    file_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, E_EDIT,
    NULL,
    edit_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, E_SETTINGS,
    NULL,
    settings_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_SUBTREE, E_HELP,
    NULL,
    help_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

GtkWidget*
create_main_window (void)
{
  GtkWidget *main_window;
  GtkWidget *dock;
  GtkWidget *eventbox1;
  GtkWidget *toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *open_button;
  GtkWidget *save_button;
  GtkWidget *save_as_button;
  GtkWidget *preferences_button;
  GtkWidget *quit_button;
  GtkWidget *vbox1;
  GtkWidget *hbox5;
  GtkWidget *label_time_bottom;
  GtkWidget *entry_sub_bottom;
  GtkWidget *label_sub_bottom;
  GtkWidget *text_sub_bottom;
  GtkWidget *hbox4;
  GtkWidget *button_move_from_bottom;
  GtkWidget *entry_move_from_bottom;
  GtkWidget *button_move_to_bottom;
  GtkWidget *entry_move_to_bottom;
  GtkWidget *button_insert_bottom;
  GtkWidget *button_change_bottom;
  GtkWidget *button_delete_bottom;
  GtkWidget *scrolledwindow1;
  GtkWidget *sub_list;
  GtkWidget *list_time_label;
  GtkWidget *list_sub_label;
  GtkWidget *appbar;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  main_window = gnome_app_new ("GTKsubtitler", GTKSUBTITLER_VERSION);
  gtk_object_set_data (GTK_OBJECT (main_window), "main_window", main_window);
  gtk_widget_set_usize (main_window, 662, 346);
  gtk_window_set_position (GTK_WINDOW (main_window), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (main_window), TRUE, TRUE, TRUE);



  dock = GNOME_APP (main_window)->dock;
  gtk_widget_ref (dock);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "dock", dock,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (dock);

  gnome_app_create_menus (GNOME_APP (main_window), menubar_uiinfo);

  gtk_widget_ref (menubar_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "file",
                            menubar_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "open",
                            file_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save",
                            file_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_as",
                            file_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator3",
                            file_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (file_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "exit",
                            file_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "edit",
                            menubar_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "move_all",
                            edit_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "move_partly",
                            edit_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "change_format",
                            edit_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "merge_two_sub_files1",
                            edit_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "separator4",
                            edit_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "convert_to_iso_8859_1",
                            edit_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[6].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "convert_to_iso_8859_2",
                            edit_menu_uiinfo[6].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "settings",
                            menubar_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (settings_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "preferences",
                            settings_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "help",
                            menubar_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "about1",
                            help_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  eventbox1 = gtk_event_box_new ();
  gtk_widget_ref (eventbox1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "eventbox1", eventbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (eventbox1);
  gnome_app_add_docked (GNOME_APP (main_window), eventbox1, "eventbox1",
                                GNOME_DOCK_ITEM_BEH_EXCLUSIVE,
                                GNOME_DOCK_TOP, 1, 0, 0);

  toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "toolbar", toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar);
  gtk_container_add (GTK_CONTAINER (eventbox1), toolbar);
  gtk_container_set_border_width (GTK_CONTAINER (toolbar), 1);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar), 16);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_window, GNOME_STOCK_PIXMAP_OPEN);
  open_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                E_OPEN,
                                E_OPEN, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (open_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "open_button", open_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (open_button);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_window, GNOME_STOCK_PIXMAP_SAVE);
  save_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                E_SAVE,
                                E_SAVE, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (save_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_button", save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_button);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_window, GNOME_STOCK_PIXMAP_SAVE_AS);
  save_as_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                E_SAVE_AS,
                                E_SAVE_AS, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (save_as_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "save_as_button", save_as_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (save_as_button);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_window, GNOME_STOCK_PIXMAP_PREFERENCES);
  preferences_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                E_PREFERENCES,
                                E_PREFERENCES, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (preferences_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "preferences_button", preferences_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (preferences_button);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (main_window, GNOME_STOCK_PIXMAP_EXIT);
  quit_button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                E_QUIT,
                                E_QUIT, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (quit_button);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "quit_button", quit_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (quit_button);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gnome_app_add_docked (GNOME_APP (main_window), vbox1, "vbox1",
                                GNOME_DOCK_ITEM_BEH_LOCKED,
                                GNOME_DOCK_BOTTOM, 0, 0, 0);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox5);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "hbox5", hbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox5, TRUE, TRUE, 0);

  label_time_bottom = gtk_label_new (E_TIME_FRAMES);
  gtk_widget_ref (label_time_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label_time_bottom", label_time_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_time_bottom);
  gtk_box_pack_start (GTK_BOX (hbox5), label_time_bottom, FALSE, FALSE, 0);
  gtk_widget_set_usize (label_time_bottom, 0, 0);

  entry_sub_bottom = gtk_entry_new ();
  gtk_widget_ref (entry_sub_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "entry_sub_bottom", entry_sub_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_sub_bottom);
  gtk_box_pack_start (GTK_BOX (hbox5), entry_sub_bottom, TRUE, TRUE, 0);
  gtk_widget_set_usize (entry_sub_bottom, 104, 22);

  label_sub_bottom = gtk_label_new (E_SUBTITLE);
  gtk_widget_ref (label_sub_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "label_sub_bottom", label_sub_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_sub_bottom);
  gtk_box_pack_start (GTK_BOX (hbox5), label_sub_bottom, FALSE, FALSE, 0);
  gtk_widget_set_usize (label_sub_bottom, 0, 0);

  text_sub_bottom = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text_sub_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "text_sub_bottom", text_sub_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text_sub_bottom);
  gtk_box_pack_start (GTK_BOX (hbox5), text_sub_bottom, TRUE, TRUE, 0);
  gtk_widget_set_usize (text_sub_bottom, 376, 24);
  gtk_text_set_editable (GTK_TEXT (text_sub_bottom), TRUE);

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox4, TRUE, TRUE, 0);

  button_move_from_bottom = gtk_button_new_with_label ( E_MOVE_FROM );
  gtk_widget_ref (button_move_from_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_move_from_bottom", button_move_from_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_move_from_bottom);
  gtk_box_pack_start (GTK_BOX (hbox4), button_move_from_bottom, FALSE, FALSE, 0);
  gtk_widget_set_usize (button_move_from_bottom, 0, 0);
  gtk_tooltips_set_tip (tooltips, button_move_from_bottom, E_MOVE_TO, NULL);

  entry_move_from_bottom = gtk_entry_new ();
  gtk_widget_ref (entry_move_from_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "entry_move_from_bottom", entry_move_from_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_move_from_bottom);
  gtk_box_pack_start (GTK_BOX (hbox4), entry_move_from_bottom, TRUE, TRUE, 0);
  gtk_widget_set_usize (entry_move_from_bottom, 104, 24);
  gtk_entry_set_editable (GTK_ENTRY (entry_move_from_bottom), FALSE);

  button_move_to_bottom = gtk_button_new_with_label (E_MOVE_TO);
  gtk_widget_ref (button_move_to_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_move_to_bottom", button_move_to_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_move_to_bottom);
  gtk_box_pack_start (GTK_BOX (hbox4), button_move_to_bottom, FALSE, FALSE, 0);
  gtk_widget_set_usize (button_move_to_bottom, 0, 0);
  gtk_tooltips_set_tip (tooltips, button_move_to_bottom, E_MOVE_TO, NULL);

  entry_move_to_bottom = gtk_entry_new ();
  gtk_widget_ref (entry_move_to_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "entry_move_to_bottom", entry_move_to_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_move_to_bottom);
  gtk_box_pack_start (GTK_BOX (hbox4), entry_move_to_bottom, TRUE, TRUE, 0);
  gtk_widget_set_usize (entry_move_to_bottom, 100, 0);
  gtk_entry_set_editable (GTK_ENTRY (entry_move_to_bottom), FALSE);

  button_insert_bottom = gtk_button_new_with_label (E_INSERT);
  gtk_widget_ref (button_insert_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_insert_bottom", button_insert_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_insert_bottom);
  gtk_box_pack_start (GTK_BOX (hbox4), button_insert_bottom, FALSE, FALSE, 0);
  gtk_widget_set_usize (button_insert_bottom, 60, 0);
  gtk_tooltips_set_tip (tooltips, button_insert_bottom, E_INSERT, NULL);

  button_change_bottom = gtk_button_new_with_label (E_CHANGE);
  gtk_widget_ref (button_change_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_change_bottom", button_change_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_change_bottom);
  gtk_box_pack_start (GTK_BOX (hbox4), button_change_bottom, FALSE, FALSE, 0);
  gtk_widget_set_usize (button_change_bottom, 60, 0);
  gtk_tooltips_set_tip (tooltips, button_change_bottom, E_CHANGE, NULL);

  button_delete_bottom = gtk_button_new_with_label (E_DELETE);
  gtk_widget_ref (button_delete_bottom);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "button_delete_bottom", button_delete_bottom,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_delete_bottom);
  gtk_box_pack_start (GTK_BOX (hbox4), button_delete_bottom, FALSE, FALSE, 0);
  gtk_widget_set_usize (button_delete_bottom, 60, 0);
  gtk_tooltips_set_tip (tooltips, button_delete_bottom, E_DELETE, NULL);


  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "scrolledwindow1", scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow1);
  gnome_app_set_contents (GNOME_APP (main_window), scrolledwindow1);

  sub_list = gtk_clist_new (2);
  gtk_widget_ref (sub_list);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "sub_list", sub_list,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sub_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), sub_list);
  gtk_clist_set_column_width (GTK_CLIST (sub_list), 0, 138);
  gtk_clist_set_column_width (GTK_CLIST (sub_list), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (sub_list));

  list_time_label = gtk_label_new (E_TIME_FRAMES);
  gtk_widget_ref (list_time_label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "list_time_label", list_time_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_time_label);
  gtk_clist_set_column_widget (GTK_CLIST (sub_list), 0, list_time_label);

  list_sub_label = gtk_label_new (E_SUBTITLE);
  gtk_widget_ref (list_sub_label);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "list_sub_label", list_sub_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (list_sub_label);
  gtk_clist_set_column_widget (GTK_CLIST (sub_list), 1, list_sub_label);

  appbar = gnome_appbar_new (TRUE, TRUE, GNOME_PREFERENCES_NEVER);
  gtk_widget_ref (appbar);
  gtk_object_set_data_full (GTK_OBJECT (main_window), "appbar", appbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (appbar);
  gnome_app_set_statusbar (GNOME_APP (main_window), appbar);

  gtk_signal_connect (GTK_OBJECT (main_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_main_window_delete_event),
                      NULL);
  gnome_app_install_menu_hints (GNOME_APP (main_window), menubar_uiinfo);
  gtk_signal_connect (GTK_OBJECT (open_button), "clicked",
                      GTK_SIGNAL_FUNC (on_open_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_save_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (save_as_button), "clicked",
                      GTK_SIGNAL_FUNC (on_save_as_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (preferences_button), "clicked",
                      GTK_SIGNAL_FUNC (on_preferences_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (quit_button), "clicked",
                      GTK_SIGNAL_FUNC (on_quit_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_move_from_bottom), "clicked",
                      GTK_SIGNAL_FUNC (on_button_move_from_bottom_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_move_to_bottom), "clicked",
                      GTK_SIGNAL_FUNC (on_button_move_to_bottom_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_insert_bottom), "clicked",
                      GTK_SIGNAL_FUNC (on_button_insert_bottom_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_change_bottom), "clicked",
                      GTK_SIGNAL_FUNC (on_button_change_bottom_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_delete_bottom), "clicked",
                      GTK_SIGNAL_FUNC (on_button_delete_bottom_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (sub_list), "select_row",
                      GTK_SIGNAL_FUNC (on_sub_list_select_row),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (main_window), "tooltips", tooltips);

  return main_window;
}

GtkWidget*
create_fileselection_window (void)
{
  GtkWidget *fileselection_window;
  GtkWidget *ok_button1;
  GtkWidget *cancel_button1;

  fileselection_window = gtk_file_selection_new (E_CHOOSE_FILE);
  gtk_object_set_data (GTK_OBJECT (fileselection_window), "fileselection_window", fileselection_window);
  gtk_container_set_border_width (GTK_CONTAINER (fileselection_window), 10);
  gtk_window_set_position (GTK_WINDOW (fileselection_window), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (fileselection_window), TRUE, TRUE,TRUE);
  gtk_window_set_modal (GTK_WINDOW (fileselection_window), TRUE);

  ok_button1 = GTK_FILE_SELECTION (fileselection_window)->ok_button;
  gtk_object_set_data (GTK_OBJECT (fileselection_window), "ok_button1", ok_button1);
  gtk_widget_show (ok_button1);
  GTK_WIDGET_SET_FLAGS (ok_button1, GTK_CAN_DEFAULT);

  cancel_button1 = GTK_FILE_SELECTION (fileselection_window)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (fileselection_window), "cancel_button1", cancel_button1);
  gtk_widget_show (cancel_button1);
  GTK_WIDGET_SET_FLAGS (cancel_button1, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (fileselection_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_fileselection_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (ok_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_button1_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cancel_button1), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_button1_clicked),
                      NULL);

  return fileselection_window;
}

GtkWidget*
create_pref_window (void)
{
  GtkWidget *pref_window;
  GtkWidget *fixed4;
  GtkWidget *button_pref_ok;
  GtkWidget *button_pref_cancel;
  GtkWidget *notebook_pref;
  GtkWidget *fixed_pref_general;
  GtkWidget *entry_pref_temp_dir;
  GtkWidget *entry_chmod;
  GtkWidget *label_chmod;
  GtkWidget *label_temp;
  GtkWidget *label_pref_general;
  GtkWidget *fixed_pref_lang;
  GtkWidget *entry_pref_lang_dir;
  GtkWidget *label_lang_dir;
  GtkWidget *label_lang;
  GtkWidget *combo_pref_lang;
  GtkWidget *combo_entry_pref_lang;
  GtkWidget *label_pref_lang;
  GtkWidget *hseparator_pref;

  pref_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (pref_window), "pref_window", pref_window);
  gtk_container_set_border_width (GTK_CONTAINER (pref_window), 2);
  gtk_window_set_title (GTK_WINDOW (pref_window), E_PREFERENCES_WINDOW);
  gtk_window_set_position (GTK_WINDOW (pref_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (pref_window), TRUE);

  fixed4 = gtk_fixed_new ();
  gtk_widget_ref (fixed4);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "fixed4", fixed4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed4);
  gtk_container_add (GTK_CONTAINER (pref_window), fixed4);

  button_pref_ok = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (button_pref_ok);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "button_pref_ok", button_pref_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_pref_ok);
  gtk_fixed_put (GTK_FIXED (fixed4), button_pref_ok, 192, 168);
  gtk_widget_set_uposition (button_pref_ok, 192, 168);
  gtk_widget_set_usize (button_pref_ok, 80, 24);

  button_pref_cancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (button_pref_cancel);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "button_pref_cancel", button_pref_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_pref_cancel);
  gtk_fixed_put (GTK_FIXED (fixed4), button_pref_cancel, 288, 168);
  gtk_widget_set_uposition (button_pref_cancel, 288, 168);
  gtk_widget_set_usize (button_pref_cancel, 80, 24);

  notebook_pref = gtk_notebook_new ();
  gtk_widget_ref (notebook_pref);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "notebook_pref", notebook_pref,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook_pref);
  gtk_fixed_put (GTK_FIXED (fixed4), notebook_pref, 0, 0);
  gtk_widget_set_uposition (notebook_pref, 0, 0);
  gtk_widget_set_usize (notebook_pref, 384, 152);

  fixed_pref_general = gtk_fixed_new ();
  gtk_widget_ref (fixed_pref_general);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "fixed_pref_general", fixed_pref_general,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed_pref_general);
  gtk_container_add (GTK_CONTAINER (notebook_pref), fixed_pref_general);

  entry_pref_temp_dir = gtk_entry_new ();
  gtk_widget_ref (entry_pref_temp_dir);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "entry_pref_temp_dir", entry_pref_temp_dir,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_pref_temp_dir);
  gtk_fixed_put (GTK_FIXED (fixed_pref_general), entry_pref_temp_dir, 124, 24);
  gtk_widget_set_uposition (entry_pref_temp_dir, 124, 24);
  gtk_widget_set_usize (entry_pref_temp_dir, 234, 24);

  entry_chmod = gtk_entry_new_with_max_length (3);
  gtk_widget_ref (entry_chmod);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "entry_chmod", entry_chmod,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_chmod);
  gtk_fixed_put (GTK_FIXED (fixed_pref_general), entry_chmod, 144, 72);
  gtk_widget_set_uposition (entry_chmod, 144, 72);
  gtk_widget_set_usize (entry_chmod, 40, 24);
  gtk_entry_set_text (GTK_ENTRY (entry_chmod), "0644");

  label_chmod = gtk_label_new (E_FILE_ACCESS);
  gtk_widget_ref (label_chmod);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "label_chmod", label_chmod,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_chmod);
  gtk_fixed_put (GTK_FIXED (fixed_pref_general), label_chmod, 8, 80);
  gtk_widget_set_uposition (label_chmod, 8, 80);
  gtk_widget_set_usize (label_chmod, 128, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label_chmod), TRUE);

  label_temp = gtk_label_new (E_TEMP_DIR);
  gtk_widget_ref (label_temp);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "label_temp", label_temp,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_temp);
  gtk_fixed_put (GTK_FIXED (fixed_pref_general), label_temp, 8, 32);
  gtk_widget_set_uposition (label_temp, 8, 32);
  gtk_widget_set_usize (label_temp, 156, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label_temp), TRUE);

  label_pref_general = gtk_label_new (E_GENERAL);
  gtk_widget_ref (label_pref_general);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "label_pref_general", label_pref_general,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_pref_general);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_pref), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_pref), 0), label_pref_general);

  fixed_pref_lang = gtk_fixed_new ();
  gtk_widget_ref (fixed_pref_lang);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "fixed_pref_lang", fixed_pref_lang,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed_pref_lang);
  gtk_container_add (GTK_CONTAINER (notebook_pref), fixed_pref_lang);

  entry_pref_lang_dir = gtk_entry_new ();
  gtk_widget_ref (entry_pref_lang_dir);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "entry_pref_lang_dir", entry_pref_lang_dir,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_pref_lang_dir);
  gtk_fixed_put (GTK_FIXED (fixed_pref_lang), entry_pref_lang_dir, 98, 16);
  gtk_widget_set_uposition (entry_pref_lang_dir, 98, 16);
  gtk_widget_set_usize (entry_pref_lang_dir, 192, 24);

  label_lang_dir = gtk_label_new (E_LANG_DIR);
  gtk_widget_ref (label_lang_dir);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "label_lang_dir", label_lang_dir,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_lang_dir);
  gtk_fixed_put (GTK_FIXED (fixed_pref_lang), label_lang_dir, 8, 24);
  gtk_widget_set_uposition (label_lang_dir, 8, 24);
  gtk_widget_set_usize (label_lang_dir, 86, 16);

  label_lang = gtk_label_new (E_LANG);
  gtk_widget_ref (label_lang);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "label_lang", label_lang,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_lang);
  gtk_fixed_put (GTK_FIXED (fixed_pref_lang), label_lang, 8, 72);
  gtk_widget_set_uposition (label_lang, 8, 72);
  gtk_widget_set_usize (label_lang, 64, 16);

  combo_pref_lang = gtk_combo_new ();
  gtk_widget_ref (combo_pref_lang);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "combo_pref_lang", combo_pref_lang,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_pref_lang);
  gtk_fixed_put (GTK_FIXED (fixed_pref_lang), combo_pref_lang, 98, 64);
  gtk_widget_set_uposition (combo_pref_lang, 98, 64);
  gtk_widget_set_usize (combo_pref_lang, 192, 24);

  combo_entry_pref_lang = GTK_COMBO (combo_pref_lang)->entry;
  gtk_widget_ref (combo_entry_pref_lang);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "combo_entry_pref_lang", combo_entry_pref_lang,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry_pref_lang);

  label_pref_lang = gtk_label_new (E_LANG);
  gtk_widget_ref (label_pref_lang);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "label_pref_lang", label_pref_lang,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_pref_lang);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook_pref), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook_pref), 1), label_pref_lang);

  hseparator_pref = gtk_hseparator_new ();
  gtk_widget_ref (hseparator_pref);
  gtk_object_set_data_full (GTK_OBJECT (pref_window), "hseparator_pref", hseparator_pref,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator_pref);
  gtk_fixed_put (GTK_FIXED (fixed4), hseparator_pref, 0, 152);
  gtk_widget_set_uposition (hseparator_pref, 0, 152);
  gtk_widget_set_usize (hseparator_pref, 376, 16);

  gtk_signal_connect (GTK_OBJECT (pref_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_pref_window_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_pref_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_button_pref_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_pref_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_button_pref_cancel_clicked),
                      NULL);

  return pref_window;
}

GtkWidget*
create_properties_window (void)
{
  GtkWidget *properties_window;
  GtkWidget *fixed_properties;
  GtkWidget *button_properties_ok;
  GtkWidget *button_properties_cancel;
  GtkObject *spinbutton_properties_hours_adj;
  GtkWidget *spinbutton_properties_hours;
  GtkObject *spinbutton_properties_minutes_adj;
  GtkWidget *spinbutton_properties_minutes;
  GtkObject *spinbutton_properties_seconds_adj;
  GtkWidget *spinbutton_properties_seconds;
  GtkObject *spinbutton_properties_frames_in_sec_adj;
  GtkWidget *spinbutton_properties_frames_in_sec;
  GtkWidget *label_properties_move_hours;
  GtkWidget *label_properties_seconds_seconds;
  GtkWidget *label_properties_move_minutes;
  GtkWidget *label_properties_direction;
  GtkWidget *entry_hour_from;
  GtkWidget *entry_hour_to;
  GtkWidget *entry_sec_to;
  GtkWidget *entry_min_to;
  GtkWidget *entry_min_from;
  GtkWidget *entry_sec_from;
  GtkWidget *entry_frame_from;
  GtkWidget *entry_frame_to;
  GtkWidget *label1;
  GtkWidget *hseparator1;
  GtkWidget *label11;
  GtkWidget *label12;
  GtkWidget *label13;
  GtkWidget *label_from;
  GtkWidget *label_to;
  GtkWidget *label_properties_frames_in_sec;
  GtkWidget *label_move_from_to;
  GtkWidget *combo_properties_direction;
  GList *combo_properties_direction_items = NULL;
  GtkWidget *combo_entry_properties_direction;

  properties_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (properties_window), "properties_window", properties_window);
  gtk_container_set_border_width (GTK_CONTAINER (properties_window), 4);
  gtk_window_set_title (GTK_WINDOW (properties_window), E_PROPERTIES);
  gtk_window_set_position (GTK_WINDOW (properties_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (properties_window), TRUE);

  fixed_properties = gtk_fixed_new ();
  gtk_widget_ref (fixed_properties);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "fixed_properties", fixed_properties,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed_properties);
  gtk_container_add (GTK_CONTAINER (properties_window), fixed_properties);

  button_properties_ok = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (button_properties_ok);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "button_properties_ok", button_properties_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_properties_ok);
  gtk_fixed_put (GTK_FIXED (fixed_properties), button_properties_ok, 320, 264);
  gtk_widget_set_uposition (button_properties_ok, 320, 264);
  gtk_widget_set_usize (button_properties_ok, 72, 24);

  button_properties_cancel = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (button_properties_cancel);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "button_properties_cancel", button_properties_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_properties_cancel);
  gtk_fixed_put (GTK_FIXED (fixed_properties), button_properties_cancel, 416, 264);
  gtk_widget_set_uposition (button_properties_cancel, 416, 264);
  gtk_widget_set_usize (button_properties_cancel, 80, 24);

  spinbutton_properties_hours_adj = gtk_adjustment_new (1, 0, 99, 1, 10, 10);
  spinbutton_properties_hours = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_properties_hours_adj), 1, 0);
  gtk_widget_ref (spinbutton_properties_hours);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "spinbutton_properties_hours", spinbutton_properties_hours,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_properties_hours);
  gtk_fixed_put (GTK_FIXED (fixed_properties), spinbutton_properties_hours, 216, 8);
  gtk_widget_set_uposition (spinbutton_properties_hours, 216, 8);
  gtk_widget_set_usize (spinbutton_properties_hours, 40, 24);

  spinbutton_properties_minutes_adj = gtk_adjustment_new (1, 0, 59, 1, 10, 10);
  spinbutton_properties_minutes = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_properties_minutes_adj), 1, 0);
  gtk_widget_ref (spinbutton_properties_minutes);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "spinbutton_properties_minutes", spinbutton_properties_minutes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_properties_minutes);
  gtk_fixed_put (GTK_FIXED (fixed_properties), spinbutton_properties_minutes, 216, 40);
  gtk_widget_set_uposition (spinbutton_properties_minutes, 216, 40);
  gtk_widget_set_usize (spinbutton_properties_minutes, 40, 24);

  spinbutton_properties_seconds_adj = gtk_adjustment_new (1, 0, 59, 1, 10, 10);
  spinbutton_properties_seconds = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_properties_seconds_adj), 1, 0);
  gtk_widget_ref (spinbutton_properties_seconds);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "spinbutton_properties_seconds", spinbutton_properties_seconds,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_properties_seconds);
  gtk_fixed_put (GTK_FIXED (fixed_properties), spinbutton_properties_seconds, 216, 72);
  gtk_widget_set_uposition (spinbutton_properties_seconds, 216, 72);
  gtk_widget_set_usize (spinbutton_properties_seconds, 40, 24);

  spinbutton_properties_frames_in_sec_adj = gtk_adjustment_new (29.97, 0, 999.99, 0.01, 1, 1);
  spinbutton_properties_frames_in_sec = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_properties_frames_in_sec_adj), 1, 2);
  gtk_widget_ref (spinbutton_properties_frames_in_sec);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "spinbutton_properties_frames_in_sec", spinbutton_properties_frames_in_sec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_properties_frames_in_sec);
  gtk_fixed_put (GTK_FIXED (fixed_properties), spinbutton_properties_frames_in_sec, 416, 64);
  gtk_widget_set_uposition (spinbutton_properties_frames_in_sec, 416, 64);
  gtk_widget_set_usize (spinbutton_properties_frames_in_sec, 60, 24);

  label_properties_move_hours = gtk_label_new (E_HOW_MANY_HOURS);
  gtk_widget_ref (label_properties_move_hours);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label_properties_move_hours", label_properties_move_hours,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_properties_move_hours);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label_properties_move_hours, 8, 16);
  gtk_widget_set_uposition (label_properties_move_hours, 8, 16);
  gtk_widget_set_usize (label_properties_move_hours, 184, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label_properties_move_hours), TRUE);

  label_properties_seconds_seconds = gtk_label_new (E_HOW_MANY_SEC);
  gtk_widget_ref (label_properties_seconds_seconds);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label_properties_seconds_seconds", label_properties_seconds_seconds,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_properties_seconds_seconds);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label_properties_seconds_seconds, 8, 80);
  gtk_widget_set_uposition (label_properties_seconds_seconds, 8, 80);
  gtk_widget_set_usize (label_properties_seconds_seconds, 200, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label_properties_seconds_seconds), TRUE);

  label_properties_move_minutes = gtk_label_new (E_HOW_MANY_MIN);
  gtk_widget_ref (label_properties_move_minutes);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label_properties_move_minutes", label_properties_move_minutes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_properties_move_minutes);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label_properties_move_minutes, 8, 48);
  gtk_widget_set_uposition (label_properties_move_minutes, 8, 48);
  gtk_widget_set_usize (label_properties_move_minutes, 200, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label_properties_move_minutes), TRUE);

  label_properties_direction = gtk_label_new (E_WHAT_DIRECTION);
  gtk_widget_ref (label_properties_direction);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label_properties_direction", label_properties_direction,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_properties_direction);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label_properties_direction, 272, 8);
  gtk_widget_set_uposition (label_properties_direction, 272, 8);
  gtk_widget_set_usize (label_properties_direction, 96, 24);
  gtk_label_set_justify (GTK_LABEL (label_properties_direction), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label_properties_direction), TRUE);

  entry_hour_from = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (entry_hour_from);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "entry_hour_from", entry_hour_from,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_hour_from);
  gtk_fixed_put (GTK_FIXED (fixed_properties), entry_hour_from, 104, 184);
  gtk_widget_set_uposition (entry_hour_from, 104, 184);
  gtk_widget_set_usize (entry_hour_from, 24, 24);

  entry_hour_to = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (entry_hour_to);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "entry_hour_to", entry_hour_to,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_hour_to);
  gtk_fixed_put (GTK_FIXED (fixed_properties), entry_hour_to, 104, 216);
  gtk_widget_set_uposition (entry_hour_to, 104, 216);
  gtk_widget_set_usize (entry_hour_to, 24, 24);

  entry_sec_to = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (entry_sec_to);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "entry_sec_to", entry_sec_to,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_sec_to);
  gtk_fixed_put (GTK_FIXED (fixed_properties), entry_sec_to, 216, 216);
  gtk_widget_set_uposition (entry_sec_to, 216, 216);
  gtk_widget_set_usize (entry_sec_to, 24, 24);

  entry_min_to = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (entry_min_to);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "entry_min_to", entry_min_to,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_min_to);
  gtk_fixed_put (GTK_FIXED (fixed_properties), entry_min_to, 160, 216);
  gtk_widget_set_uposition (entry_min_to, 160, 216);
  gtk_widget_set_usize (entry_min_to, 24, 24);

  entry_min_from = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (entry_min_from);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "entry_min_from", entry_min_from,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_min_from);
  gtk_fixed_put (GTK_FIXED (fixed_properties), entry_min_from, 160, 184);
  gtk_widget_set_uposition (entry_min_from, 160, 184);
  gtk_widget_set_usize (entry_min_from, 24, 24);

  entry_sec_from = gtk_entry_new_with_max_length (2);
  gtk_widget_ref (entry_sec_from);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "entry_sec_from", entry_sec_from,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_sec_from);
  gtk_fixed_put (GTK_FIXED (fixed_properties), entry_sec_from, 216, 184);
  gtk_widget_set_uposition (entry_sec_from, 216, 184);
  gtk_widget_set_usize (entry_sec_from, 24, 24);

  entry_frame_from = gtk_entry_new_with_max_length (8);
  gtk_widget_ref (entry_frame_from);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "entry_frame_from", entry_frame_from,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_frame_from);
  gtk_fixed_put (GTK_FIXED (fixed_properties), entry_frame_from, 352, 184);
  gtk_widget_set_uposition (entry_frame_from, 352, 184);
  gtk_widget_set_usize (entry_frame_from, 64, 24);

  entry_frame_to = gtk_entry_new_with_max_length (8);
  gtk_widget_ref (entry_frame_to);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "entry_frame_to", entry_frame_to,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_frame_to);
  gtk_fixed_put (GTK_FIXED (fixed_properties), entry_frame_to, 352, 216);
  gtk_widget_set_uposition (entry_frame_to, 352, 216);
  gtk_widget_set_usize (entry_frame_to, 64, 24);

  label1 = gtk_label_new (E_TIME);
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label1, 16, 160);
  gtk_widget_set_uposition (label1, 16, 160);
  gtk_widget_set_usize (label1, 32, 16);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);

  hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator1);
  gtk_fixed_put (GTK_FIXED (fixed_properties), hseparator1, 8, 248);
  gtk_widget_set_uposition (hseparator1, 8, 248);
  gtk_widget_set_usize (hseparator1, 504, 16);

  label11 = gtk_label_new (E_HOUR_MINUTE_SECOND);
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label11);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label11, 96, 168);
  gtk_widget_set_uposition (label11, 96, 168);
  gtk_widget_set_usize (label11, 160, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label11), TRUE);

  label12 = gtk_label_new ("or");
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label12);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label12, 288, 200);
  gtk_widget_set_uposition (label12, 288, 200);
  gtk_widget_set_usize (label12, 16, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label12), TRUE);

  label13 = gtk_label_new (E_FRAME_MICRODVD);
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label13);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label13, 288, 152);
  gtk_widget_set_uposition (label13, 288, 152);
  gtk_widget_set_usize (label13, 112, 16);

  label_from = gtk_label_new (E_FROM);
  gtk_widget_ref (label_from);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label_from", label_from,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_from);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label_from, 40, 192);
  gtk_widget_set_uposition (label_from, 40, 192);
  gtk_widget_set_usize (label_from, 34, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label_from), TRUE);

  label_to = gtk_label_new (E_TO);
  gtk_widget_ref (label_to);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label_to", label_to,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_to);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label_to, 40, 224);
  gtk_widget_set_uposition (label_to, 40, 224);
  gtk_widget_set_usize (label_to, 16, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label_to), TRUE);

  label_properties_frames_in_sec = gtk_label_new (E_FRAMES_IN_ONE_SEC);
  gtk_widget_ref (label_properties_frames_in_sec);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label_properties_frames_in_sec", label_properties_frames_in_sec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_properties_frames_in_sec);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label_properties_frames_in_sec, 272, 48);
  gtk_widget_set_uposition (label_properties_frames_in_sec, 272, 48);
  gtk_widget_set_usize (label_properties_frames_in_sec, 240, 48);
  gtk_label_set_justify (GTK_LABEL (label_properties_frames_in_sec), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label_properties_frames_in_sec), TRUE);

  label_move_from_to = gtk_label_new (E_MOVE_FROM_POINT_TO_POINT);
  gtk_widget_ref (label_move_from_to);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "label_move_from_to", label_move_from_to,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_move_from_to);
  gtk_fixed_put (GTK_FIXED (fixed_properties), label_move_from_to, 8, 136);
  gtk_widget_set_uposition (label_move_from_to, 8, 136);
  gtk_widget_set_usize (label_move_from_to, 496, 16);
  gtk_label_set_line_wrap (GTK_LABEL (label_move_from_to), TRUE);

  combo_properties_direction = gtk_combo_new ();
  gtk_widget_ref (combo_properties_direction);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "combo_properties_direction", combo_properties_direction,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_properties_direction);
  gtk_fixed_put (GTK_FIXED (fixed_properties), combo_properties_direction, 400, 8);
  gtk_widget_set_uposition (combo_properties_direction, 400, 8);
  gtk_widget_set_usize (combo_properties_direction, 56, 24);
  gtk_combo_set_value_in_list (GTK_COMBO (combo_properties_direction), TRUE, FALSE);
  combo_properties_direction_items = g_list_append (combo_properties_direction_items, (gpointer) "===>>");
  combo_properties_direction_items = g_list_append (combo_properties_direction_items, (gpointer) "<<===");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo_properties_direction), combo_properties_direction_items);
  g_list_free (combo_properties_direction_items);

  combo_entry_properties_direction = GTK_COMBO (combo_properties_direction)->entry;
  gtk_widget_ref (combo_entry_properties_direction);
  gtk_object_set_data_full (GTK_OBJECT (properties_window), "combo_entry_properties_direction", combo_entry_properties_direction,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry_properties_direction);
  gtk_entry_set_text (GTK_ENTRY (combo_entry_properties_direction), "===>>");

  gtk_signal_connect (GTK_OBJECT (properties_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_properties_window_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_properties_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_button_properties_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_properties_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_button_properties_cancel_clicked),
                      NULL);

  return properties_window;
}

GtkWidget*
create_information_window (void)
{
  GtkWidget *information_window;
  GtkWidget *fixed_inf;
  GtkWidget *button_inf_ok;
  GtkWidget *hseparator_inf;
  GtkWidget *label_information;

  information_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (information_window), "information_window", information_window);
  gtk_container_set_border_width (GTK_CONTAINER (information_window), 3);
  gtk_window_set_title (GTK_WINDOW (information_window), E_INFORMATION);
  gtk_window_set_position (GTK_WINDOW (information_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (information_window), TRUE);

  fixed_inf = gtk_fixed_new ();
  gtk_widget_ref (fixed_inf);
  gtk_object_set_data_full (GTK_OBJECT (information_window), "fixed_inf", fixed_inf,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed_inf);
  gtk_container_add (GTK_CONTAINER (information_window), fixed_inf);

  button_inf_ok = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (button_inf_ok);
  gtk_object_set_data_full (GTK_OBJECT (information_window), "button_inf_ok", button_inf_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_inf_ok);
  gtk_fixed_put (GTK_FIXED (fixed_inf), button_inf_ok, 152, 56);
  gtk_widget_set_uposition (button_inf_ok, 152, 56);
  gtk_widget_set_usize (button_inf_ok, 88, 24);

  hseparator_inf = gtk_hseparator_new ();
  gtk_widget_ref (hseparator_inf);
  gtk_object_set_data_full (GTK_OBJECT (information_window), "hseparator_inf", hseparator_inf,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator_inf);
  gtk_fixed_put (GTK_FIXED (fixed_inf), hseparator_inf, 0, 32);
  gtk_widget_set_uposition (hseparator_inf, 0, 32);
  gtk_widget_set_usize (hseparator_inf, 384, 16);

  label_information = gtk_label_new ("");
  gtk_widget_ref (label_information);
  gtk_object_set_data_full (GTK_OBJECT (information_window), "label_information", label_information,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_information);
  gtk_fixed_put (GTK_FIXED (fixed_inf), label_information, 0, 8);
  gtk_widget_set_uposition (label_information, 0, 8);
  gtk_widget_set_usize (label_information, 384, 16);
  gtk_label_set_justify (GTK_LABEL (label_information), GTK_JUSTIFY_LEFT);

  gtk_signal_connect (GTK_OBJECT (information_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_information_window_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_inf_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_button_inf_ok_clicked),
                      NULL);

  return information_window;
}

GtkWidget*
create_change_format_window (void)
{
  GtkWidget *change_format_window;
  GtkWidget *fixed5;
  GtkWidget *button_ok_change_type;
  GtkWidget *button_cancel_change_type;
  GtkObject *spinbutton_change_format_frames_in_sec_adj;
  GtkWidget *spinbutton_change_format_frames_in_sec;
  GtkWidget *label_change_format_frames_in_sec;
  GtkWidget *combo_change_format;
  GList *combo_change_format_items = NULL;
  GtkWidget *combo_entry_change_format;

  change_format_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (change_format_window), "change_format_window", change_format_window);
  gtk_window_set_title (GTK_WINDOW (change_format_window), "Choose type:");
  gtk_window_set_position (GTK_WINDOW (change_format_window), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (change_format_window), FALSE, FALSE, FALSE);

  fixed5 = gtk_fixed_new ();
  gtk_widget_ref (fixed5);
  gtk_object_set_data_full (GTK_OBJECT (change_format_window), "fixed5", fixed5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed5);
  gtk_container_add (GTK_CONTAINER (change_format_window), fixed5);
  gtk_container_set_border_width (GTK_CONTAINER (fixed5), 5);

  button_ok_change_type = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (button_ok_change_type);
  gtk_object_set_data_full (GTK_OBJECT (change_format_window), "button_ok_change_type", button_ok_change_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok_change_type);
  gtk_fixed_put (GTK_FIXED (fixed5), button_ok_change_type, 32, 120);
  gtk_widget_set_uposition (button_ok_change_type, 32, 120);
  gtk_widget_set_usize (button_ok_change_type, 64, 24);

  button_cancel_change_type = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (button_cancel_change_type);
  gtk_object_set_data_full (GTK_OBJECT (change_format_window), "button_cancel_change_type", button_cancel_change_type,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_cancel_change_type);
  gtk_fixed_put (GTK_FIXED (fixed5), button_cancel_change_type, 160, 120);
  gtk_widget_set_uposition (button_cancel_change_type, 160, 120);
  gtk_widget_set_usize (button_cancel_change_type, 64, 24);

  spinbutton_change_format_frames_in_sec_adj = gtk_adjustment_new (29.97, 0, 999.99, 0.01, 1, 1);
  spinbutton_change_format_frames_in_sec = gtk_spin_button_new (GTK_ADJUSTMENT (spinbutton_change_format_frames_in_sec_adj), 1, 2);
  gtk_widget_ref (spinbutton_change_format_frames_in_sec);
  gtk_object_set_data_full (GTK_OBJECT (change_format_window), "spinbutton_change_format_frames_in_sec", spinbutton_change_format_frames_in_sec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (spinbutton_change_format_frames_in_sec);
  gtk_fixed_put (GTK_FIXED (fixed5), spinbutton_change_format_frames_in_sec, 176, 80);
  gtk_widget_set_uposition (spinbutton_change_format_frames_in_sec, 176, 80);
  gtk_widget_set_usize (spinbutton_change_format_frames_in_sec, 60, 24);

  label_change_format_frames_in_sec = gtk_label_new (E_FRAMES_IN_ONE_SEC);
  gtk_widget_ref (label_change_format_frames_in_sec);
  gtk_object_set_data_full (GTK_OBJECT (change_format_window), "label_change_format_frames_in_sec", label_change_format_frames_in_sec,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_change_format_frames_in_sec);
  gtk_fixed_put (GTK_FIXED (fixed5), label_change_format_frames_in_sec, 8, 56);
  gtk_widget_set_uposition (label_change_format_frames_in_sec, 8, 56);
  gtk_widget_set_usize (label_change_format_frames_in_sec, 240, 56);
  gtk_label_set_justify (GTK_LABEL (label_change_format_frames_in_sec), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label_change_format_frames_in_sec), TRUE);

  combo_change_format = gtk_combo_new ();
  gtk_widget_ref (combo_change_format);
  gtk_object_set_data_full (GTK_OBJECT (change_format_window), "combo_change_format", combo_change_format,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_change_format);
  gtk_fixed_put (GTK_FIXED (fixed5), combo_change_format, 32, 24);
  gtk_widget_set_uposition (combo_change_format, 32, 24);
  gtk_widget_set_usize (combo_change_format, 200, 24);
  gtk_combo_set_value_in_list (GTK_COMBO (combo_change_format), TRUE, TRUE);
  combo_change_format_items = g_list_append (combo_change_format_items, (gpointer) "Time");
  combo_change_format_items = g_list_append (combo_change_format_items, (gpointer) "MicroDVD");
  combo_change_format_items = g_list_append (combo_change_format_items, (gpointer) "SubRip");
  combo_change_format_items = g_list_append (combo_change_format_items, (gpointer) "SubViewer 2.0");
  combo_change_format_items = g_list_append (combo_change_format_items, (gpointer) "MPsub");
  gtk_combo_set_popdown_strings (GTK_COMBO (combo_change_format), combo_change_format_items);
  g_list_free (combo_change_format_items);

  combo_entry_change_format = GTK_COMBO (combo_change_format)->entry;
  gtk_widget_ref (combo_entry_change_format);
  gtk_object_set_data_full (GTK_OBJECT (change_format_window), "combo_entry_change_format", combo_entry_change_format,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_entry_change_format);
  gtk_entry_set_text (GTK_ENTRY (combo_entry_change_format), "Time");

  gtk_signal_connect (GTK_OBJECT (button_ok_change_type), "clicked",
                      GTK_SIGNAL_FUNC (on_button_ok_change_format_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_cancel_change_type), "clicked",
                      GTK_SIGNAL_FUNC (on_button_cancel_change_format_clicked),
                      NULL);

  return change_format_window;
}




GtkWidget*
create_save_as_window (void)
{
  GtkWidget *save_as_window;
  GtkWidget *fixed6;
  GtkWidget *button_ok_save_as;
  GtkWidget *button_cancel_save_as;
  GtkWidget *entry_save_as;
  GtkWidget *label_save_as;

  save_as_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (save_as_window), "save_as_window", save_as_window);
  gtk_container_set_border_width (GTK_CONTAINER (save_as_window), 7);
  gtk_window_set_title (GTK_WINDOW (save_as_window), E_SAVE_AS);
  gtk_window_set_position (GTK_WINDOW (save_as_window), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (save_as_window), FALSE, FALSE, FALSE);
  gtk_window_set_modal (GTK_WINDOW (save_as_window), TRUE);

  fixed6 = gtk_fixed_new ();
  gtk_widget_ref (fixed6);
  gtk_object_set_data_full (GTK_OBJECT (save_as_window), "fixed6", fixed6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed6);
  gtk_container_add (GTK_CONTAINER (save_as_window), fixed6);

  button_ok_save_as = gnome_stock_button (GNOME_STOCK_BUTTON_OK);
  gtk_widget_ref (button_ok_save_as);
  gtk_object_set_data_full (GTK_OBJECT (save_as_window), "button_ok_save_as", button_ok_save_as,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_ok_save_as);
  gtk_fixed_put (GTK_FIXED (fixed6), button_ok_save_as, 304, 64);
  gtk_widget_set_uposition (button_ok_save_as, 304, 64);
  gtk_widget_set_usize (button_ok_save_as, 72, 24);

  button_cancel_save_as = gnome_stock_button (GNOME_STOCK_BUTTON_CANCEL);
  gtk_widget_ref (button_cancel_save_as);
  gtk_object_set_data_full (GTK_OBJECT (save_as_window), "button_cancel_save_as", button_cancel_save_as,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_cancel_save_as);
  gtk_fixed_put (GTK_FIXED (fixed6), button_cancel_save_as, 400, 64);
  gtk_widget_set_uposition (button_cancel_save_as, 400, 64);
  gtk_widget_set_usize (button_cancel_save_as, 72, 24);

  entry_save_as = gtk_entry_new ();
  gtk_widget_ref (entry_save_as);
  gtk_object_set_data_full (GTK_OBJECT (save_as_window), "entry_save_as", entry_save_as,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_save_as);
  gtk_fixed_put (GTK_FIXED (fixed6), entry_save_as, 72, 16);
  gtk_widget_set_uposition (entry_save_as, 72, 16);
  gtk_widget_set_usize (entry_save_as, 400, 24);

  label_save_as = gtk_label_new ("Save file as:");
  gtk_widget_ref (label_save_as);
  gtk_object_set_data_full (GTK_OBJECT (save_as_window), "label_save_as", label_save_as,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_save_as);
  gtk_fixed_put (GTK_FIXED (fixed6), label_save_as, 0, 24);
  gtk_widget_set_uposition (label_save_as, 0, 24);
  gtk_widget_set_usize (label_save_as, 72, 16);
  gtk_label_set_justify (GTK_LABEL (label_save_as), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label_save_as), TRUE);

  gtk_signal_connect (GTK_OBJECT (save_as_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_save_as_window_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_ok_save_as), "clicked",
                      GTK_SIGNAL_FUNC (on_button_ok_save_as_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_cancel_save_as), "clicked",
                      GTK_SIGNAL_FUNC (on_button_cancel_save_as_clicked),
                      NULL);

  return save_as_window;
}

GtkWidget*
create_about_window (void)
{
  GtkWidget *about_window;
  GtkWidget *fixed7;
  GtkWidget *button_close_about;
  GtkWidget *notebook1;
  GtkWidget *scrolledwindow2;
  GtkWidget *text_about;
  GtkWidget *label_about;
  GtkWidget *scrolledwindow3;
  GtkWidget *text_faq;
  GtkWidget *label_faq;
  GtkWidget *hseparator2;

  about_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (about_window), "about_window", about_window);
  gtk_window_set_title (GTK_WINDOW (about_window), E_ABOUT);
  gtk_window_set_position (GTK_WINDOW (about_window), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (about_window), FALSE, FALSE, TRUE);
  gtk_window_set_modal (GTK_WINDOW (about_window), TRUE);

  fixed7 = gtk_fixed_new ();
  gtk_widget_ref (fixed7);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "fixed7", fixed7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed7);
  gtk_container_add (GTK_CONTAINER (about_window), fixed7);

  button_close_about = gnome_stock_button (GNOME_STOCK_BUTTON_CLOSE);
  gtk_widget_ref (button_close_about);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "button_close_about", button_close_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_close_about);
  gtk_fixed_put (GTK_FIXED (fixed7), button_close_about, 256, 368);
  gtk_widget_set_uposition (button_close_about, 256, 368);
  gtk_widget_set_usize (button_close_about, 80, 24);

  notebook1 = gtk_notebook_new ();
  gtk_widget_ref (notebook1);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "notebook1", notebook1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook1);
  gtk_fixed_put (GTK_FIXED (fixed7), notebook1, 0, 0);
  gtk_widget_set_uposition (notebook1, 0, 0);
  gtk_widget_set_usize (notebook1, 344, 352);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (notebook1), scrolledwindow2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  text_about = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text_about);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "text_about", text_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text_about);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), text_about);
  gtk_text_insert (GTK_TEXT (text_about), NULL, NULL, NULL,
                   E_TEXT_ABOUT, -1);

  label_about = gtk_label_new (E_ABOUT);
  gtk_widget_ref (label_about);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "label_about", label_about,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_about);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 0), label_about);

  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_container_add (GTK_CONTAINER (notebook1), scrolledwindow3);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow3), GTK_POLICY_NEVER, GTK_POLICY_ALWAYS);

  text_faq = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text_faq);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "text_faq", text_faq,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text_faq);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), text_faq);
  gtk_text_insert (GTK_TEXT (text_faq), NULL, NULL, NULL,
                   E_TEXT_FAQ, -1);

  label_faq = gtk_label_new (E_FAQ);
  gtk_widget_ref (label_faq);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "label_faq", label_faq,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_faq);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook1), 1), label_faq);




  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator2);
  gtk_fixed_put (GTK_FIXED (fixed7), hseparator2, 0, 352);
  gtk_widget_set_uposition (hseparator2, 0, 352);
  gtk_widget_set_usize (hseparator2, 344, 16);

  gtk_signal_connect (GTK_OBJECT (about_window), "delete_event",
                      GTK_SIGNAL_FUNC (on_about_window_delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_close_about), "clicked",
                      GTK_SIGNAL_FUNC (on_button_close_about_clicked),
                      NULL);

  return about_window;
}

